dnl NMM - Network-Integrated Multimedia Environment
dnl
dnl Copyright (C) 2002 Network-Multimedia Workgroup,
dnl                    Computer Graphics Lab,
dnl                    Saarland University, Germany
dnl                    http://www.networkmultimedia.org
dnl
dnl Maintainer:       

dnl This acinclude.m4 is free software; you can redistribute it and/or
dnl modify it under the terms of the GNU General Public License
dnl as published by the Free Software Foundation; either version 2
dnl of the License, or (at your option) any later version.
dnl
dnl This configure.in is distributed in the hope that it will be useful,
dnl but WITHOUT ANY WARRANTY; without even the implied warranty of
dnl MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
dnl GNU General Public License for more details.
dnl
dnl You should have received a copy of the GNU General Public License
dnl along with this program; if not, write to the Free Software
dnl Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, 




dnl =======================================================================
dnl the following macros are inspirited by the kdelibs package
dnl    Copyright (C) 1997 Janos Farkas (chexum@shadow.banki.hu)
dnl              (C) 1997,98,99 Stephan Kulow (coolo@kde.org)
dnl =======================================================================



dnl NMM_CKECK_COMPILER_FLAG
dnl checks the C++ compiler for support for a specific flag
AC_DEFUN([NMM_CHECK_COMPILER_FLAG],
[
AC_MSG_CHECKING(whether $CXX supports -$1)
nmm_cache=`echo $1 | sed 'y%.=/+-%___p_%'`
AC_CACHE_VAL(nmm_cv_prog_cxx_$nmm_cache,
[
echo 'void f(){}' >conftest.cc
if test -z "`$CXX -$1 -c conftest.cc 2>&1`"; then
  eval "nmm_cv_prog_cxx_$nmm_cache=yes"
else
  eval "nmm_cv_prog_cxx_$nmm_cache=no"
fi
rm -f conftest*
])
if eval "test \"`echo '$nmm_cv_prog_cxx_'$nmm_cache`\" = yes"; then
 AC_MSG_RESULT(yes)
 :
 $2
else
 AC_MSG_RESULT(no)
 :
 $3
fi
])


dnl just a wrapper to clean up configure.in
AC_DEFUN([NMM_PROG_LIBTOOL],
[
if test -z "$LIBTOOL"; then
  dnl libtool is only for C, so I must force him
  dnl to find the correct flags for C++
  nmm_save_cc=$CC
  nmm_save_cflags="$CFLAGS"
  CC=$CXX
  CFLAGS="$CXXFLAGS"
  AC_LANG_SAVE
  AC_LANG_C
  AC_LIBTOOL_DLOPEN
  AC_PROG_LIBTOOL
  AC_LANG_RESTORE
  CC=$nmm_save_cc
  CFLAGS="$nmm_save_cflags"
  LIBTOOL_SHELL='/bin/sh ./libtool'
  LDFLAGS="-Wl,-O1 $LDFLAGS"
else
  LIBTOOL_SHELL=$LIBTOOL
fi
])


dnl NMM_CHECK_EXTRA_LIBS
dnl check in fact for extra libs AND extra incs and adds them
dnl to the appropriate varables for compiling and linking
AC_DEFUN([NMM_CHECK_EXTRA_LIBS],
[
AC_MSG_CHECKING(for extra includes)
AC_ARG_WITH(extra-includes, [  --with-extra-includes=DIR   adds non standard include paths],
  nmm_use_extra_includes="$withval",
  nmm_use_extra_includes=NONE
)
nmm_extra_includes=
if test -n "nmm_use_extra_includes" && \
   test "$nmm_use_extra_includes" != "NONE"; then

   ac_save_ifs=$IFS
   IFS=':'
   for dir in $nmm_use_extra_includes; do
     nmm_extra_includes="$nmm_extra_includes $dir"
     USER_INCLUDES="$USER_INCLUDES -I$dir"
   done
   IFS=$ac_save_ifs
   nmm_use_extra_includes="added"
else
   nmm_use_extra_includes="no"
fi
AC_SUBST(USER_INCLUDES)

AC_MSG_RESULT($nmm_use_extra_includes)

nmm_extra_libs=
AC_MSG_CHECKING(for extra libs)
AC_ARG_WITH(extra-libs, [  --with-extra-libs=DIR       adds non standard library paths],
  nmm_use_extra_libs=$withval,
  nmm_use_extra_libs=NONE
)
if test -n "$nmm_use_extra_libs" && \
   test "$nmm_use_extra_libs" != "NONE"; then

   ac_save_ifs=$IFS
   IFS=':'
   for dir in $nmm_use_extra_libs; do
     nmm_extra_libs="$nmm_extra_libs $dir"
     NMM_EXTRA_RPATH="$NMM_EXTRA_RPATH -rpath $dir"
     USER_LDFLAGS="$USER_LDFLAGS -L$dir"
   done
   IFS=$ac_save_ifs
   nmm_use_extra_libs="added"
else
   nmm_use_extra_libs="no"
fi
AC_SUBST(USER_LDFLAGS)

AC_MSG_RESULT($nmm_use_extra_libs)

])
dnl =====================================================================


dnl =====================================================================
dnl new macros from errror for nmm
dnl =====================================================================

dnl NMM_ENABLE_DEBUG
dnl to get a configure switch to enable debugging
AC_DEFUN([NMM_ENABLE_DEBUG],[
  AC_ARG_ENABLE(debug,[  --enable-debug              creates debugging code [default=no]],[
   if test x$enableval = "xno";
     then
       nmm_use_debug_code="no"
     else
       nmm_use_debug_code="yes"
   fi
  ],nmm_use_debug_code="no")
  dnl DEBUG options for C
  if test "x$nmm_use_debug_code" = "xyes"; then
    if test "x$ac_cv_prog_cc_g" = "xyes"; then
      CFLAGS="-g -O0"
    else
      CFLAGS="-g"
    fi
  elif test "x$GCC" = "xyes"; then
    CFLAGS="-O2"
  else
    CFLAGS=""
  fi
  dnl end debug options for C
  dnl DEBUG options for C++
  if test "x$nmm_use_debug_code" = "xyes"; then
    if test "x$ac_cv_prog_cxx_g" = "xyes"; then
      CXXFLAGS="-g -O0  -Wall -W -Wpointer-arith -Wwrite-strings"
      ARM_CXXFLAGS="-g -O0  -Wall-W -Wpointer-arith -Wwrite-strings"
    else
      ARM_CXXFLAGS="-g"
    fi
  elif test "x$GXX" = "xyes"; then
    CXXFLAGS="-O2"
    if test "x$HAVE_CROSSCOMPILER" = "x1"; then
        ARM_CXXFLAGS=""
    else
        ARM_CXXFLAGS="-O2"
    fi
  else
    CXXFLAGS=""
    ARM_CXXFLAGS=""
  fi
  dnl end DEBUG options for C++
  dnl DEBUG options for yacc
  if test "x$nmm_use_debug_code" = "xyes"; then
#    YFLAGS="--debug --verbose"
    YFLAGS=""
  else
    YFLAGS=""
  fi
  dnl end DEBUG options for yacc
  dnl NO DEBUG options
  if test "x$LDFLAGS" = "x"; then
    if test "x$nmm_use_debug_code" = "xno"; then
      if test "x$GCC" = "xyes"; then
        LDFLAGS="-s"
      fi
    fi
  fi
  dnl end NO DEBUG options
])


dnl NMM_ENABLE_STRICT
dnl to get a configure switch to enable strict compilation
AC_DEFUN([NMM_ENABLE_STRICT],[
  AC_ARG_ENABLE(strict,[  --enable-strict             compiles with strict compiler options (may not work!)],[
    if test "x$enableval" = "xno"; then
         nmm_use_strict_options="no"
       else
         nmm_use_strict_options="yes"
    fi
   ], [nmm_use_strict_options="no"])
  dnl strict options for C
  if test "x$GCC" = "xyes"; then
    if test "x$nmm_use_strict_options" = "xyes"; then
      CFLAGS="$CFLAGS -W -Wall -ansi -Wpointer-arith -Wmissing-prototypes -Wwrite-strings"
    fi
  fi
  dnl end strict options for C
  dnl STRICT options for C++
  if test "x$GXX" = "xyes"; then
    if test "x$nmm_use_strict_options" = "xyes"; then
      CXXFLAGS="$CXXFLAGS -Wall -W -Wpointer-arith -Wwrite-strings -Wcast-qual -Wbad-function-cast -Wcast-align"
      ARM_CXXFLAGS="$ARM_CXXFLAGS -Wall -W -Wpointer-arith -Wwrite-strings -Wcast-qual -Wbad-function-cast -Wcast-align"
    fi
  fi
  dnl end STRICT options for C++
])


dnl NMM_ENABLE_PROFILING
dnl to get a configure switch to enable profiling
AC_DEFUN([NMM_ENABLE_PROFILING],[
  dnl 17-10-01 mlohse
  dnl begin profiling
  AC_ARG_ENABLE(profiling,[  --enable-profiling          creates profiling code [default=no]],
  [
   if test $enableval = "no";
     then
       nmm_use_profiling_code="no"
     else
       nmm_use_profiling_code="yes"
   fi
  ], [nmm_use_profiling_code="no"
    ])
  dnl end profiling

  dnl 17-10-01 mlohse
  dnl begin profiling for C
  if test "$nmm_use_profiling_code" = "yes"; then
    CFLAGS="$CFLAGS -pg -fprofile-arcs -DPROFILING"
  fi
  dnl end profiling for C

  dnl 17-10-01 mlohse
  dnl begin profiling for C++
  if test "$nmm_use_profiling_code" = "yes"; then
    CXXFLAGS="$CXXFLAGS -pg -fprofile-arcs -DPROFILING"
    ARM_CXXFLAGS="$ARM_CXXFLAGS -pg -fprofile-arcs -DPROFILING"
  fi
  dnl end profiling for C++
])


dnl NMM_ENABLE_FINAL
dnl to disable all NMM-internal messages to get maximal
dnl performace
AC_DEFUN([NMM_ENABLE_FINAL],[
  dnl 13-11-01 mlohse
  dnl begin messages
  AC_ARG_ENABLE(final,[  --enable-final              creates final code without messages [default=no]],
  [
   if test $enableval = "no";
     then
       nmm_disable_messages="no"
     else
       nmm_disable_messages="yes"
   fi
  ], [nmm_disable_messages="no"
    ])
  dnl end messages

  dnl 13-11-01 mlohse
  dnl begin messages for C
  if test "$nmm_disable_messages" = "yes"; then
    CFLAGS="$CFLAGS -D_NMM_FINAL_VERSION_"
  fi
  dnl end messages for C

  dnl 13-11-01 mlohse
  dnl begin messages for C++
  if test "$nmm_disable_messages" = "yes"; then
    CXXFLAGS="$CXXFLAGS -D_NMM_FINAL_VERSION_"
    ARM_CXXFLAGS="$ARM_CXXFLAGS -D_NMM_FINAL_VERSION_"
  fi
  dnl end messages for C++
])


dnl NMM_CHECK_LIBDL
dnl only a little wrapper
dnl errror 25072003: this macro is no longer used as we now use libltdl.
dnl                  Maybe it could be removed!
AC_DEFUN([NMM_CHECK_LIBDL],[
AC_CHECK_LIB(dl, dlopen, [
LIBDL="-ldl"
ac_cv_have_dlfcn=yes
])
AC_CHECK_LIB(dld, shl_unload, [
LIBDL="-ldld"
ac_cv_have_shload=yes
])
AC_SUBST(LIBDL)
])


dnl AC_HELP_STRING
dnl little wrapper until this is correctly defined in autoconf
AC_DEFUN([AC_HELP_STRING],
[  $1      $2])


dnl NMM_USE_NO_CHECK_NEW
dnl adds no-check-new flag to c++ compiler options
AC_DEFUN([NMM_USE_NO_CHECK_NEW],[
NMM_CHECK_COMPILER_FLAG(fno-check-new, [USE_NO_CHECK_NEW="-fno-check-new"  ],USE_NO_CHECK_NEW= )
CXXFLAGS="$CXXFLAGS $USE_NO_CHECK_NEW"
ARM_CXXFLAGS="$ARM_CXXFLAGS $USE_NO_CHECK_NEW"
])


dnl NMM_USE_EXCEPTIONS
dnl adds exception flag to c++ compiler options
AC_DEFUN([NMM_USE_EXCEPTIONS],[
NMM_CHECK_COMPILER_FLAG(fexceptions,   [USE_EXCEPTIONS="-fexceptions"      ],USE_EXCEPTIONS=   )
CXXFLAGS="$CXXFLAGS $USE_EXCEPTIONS"
ARM_CXXFLAGS="$ARM_CXXFLAGS $USE_EXCEPTIONS"
])


dnl NMM_USE_RTTI
dnl adds rtti flag to c++ compiler options
AC_DEFUN([NMM_USE_RTTI],[
NMM_CHECK_COMPILER_FLAG(frtti,         [USE_RTTI="-frtti"                  ],USE_RTTI=         )
ARM_CXXFLAGS="$ARM_CXXFLAGS $USE_RTTI"
])


dnl NMM_DEFINE_LINUX
dnl added a "LINUX" define for xmlpp
dnl errror 25072003: This macro is no longer used. It was only added
dnl                  for using libxmlpp whoch is no longer used.
dnl                  Maybe it could be removed!
AC_DEFUN([NMM_DEFINE_LINUX],[
CPPFLAGS="$CPPFLAGS -DLINUX"
])


dnl NMM_ARCH_X86
dnl checks wether arch is x86 and defines ARCH_?86 accordingly
dnl also checks wether arch is arm and defines ARCH_ARM 
dnl and if X86_64 architecture, defines ARCH_X86_64 then
dnl finally all defines are also set as automake conditionals
AC_DEFUN([NMM_ARCH_X86],
[
AC_MSG_CHECKING(architecture)
arch_x86_64=
arch_x86=
arch_arm=
case "$target_cpu" in
  i?86)
    arch_x86=1
    AC_DEFINE_UNQUOTED(NMM_UPCASE_WORD([ARCH_X86]), 1, [Define if you have a x86 architecture])
    AC_MSG_RESULT(x86)
    case "$target_cpu" in
      i386)
        AC_DEFINE_UNQUOTED(NMM_UPCASE_WORD([ARCH_386]), 1, [Define if you have a 386 architecture])
      ;;
      i486)
        AC_DEFINE_UNQUOTED(NMM_UPCASE_WORD([ARCH_486]), 1, [Define if you have a 486 architecture])
      ;;
      i586)
        AC_DEFINE_UNQUOTED(NMM_UPCASE_WORD([ARCH_586]), 1, [Define if you have a 586 architecture])
      ;;
      i686)
        AC_DEFINE_UNQUOTED(NMM_UPCASE_WORD([ARCH_686]), 1, [Define if you have a 686 architecture])
      ;;
    esac
  ;;
  arm)
    arch_arm=1
    AC_MSG_RESULT(arm)
    AC_DEFINE_UNQUOTED(NMM_UPCASE_WORD([ARCH_ARM]), 1, [Define if you have a arm architecture])
  ;;
  x86_64)
  	arch_x86_64=1
	AC_MSG_RESULT(x86_64)
    	AC_DEFINE_UNQUOTED(NMM_UPCASE_WORD([ARCH_X86_64]), 1, [Define if you have a x86_64 architecture])
  	;;
  *)
    AC_MSG_RESULT(unknown)
    AC_MSG_WARN([*** No x86 architecture found!  ***])
  ;;
esac
AM_CONDITIONAL(ARCH_X86, test "x$arch_x86" != "x")

AM_CONDITIONAL(ARCH_386, test "x$target_cpu" = "xi386")
AM_CONDITIONAL(ARCH_486, test "x$target_cpu" = "xi486")
AM_CONDITIONAL(ARCH_586, test "x$target_cpu" = "xi586")
AM_CONDITIONAL(ARCH_686, test "x$target_cpu" = "xi686")

AM_CONDITIONAL(ARCH_ARM, test "x$arch_arm" != "x")
AM_CONDITIONAL(ARCH_X86_64, test "x$arch_x86_64" != "x")

unset arch_x86_64
unset arch_x86
unset arch_arm
])


dnl NMM_ARG_WITH
dnl is a somewhat enhanced wrapper vor AC_ARG_WITH
AC_DEFUN([NMM_ARG_WITH],
[
AC_ARG_WITH([$1],
            AC_HELP_STRING([--with-$1=DIR],
                           [use $1 (libs from DIR/lib, includes from DIR/include, default is to check standard paths)]),
[
if test "x$withval" = "x"; then
  ac_cv_use_$1=CHECK
else
  ac_cv_use_$1=$withval
fi
], ac_cv_use_$1=CHECK)
])


dnl NMM_UPCASE_WORD
dnl uppercase a word to create a valid define
dnl errror 25072003: After replacing the old implementation (see
dnl                  below), which also did not work properly in some
dnl                  cases, maybe the new implementation can be
dnl                  directly use!
AC_DEFUN([NMM_UPCASE_WORD],translit($1, `a-z', `A-Z'))
dnl [`echo $1 | tr '.abcdefghijklmnopqrstuvwxyz' '_ABCDEFGHIJKLMNOPQRSTUVWXYZ'`])


dnl NMM_TRY_LINK(incpaths,
dnl		 headers,
dnl		 libpaths, 
dnl		 libs, 
dnl		 testmain,
dnl		 ACTION-IF-NOT-FOUND, 
dnl		 ACTION-IF-FOUND)
dnl
dnl usage:
dnl incpaths: additional paths to search for the headers (adional to
dnl           the default search paths!)
dnl headers:  headers, as they are included in source files, multiple
dnl           in [] (maybe prepended by system headers, for undefined
dnl           symbols in the specified headers
dnl libpaths: additional paths to search for the libs (aditional to the
dnl	      default search paths!)
dnl libs:     libs, that the test program should be linked against,
dnl           multiple in [].
dnl           libs are specified by their library names, NOT their
dnl           filenames, e.g. for liblame.so the library name is "lame"
dnl testmain: source code to a apear in an main function of a test
dnl           program, always in []
AC_DEFUN([NMM_TRY_LINK],
[
nmmtrylink_incpaths="$1"
nmmtrylink_headers="$2"
nmmtrylink_libpaths="$3"
nmmtrylink_libraries="$4"
nmmtrylink_foundit=NOTFOUND

nmm_save_cppflags="$CPPFLAGS"
nmm_save_cflags="$CFLAGS"
nmm_save_cxxflags="$CXXFLAGS"
nmm_save_ldflags="$LDFLAGS"
nmm_save_libs="$LIBS"

nmmtrylink_inc_headers=
for i in $nmmtrylink_headers; do
  nmmtrylink_inc_headers="$nmmtrylink_inc_headers
#include <$i>"
done

LIBS="$nmm_save_libs"
for l in $nmmtrylink_libraries; do
  LIBS="$LIBS -l$l" 
done

dnl extern_c is defined by the NMM_CHECK_EXTPACKAGE_EXTERNC and
dnl indicates, that the specified headers should be clasped in a
dnl 'extern "C"' declaration
if test "x$extern_c" = "x1"; then
        nmmtrylink_inc_headers="extern \"C\" {
$nmmtrylink_inc_headers
}"
fi

dnl iterate over all include-dirs with all lib-dirs
for i in $nmmtrylink_incpaths stdincpath; do
  if test $i = "stdincpath";  then
    CPPFLAGS="$nmm_save_cppflags"
    ADDEDINCLUDES=""
    CFLAGS="$nmm_save_cflags"
    CXXFLAGS="$nmm_save_cxxflags"
  else
    CPPFLAGS="$nmm_save_cppflags"
    ADDEDINCLUDES="-I$i"
    CFLAGS="$nmm_save_cflags $ADDEDINCLUDES"
    CXXFLAGS="$nmm_save_cxxflags $ADDEDINCLUDES"
  fi

  for l in $nmmtrylink_libpaths stdlibpath; do 
    if test $l = "stdlibpath"; then
      ADDEDLDFLAGS=""
      LDFLAGS="$nmm_save_ldflags"
    else
      ADDEDLDFLAGS="-L$l"
      LDFLAGS="$nmm_save_ldflags $ADDEDLDFLAGS"
    fi

    dnl try compiling & linking with current lib- and include-dirs
    AC_TRY_LINK([$nmmtrylink_inc_headers], [$5], [
      nmmtrylink_foundit=FOUND
      found_cflags="$ADDEDINCLUDES"
      found_ldflags="$ADDEDLDFLAGS"
      found_libs="$LIBS"    
      nmmtrylink_incdir=$i
      nmmtrylink_libdir=$l
      ])
    
    test "x$nmmtrylink_foundit" = "xFOUND" && break
  done

  test "x$nmmtrylink_foundit" = "xFOUND" && break
done

CPPFLAGS="$nmm_save_cppflags"
CFLAGS="$nmm_save_cflags"
CXXFLAGS="$nmm_save_cxxflags"
LDFLAGS="$nmm_save_ldflags"
LIBS="$nmm_save_libs"

if test "x$nmmtrylink_foundit" = "xFOUND"; then
  dnl if we found a working lib-/include-dir pair, we execude arg #7
  [$7]
else
  dnl if not, we execude arg #6
  [$6]
fi

unset nmmtrylink_incpaths
unset nmmtrylink_headers
unset nmmtrylink_libpaths
unset nmmtrylink_libraries
unset nmmtrylink_foundit
unset nmm_save_cppflags
unset nmm_save_cflags
unset nmm_save_cxxflags
unset nmm_save_ldflags
unset nmm_save_libs
unset nmmtrylink_inc_headers
unset found_cflags
unset found_ldflags
unset found_libs
unset nmmtrylink_incdir
unset nmmtrylink_libdir
])


dnl NMM_CHECK_EXTPACKAGE_EXTERNC(name, libincs, libs, testmain, [NODENAME])
dnl
dnl usage:
dnl see NMM_CHECK_EXTPACKAGE.
dnl The behavior is the same as NMM_CHECK_EXTPACKAGE except, that the
dnl header files are included with 'extern "C" { ... }'.
AC_DEFUN([NMM_CHECK_EXTPACKAGE_EXTERNC],
[
extern_c=1
NMM_CHECK_EXTPACKAGE($1,$2,$3,$4,$5,$6)
unset extern_c
])


dnl NMM_CHECK_EXTPACKAGE(name, libincs, libs, testmain, [NODENAME], longdesc)
dnl
dnl usage:
dnl name:     name of the package as configure should print it in "Checking..."
dnl incs:     headers, as they are included in source files, multiple in []
dnl libs:     library names, as needed for linking, multiple in []
dnl testmain: source code to a apear in an main function of a test program, always in []
dnl NODENAME: name of the node, that should not be build if package not installed
dnl           could be used for conditionals in Makefile.am(s)
dnl           if NODENAME is "1": package ist needed for build always
dnl longdesc: long description given out, when package not found (URL is recommended)
AC_DEFUN([NMM_CHECK_EXTPACKAGE],
[
extpack_must=0
if test "x$5" = x1; then
  extpack_must=1
fi

extpack_specified=
extpack_inc_path=
extpack_includes=
extpack_lib_path=
extpack_ldadd=
with_extpack=

AC_MSG_CHECKING([for $1])

NMM_ARG_WITH($1)

if test "x$ac_cv_use_$1" != "xCHECK" ; then
  extpack_specified=1
  extpack_inc_path=$ac_cv_use_$1/include
  extpack_lib_path=$ac_cv_use_$1/lib
fi

NMM_TRY_LINK([$extpack_inc_path $nmm_extra_includes], [$2],
	     [$extpack_lib_path $nmm_extra_libs], [$3],
	     [$4],
               dnl this code is executed if the specified headers/libs
               dnl are not found
	       if test $extpack_must = 1; then
	         AC_MSG_RESULT(no)
	         AC_MSG_ERROR([***  NMM needs $1 for base functionalty!  ***])
	       else
	         AC_MSG_RESULT(no)
	         AC_MSG_WARN([*** $1 not found. NMM will suffer funcionality!  ***])
                 if test "x$6" != "x"; then
                   AC_MSG_RESULT(Hint: $6)
                 fi
	         $1_incs=
	         $1_libs=
	       fi
	     ,
               dnl this code is executed if the specified headers/libs
               dnl are found
	       AC_MSG_RESULT(yes: incs=$nmmtrylink_incdir libs=$nmmtrylink_libdir)
	       $1_incs="$found_cflags"
	       $1_libs="$found_ldflags $found_libs"
	       if test "x$extpack_must" != "x1"; then
	         AC_DEFINE_UNQUOTED([HAVE_$5],, Define if you have $5)
	       fi
	       HAVE_$5=1
	     )

AC_SUBST($1_incs)
AC_SUBST($1_libs)

unset extpack_must
unset extpack_specified
unset extpack_inc_path
unset extpack_includes
unset extpack_lib_path
unset extpack_ldadd
unset with_extpack
])


dnl NMM_PATH_QT3
dnl wrapper for NMM[]_CHECK[]_EXTPACKAGE and others + slidely diffs
AC_DEFUN([NMM_PATH_QT3],[
qt3_path=
qt3_inc_path=
qt3_lib_path=
qt3_qtdir_inc_path=
qt3_qtdir_lib_path=
qt3_extra_inc_path=
qt3_extra_lib_path=
qt3_found_inc_path=

AC_MSG_CHECKING([for qt3])

NMM_ARG_WITH(qt3)

if test "x$ac_cv_use_qt3" != "xCHECK" ; then
  qt3_path=$ac_cv_use_qt3
  qt3_inc_path=$qt3_path/include
  qt3_lib_path=$qt3_path/lib
fi

dnl Qt directory may also be specified via QTDIR environment variable
if test "x$QTDIR" != "x"; then
  qt3_qtdir_inc_path=$QTDIR/include
  qt3_qtdir_lib_path=$QTDIR/lib
fi

dnl if we are not cross-compiling, we add some "default" directories
dnl for QT3 (taken from different Linux distributions)
if test "x$HAVE_CROSSCOMPILER" != "x1"; then
  for d in /usr/include /usr/local/qt/include /usr/include/qt3 /usr/include/qt /usr/X11R6/include/X11/qt /usr/X11R6/include/qt /usr/share/qt/include; do
    if test -d "$d"; then
      qt3_extra_inc_path="$qt3_extra_inc_path $d"
    fi
  done

  for d in /usr/lib /usr/X11R6/lib /usr/local/qt/lib; do
    if test -d "$d"; then
      qt3_extra_lib_path="$qt3_extra_lib_path $d"
    fi
  done
fi

NMM_TRY_LINK([$qt3_inc_path $qt3_qtdir_inc_path $nmm_extra_includes $qt3_extra_inc_path], [qcursor.h qstylefactory.h private/qucomextra_p.h],
	     [$qt3_lib_path $qt3_qtdir_lib_path $nmm_extra_libs $qt3_extra_lib_path], [qt-mt],
	     [(void) QStyleFactory::create(QString::null); QCursor c(Qt::WhatsThisCursor);],
	       AC_MSG_RESULT(no)
	       AC_MSG_WARN([*** qt3 not found. NMM will suffer funcionality!  ***])
               AC_MSG_RESULT([Hint: The Qt libraries from Trolltech can be found
under http://www.trolltech.com/ .])
	       qt3_incs=
	       qt3_libs=
	     ,
	       AC_MSG_RESULT(yes: incs=$nmmtrylink_incdir libs=$nmmtrylink_libdir)
	       qt3_found_inc_path=$nmmtrylink_incdir
	       qt3_incs="$found_cflags"
	       qt3_libs="$found_ldflags $found_libs"
	       HAVE_QTMT3=1
	     )

dnl if we have found the Qt3 libs and includes, we have to check for a
dnl working MetaObjectCompiler (moc) ...
if test "x$HAVE_QTMT3" != "x"; then
    case $qt3_found_inc_path in
	$qt3_inc_path)
	    AC_CHECK_PROG(QT3MOC, moc, $qt3_path/bin/moc,, $qt3_path/bin)
	    ;;
	$qt3_qtdir_inc_path)
	    AC_CHECK_PROG(QT3MOC, moc, $QTDIR/bin/moc,, $QTDIR/bin)	
	    ;;
	*)
	    AC_CHECK_PROG(QT3MOC, moc, moc)	
	    ;;
    esac
    if test "x$QT3MOC" = "x"; then
	AC_MSG_WARN([
*** No MetaObjectCompiler for Qt3 found. Disabling Qt3 support for NMM. ***])
	HAVE_QTMT3=0
    fi
fi

dnl ... and UserInterfaceCompiler (uic)
if test "x$HAVE_QTMT3" != "x"; then
    case $qt3_found_inc_path in
	$qt3_inc_path)
	    AC_CHECK_PROG(QT3UIC, uic, $qt3_path/bin/uic,, $qt3_path/bin)
	    ;;
	$qt3_qtdir_inc_path)
	    AC_CHECK_PROG(QT3UIC, uic, $QTDIR/bin/uic,, $QTDIR/bin)	
	    ;;
	*)
	    AC_CHECK_PROG(QT3UIC, uic, uic)	
	    ;;
    esac
    if test "x$QT3UIC" = "x"; then
	AC_MSG_WARN([
*** No UserInterfaceCompiler for Qt3 found. Disabling Qt3 support for NMM. ***])
	HAVE_QTMT3=0
    fi
fi

dnl now we can finally decide if Qt3 is available
if test "x$HAVE_QTMT3" != "x"; then
    AC_DEFINE_UNQUOTED([HAVE_QTMT3],, Define if you have QTMT3)
fi

AC_SUBST(qt3_incs)
AC_SUBST(qt3_libs)

unset qt3_path
unset qt3_inc_path
unset qt3_lib_path
unset qt3_qtdir_inc_path
unset qt3_qtdir_lib_path
unset qt3_extra_inc_path
unset qt3_extra_lib_path
])


dnl NMM_PROG_NASM
dnl checks for existence of nasm assembler and configures Makefiles for
dnl usage. Add workarounds for libtool (nasm doesn't understand PIC).
dnl if not present, configures Makefiles to use (slower) C sources.
AC_DEFUN([NMM_PROG_NASM],[
  AC_ARG_ENABLE(nasm,
                [  --disable-nasm          disables (possible) usage of nasm [default=no]],,
                enable_nasm=yes)  

dnl we disable nasm support if we are cross-compiling
if test "x$HAVE_CROSSCOMPILER" = "x1"; then
   AC_MSG_CHECKING([for nasm])
   AC_MSG_RESULT([no])
   AC_MSG_WARN([***  Disabling nasm support while cross-compiling!  ***])
   NMM_USE_NASM=0
else
   NMM_USE_NASM=0
   AC_CHECK_PROG(NASM, nasm, nasm)
   if test "x$NASM" = "xnasm"; then
      NMM_USE_NASM=1
      STRIP_FPIC='$(SHELL) $(top_srcdir)/strip_fPIC.sh'
      AC_SUBST(STRIP_FPIC)
   else
      AC_MSG_WARN([*** nasm was not found! No assembler optimized code will be integrated!  ***])
      AC_MSG_RESULT([Hint: nasm can be found under http://nasm.sourceforge.net/ .])
   fi
fi

if test "x$enable_nasm" != "xyes"; then
   AC_MSG_WARN([*** disabled (possible) usage of nasm!  ***])
   NMM_USE_NASM=0
fi

AC_SUBST(NMM_USE_NASM)
AM_CONDITIONAL(NMM_USE_NASM, test "x$NMM_USE_NASM" = "x1")
])


dnl NMM_CROSS_CC
dnl checks, wether CC is found as a cross compiler and sets
dnl CC_FOR_BUILD a gcc to compile the NMM idl compiler for the build
dnl system.
AC_DEFUN([NMM_CROSS_CC],[
if test "x$HAVE_CROSSCOMPILER" = "x1"; then
   AC_CHECK_PROG(CC_FOR_BUILD, gcc, gcc)
   if test "x$CC_FOR_BUILD" != "xgcc"; then
      AC_MSG_ERROR([***  No build-host gcc found. NMM needs systems gcc  ***
***  to create compilation tools!                    ***])
   fi
else
   CC_FOR_BUILD=$CC
   AC_SUBST(CC_FOR_BUILD)
fi
])


dnl NMM_CROSS_CXX
dnl checks, wether CXX is found as a cross compiler and sets
dnl CXX_FOR_BUILD a gcc to compile the NMM idl compiler for the build
dnl system.
AC_DEFUN([NMM_CROSS_CXX],[
if test "x$HAVE_CROSSCOMPILER" = "x1"; then
   AC_CHECK_PROG(CXX_FOR_BUILD, g++, g++)
   if test "x$CXX_FOR_BUILD" != "xg++"; then
      AC_MSG_ERROR([***  No build-host g++ found. NMM needs systems gcc  ***
***  to create compilation tools!                    ***])
   fi
else
   CXX_FOR_BUILD=$CXX
   AC_SUBST(CXX_FOR_BUILD)
fi
])


dnl NMM_PROG_YACC
dnl checks for a working yacc.
AC_DEFUN([NMM_PROG_YACC],[
AC_PROG_YACC
if echo $YACC | grep bison >/dev/null; then
   foundayacc=1
else
   dnl if $YACC is not bison, test if it is program at all
   save_IFS="$IFS"
   IFS=:
   for p in $PATH; do
       test -x "$p/$YACC" || continue
       foundayacc=1
   done
   IFS="$save_IFS"
   if test "x$foundayacc" = "x1"; then
      AC_MSG_WARN([
*** Your yacc program is not GNU bison. If you encounter problems, ***
*** compiling NMM, which indicate problems with your yacc program, ***
*** try installing bison from ftp://ftp.gnu.org/gnu/bison/ .       ***])
    fi
fi
if test "x$foundayacc" = "x"; then
   AC_MSG_WARN([
*** No suitable yacc program found. You will run into trouble, if  ***
*** you try to regenerate C++ sources generated by yacc.           ***])
   if test "x${am_missing_run}" = "x"; then
     am_missing_run="${missing_dir}/missing "
   fi
   YACC="${am_missing_run}bison"
fi
])


dnl NMM_PROG_LEX
dnl checks for a working lex.
AC_DEFUN([NMM_PROG_LEX],[
AM_PROG_LEX
if test "x$LEX" != "xflex"; then
   save_IFS="$IFS"
   IFS=:
   for p in $PATH; do
       test -x "$p/$YACC" || continue
       foundalexer=1
   done
   IFS="$save_IFS"
   if "x$foundalexer" = "x"; then
      AC_MSG_WARN([
*** No suitable lex program found. You will run into trouble, if ***
*** you try to regenerate C sources generated by lex.            ***])
   fi
fi
])


dnl NMM_PROGS_DOCBOOK
dnl checks for the needed docbook utils.
dnl defines HAVE_DOCBOOKUTILS=1 if found.
AC_DEFUN([NMM_PROGS_DOCBOOK],[
found_docbook_utils=0
AC_CHECK_PROGS(DB2HTML,db2html docbook2html)
if test "x$DB2HTML" != "x"; then
   found_docbook_utils=1
   AC_CHECK_PROGS(DB2PDF,db2pdf docbook2pdf)
   if test "x$DB2PDF" = "x"; then
      found_docbook_utils=0
      AC_MSG_WARN([
*** No db2pdf tool found. Maybe your docbook-utils are not ***
*** installed properly?                                    ***])
   fi
else
  found_docbook_utils=0
fi
if test "x$found_docbook_utils" != "x1"; then
  AC_MSG_WARN([
*** No docbook-utils found. Please install if you want the ***
*** according documentation to be build.                   ***])
  AC_MSG_RESULT([Hint: docbook-utils can be found under http://sources.redhat.com/docbook-tools/ .])
else
  HAVE_DOCBOOKUTILS=1
  AC_DEFINE_UNQUOTED([HAVE_DOCBOOKUTILS],, Define if you have docbook utils)
fi
])

dnl NMM_PROGS_HTMLDOC
dnl checks for htmldocs
dnl defines HAVE_HTMLDOC=1 if found
AC_DEFUN([NMM_PROG_HTMLDOC],[
found_htmldoc=0
AC_CHECK_PROG(HTMLDOC, htmldoc, htmldoc)
if test "x$HTMLDOC" != "x"; then
  found_htmldoc=1
else
  found_htmldoc=0
fi
if test "x$found_htmldoc" != "x1"; then
  AC_MSG_WARN([
*** htmldoc not found. Please install if you want ***
*** pluginlist.pdf to be generated.               ***])
  AC_MSG_RESULT([Hint: htmldoc can be found under http://www.easysw.com/htmldoc/ .])
else
  HAVE_HTMLDOC=1
  AC_DEFINE_UNQUOTED([HAVE_HTMLDOC],, Define if you have htmldoc)
fi
])


dnl NMM_PATH_XTRA
dnl wrapper for AC_[]PATH_[]XTRA with cross compiling tests
AC_DEFUN([NMM_PATH_XTRA],[
AC_PATH_XTRA
if test "x$HAVE_CROSSCOMPILER" = "x1"; then
    no_x=yes
    AC_MSG_WARN([*** X11 support disabled while cross compiling  ***])
else
    if test "x$no_x" != "xyes"; then
        AC_DEFINE_UNQUOTED([HAVE_XDISPLAYNODE],, Define if you have XDISPLAYNODE)
        HAVE_XDISPLAYNODE=1
	
	x11_cxxflags="$CXXFLAGS"
	CXXFLAGS="$CXXFLAGS $X_CFLAGS"
	NMM_TRY_LINK(,[X11/Xutil.h Xm/MwmUtil.h],,,, have_mwmutil_h_internal=0, have_mwmutil_h_internal=1)
	if test "x$have_mwmutil_h_internal" = "x1"; then
		AC_DEFINE_UNQUOTED([HAVE_MWMUTIL_H],, Define if you have Xm/MwmUtil.h)
	fi
	unset have_mwmutil_h_internal
	CXXFLAGS="$x11_cxxflags"
	unset x11_cxxflags
    else
        AC_MSG_WARN([*** X11 not found. NMM will suffer funcionality!  ***])
    fi
fi
])



dnl the whole vorbis / vorbis_nmm stuff is a huge hack, someone with more
dnl knowledge of this stuff will hopefully refactor it... so long: sorry!

dnl NMM_PATH_VORBIS_NMM
dnl wrapper for AM_[]PATH_[]VORBIS with cross compiling tests.
AC_DEFUN([NMM_PATH_VORBIS_NMM],[
dnl we use AM_[]PATH_[]VORBIS here (defined below!) as
dnl XIPH_[]PATH_[]VORBIS from vorbis-1.0 is buggy!
dnl
dnl the AC_[]TRY_[]LINK below makes sure, that we have found vorbis
dnl libs >= 1.0rc3
AM_PATH_VORBIS_NMM([
        nmm_save_cflags="$CFLAGS"
        nmm_save_cppflags="$CPPFLAGS"
        nmm_save_cxxflags="$CXXFLAGS"
        nmm_save_ldflags="$LDFLAGS"
        CFLAGS="$VORBIS_CFLAGS $CFLAGS"
        CPPFLAGS="$VORBIS_CFLAGS $CPPFLAGS"
        CXXFLAGS="$VORBIS_CFLAGS $CXXFLAGS"
        LDFLAGS="$VORBIS_LIBS $VORBISENC_LIBS $VORBISFILE_LIBS $LDFLAGS $USER_LDFLAGS"
        AC_TRY_LINK([
#include <stdio.h>
#include <vorbis/codec.h>
],              [
vorbis_bitrate_addblock(NULL);
vorbis_bitrate_flushpacket(NULL, NULL);
return 0;
],              [HAVE_OGGVORBISNODES_NMM=1
		 AC_DEFINE_UNQUOTED([HAVE_OGGVORBISNODES_NMM],, Define if you have OGGVORBISNODES)
                 AC_DEFINE_UNQUOTED([HAVE_OGGVORBISNODES],, Define if you have OGGVORBISNODES)
                ],[AC_MSG_WARN([
*** The version of the Vorbis libraries found is to old. NMM needs   ***
*** a version greater or equal to 1.0rc3 of the Vorbis libs to work. ***
*** Please update your NMM libraries!                                ***])
                HAVE_OGGVORBISNODES_NMM=0])
       CFLAGS="$nmm_save_cflags"
       CPPFLAGS="$nmm_save_cppflags"
       CXXFLAGS="$nmm_save_cxxflags"
       LDFLAGS="$nmm_save_ldflags"
       ],
       [AC_MSG_WARN([*** OggVorbis NMM version not found, checking for regular version  ***])])
])

dnl NMM_PATH_VORBIS_CUSTOM
dnl wrapper for AM_[]PATH_[]VORBIS with cross compiling tests.
AC_DEFUN([NMM_PATH_VORBIS_CUSTOM],[
dnl we use AM_[]PATH_[]VORBIS here (defined below!) as
dnl XIPH_[]PATH_[]VORBIS from vorbis-1.0 is buggy!
dnl
dnl the AC_[]TRY_[]LINK below makes sure, that we have found vorbis
dnl libs >= 1.0rc3
AM_PATH_VORBIS([
        nmm_save_cflags="$CFLAGS"
        nmm_save_cppflags="$CPPFLAGS"
        nmm_save_cxxflags="$CXXFLAGS"
        nmm_save_ldflags="$LDFLAGS"
        CFLAGS="$VORBIS_CFLAGS $CFLAGS $USER_INCLUDES"
        CPPFLAGS="$VORBIS_CFLAGS $CPPFLAGS"
        CXXFLAGS="$VORBIS_CFLAGS $CXXFLAGS"
        LDFLAGS="$VORBIS_LIBS $VORBISENC_LIBS $VORBISFILE_LIBS $LDFLAGS $USER_INCLUDES $USER_LDFLAGS"
        AC_TRY_LINK([
#include <stdio.h>
#include <vorbis/codec.h>
],              [
vorbis_bitrate_addblock(NULL);
vorbis_bitrate_flushpacket(NULL, NULL);
return 0;
],              [HAVE_OGGVORBISNODES_CUSTOM=1 
                AC_DEFINE_UNQUOTED([HAVE_OGGVORBISNODES_CUSTOM],, Define if you have OGGVORBISNODES)
                AC_DEFINE_UNQUOTED([HAVE_OGGVORBISNODES],, Define if you have OGGVORBISNODES)
                ],[AC_MSG_WARN([
*** The version of the Vorbis libraries found is to old. NMM needs   ***
*** a version greater or equal to 1.0rc3 of the Vorbis libs to work. ***
*** Disabling Vorbis support for NMM!                                ***])
                HAVE_OGGVORBISNODES_CUSTOM=0])
       CFLAGS="$nmm_save_cflags"
       CPPFLAGS="$nmm_save_cppflags"
       CXXFLAGS="$nmm_save_cxxflags"
       LDFLAGS="$nmm_save_ldflags"
       ],
       [AC_MSG_WARN([*** OggVorbis not found. NMM will suffer funcionality!  ***])])
])

dnl NMM_SUMMARY
dnl summarizes the results of the tests and checks at the end of the
dnl configure run
AC_DEFUN([NMM_SUMMARY],[
cat <<EOF



Summary:
========

Results to be summaries here...


run "make" to compile now.
Hint: You can use "make -j 10 parallel" to speed up the build,
      esspecially on SMP machines.

EOF
])


dnl Locate a program and check that its version is acceptable.
dnl AC_PROG_CHECK_VER(var, namelist, version-switch,
dnl                   [version-extract-regexp], version-glob [, do-if-fail])
AC_DEFUN([AC_CHECK_PROG_VER],
[AC_CHECK_PROGS([$1], [$2])
if test -z "[$]$1"; then
  ac_verc_fail=yes
else
  # Found it, now check the version.
  AC_MSG_CHECKING([version of [$]$1])
changequote(<<,>>)dnl
  ac_prog_version=`<<$>>$1 $3 2>&1 ifelse(<<$4>>,,,
                   <<| sed -n 's/<<$4>>//p' | sed -n 's/[^0-9]*//p'>>)`
  case $ac_prog_version in
    '') ac_prog_version="v. ?.??, bad"; ac_verc_fail=yes;;
    <<$5>>)
changequote([,])dnl
       ac_prog_version="$ac_prog_version, ok"; ac_verc_fail=no;;
    *) ac_prog_version="$ac_prog_version, bad"; ac_verc_fail=yes;;
  esac
  AC_MSG_RESULT([$ac_prog_version])
fi
ifelse([$6],,,
[if test $ac_verc_fail = yes; then
  $6
fi])
])



dnl we must provide our own macro for libxml2 as long as their xml-config
dnl script adds the "-I/usr/include/libxml2/libxml" CFLAG which leeds to a
dnl include problem as tree.h is taken from there instead of the one in
dnl /usr/include, provided by STL

# Configure paths for LIBXML2
# Toshio Kuratomi 2001-04-21
# Adapted from:
# Configure paths for GLIB
# Owen Taylor     97-11-3

dnl NMM_PATH_XML2([MINIMUM-VERSION, [ACTION-IF-FOUND [, ACTION-IF-NOT-FOUND]]])
dnl Test for XML, and define XML_CFLAGS and XML_LIBS
dnl
AC_DEFUN([NMM_PATH_XML2],[ 
AC_ARG_WITH(xml-prefix,
            [  --with-xml-prefix=PFX       Prefix where libxml is installed (optional)],
            xml_config_prefix="$withval", xml_config_prefix="")
AC_ARG_WITH(xml-exec-prefix,
            [  --with-xml-exec-prefix=PFX  Exec prefix where libxml is installed (optional)],
            xml_config_exec_prefix="$withval", xml_config_exec_prefix="")
AC_ARG_ENABLE(xmltest,
              [  --disable-xmltest           Do not try to compile and run a test LIBXML program],,
              enable_xmltest=yes)

  if test x$xml_config_exec_prefix != x ; then
     xml_config_args="$xml_config_args --exec-prefix=$xml_config_exec_prefix"
     if test x${XML2_CONFIG+set} != xset ; then
        XML2_CONFIG=$xml_config_exec_prefix/bin/xml2-config
     fi
  fi
  if test x$xml_config_prefix != x ; then
     xml_config_args="$xml_config_args --prefix=$xml_config_prefix"
     if test x${XML2_CONFIG+set} != xset ; then
        XML2_CONFIG=$xml_config_prefix/bin/xml2-config
     fi
  fi

  AC_PATH_PROG(XML2_CONFIG, xml2-config, no)
  min_xml_version=ifelse([$1], ,2.0.0,[$1])
  AC_MSG_CHECKING(for libxml - version >= $min_xml_version)
  no_xml=""
  if test "$XML2_CONFIG" = "no" ; then
    no_xml=yes
  else
# patch to avoid conflicting include tree.h from this package and STL
#    XML_CFLAGS=`$XML2_CONFIG $xml_config_args --cflags`
    tmp_cflags=`$XML2_CONFIG $xml_config_args --cflags`
    for p in $tmp_cflags; do
      case $p in
        */libxml2/libxml*)
          continue;
          ;;
        *)
          XML_CFLAGS="$XML_CFLAGS $p"
          ;;
      esac
    done
    XML_LIBS=`$XML2_CONFIG $xml_config_args --libs`
    xml_config_major_version=`$XML2_CONFIG $xml_config_args --version | \
           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\1/'`
    xml_config_minor_version=`$XML2_CONFIG $xml_config_args --version | \
           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\2/'`
    xml_config_micro_version=`$XML2_CONFIG $xml_config_args --version | \
           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\3/'`
    if test "x$enable_xmltest" = "xyes" ; then
      ac_save_CFLAGS="$CFLAGS"
      ac_save_CXXFLAGS="$CXXFLAGS"
      ac_save_LIBS="$LIBS"
      CFLAGS="$CFLAGS $XML_CFLAGS"
      CXXFLAGS="$CXXFLAGS $XML_CFLAGS"
      LIBS="$XML_LIBS $LIBS"
dnl
dnl Now check if the installed libxml is sufficiently new.
dnl (Also sanity checks the results of xml2-config to some extent)
dnl
      rm -f conf.xmltest
      AC_TRY_RUN([
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
/* #include <xmlversion.h> */
/* patch to avoid conflicting include tree.h from this package and STL */
#include <libxml/xmlversion.h>

int 
main()
{
  int xml_major_version, xml_minor_version, xml_micro_version;
  int major, minor, micro;
  char *tmp_version;

  system("touch conf.xmltest");

  /* Capture xml2-config output via autoconf/configure variables */
  /* HP/UX 9 (%@#!) writes to sscanf strings */
  tmp_version = (char *)strdup("$min_xml_version");
  if (sscanf(tmp_version, "%d.%d.%d", &major, &minor, &micro) != 3) {
     printf("%s, bad version string from xml2-config\n", "$min_xml_version");
     exit(1);
   }
   free(tmp_version);

   /* Capture the version information from the header files */
   tmp_version = (char *)strdup(LIBXML_DOTTED_VERSION);
   if (sscanf(tmp_version, "%d.%d.%d", &xml_major_version, &xml_minor_version, &xml_micro_version) != 3) {
     printf("%s, bad version string from libxml includes\n", "LIBXML_DOTTED_VERSION");
     exit(1);
   }
   free(tmp_version);

 /* Compare xml2-config output to the libxml headers */
  if ((xml_major_version != $xml_config_major_version) ||
      (xml_minor_version != $xml_config_minor_version) ||
      (xml_micro_version != $xml_config_micro_version))
    {
      printf("*** libxml header files (version %d.%d.%d) do not match\n",
         xml_major_version, xml_minor_version, xml_micro_version);
      printf("*** xml2-config (version %d.%d.%d)\n",
         $xml_config_major_version, $xml_config_minor_version, $xml_config_micro_version);
      return 1;
    } 
/* Compare the headers to the library to make sure we match */
  /* Less than ideal -- doesn't provide us with return value feedback, 
   * only exits if there's a serious mismatch between header and library.
   */
    LIBXML_TEST_VERSION;

    /* Test that the library is greater than our minimum version */
    if ((xml_major_version > major) ||
        ((xml_major_version == major) && (xml_minor_version > minor)) ||
        ((xml_major_version == major) && (xml_minor_version == minor) &&
        (xml_micro_version >= micro)))
      {
        return 0;
       }
     else
      {
        printf("\n*** An old version of libxml (%d.%d.%d) was found.\n",
               xml_major_version, xml_minor_version, xml_micro_version);
        printf("*** You need a version of libxml newer than %d.%d.%d. The latest version of\n",
           major, minor, micro);
        printf("*** libxml is always available from ftp://ftp.xmlsoft.org.\n");
        printf("***\n");
        printf("*** If you have already installed a sufficiently new version, this error\n");
        printf("*** probably means that the wrong copy of the xml2-config shell script is\n");
        printf("*** being found. The easiest way to fix this is to remove the old version\n");
        printf("*** of LIBXML, but you can also set the XML2_CONFIG environment to point to the\n");
        printf("*** correct copy of xml2-config. (In this case, you will have to\n");
        printf("*** modify your LD_LIBRARY_PATH enviroment variable, or edit /etc/ld.so.conf\n");
        printf("*** so that the correct libraries are found at run-time))\n");
    }
  return 1;
}
],, no_xml=yes,[echo $ac_n "cross compiling; assumed OK... $ac_c"])
       CFLAGS="$ac_save_CFLAGS"
       CXXFLAGS="$ac_save_CXXFLAGS"
       LIBS="$ac_save_LIBS"
     fi
  fi

  if test "x$no_xml" = x ; then
     AC_MSG_RESULT(yes (version $xml_config_major_version.$xml_config_minor_version.$xml_config_micro_version))
     ifelse([$2], , :, [$2])     
  else
     AC_MSG_RESULT(no)
     if test "$XML2_CONFIG" = "no" ; then
       echo "*** The xml2-config script installed by LIBXML could not be found"
       echo "*** If libxml was installed in PREFIX, make sure PREFIX/bin is in"
       echo "*** your path, or set the XML2_CONFIG environment variable to the"
       echo "*** full path to xml2-config."
     else
       if test -f conf.xmltest ; then
        :
       else
          echo "*** Could not run libxml test program, checking why..."
          CFLAGS="$CFLAGS $XML_CFLAGS"
          CXXFLAGS="$CXXFLAGS $XML_CFLAGS"
          LIBS="$LIBS $XML_LIBS"
          AC_TRY_LINK([
/* #include <xmlversion.h> */
/* patch to avoid conflicting include tree.h from this package and STL */
#include <libxml/xmlversion.h>
#include <stdio.h>
],      [ LIBXML_TEST_VERSION; return 0;],
        [ echo "*** The test program compiled, but did not run. This usually means"
          echo "*** that the run-time linker is not finding LIBXML or finding the wrong"
          echo "*** version of LIBXML. If it is not finding LIBXML, you'll need to set your"
          echo "*** LD_LIBRARY_PATH environment variable, or edit /etc/ld.so.conf to point"
          echo "*** to the installed location  Also, make sure you have run ldconfig if that"
          echo "*** is required on your system"
          echo "***"
          echo "*** If you have an old version installed, it is best to remove it, although"
          echo "*** you may also be able to get things to work by modifying LD_LIBRARY_PATH" ],
        [ echo "*** The test program failed to compile or link. See the file config.log for the"
          echo "*** exact error that occured. This usually means LIBXML was incorrectly installed"
          echo "*** or that you have moved LIBXML since it was installed. In the latter case, you"
          echo "*** may want to edit the xml2-config script: $XML2_CONFIG" ])
          CFLAGS="$ac_save_CFLAGS"
          CXXFLAGS="$ac_save_CXXFLAGS"
          LIBS="$ac_save_LIBS"
       fi
     fi

     XML_CFLAGS=""
     XML_LIBS=""
     ifelse([$3], , :, [$3])
  fi
  AC_SUBST(XML_CFLAGS)
  AC_SUBST(XML_LIBS)
  rm -f conf.xmltest
])



dnl we must provide our own macro for libvorbis as they haed the great
dnl idea to rename the macro from version 1.0rc3 to 1.0 (final). The
dnl previosly called AM_PATH_VORBIS macro works fine and for that
dnl reason is included below. The new on (XIPH_PATH_VORBIS) tells me
dnl (at least on our Debian Woody/Sarge systems, that it can't link
dnl against its own lib!

dnl the stuff is copied because I don't understand how to do it right
dnl it's part of the vorbis / vorbis_nmm hack begun above

# Configure paths for libvorbis
# Jack Moffitt <jack@icecast.org> 10-21-2000
# Shamelessly stolen from Owen Taylor and Manish Singh

dnl AM_PATH_VORBIS([ACTION-IF-FOUND [, ACTION-IF-NOT-FOUND]])
dnl Test for libvorbis, and define VORBIS_CFLAGS and VORBIS_LIBS
dnl
AC_DEFUN([AM_PATH_VORBIS_NMM],
[dnl 
dnl Get the cflags and libraries
dnl
AC_ARG_WITH(vorbis,[  --with-vorbis=PFX           Prefix where libvorbis is installed (optional)], vorbis_prefix="$withval", vorbis_prefix="")
AC_ARG_WITH(vorbis-libraries,[  --with-vorbis-libraries=DIR Directory where libvorbis library is installed (optional)], vorbis_libraries="$withval", vorbis_libraries="")
AC_ARG_WITH(vorbis-includes,[  --with-vorbis-includes=DIR  Directory where libvorbis header files are installed (optional)], vorbis_includes="$withval", vorbis_includes="")
AC_ARG_ENABLE(vorbistest, [  --disable-vorbistest        Do not try to compile and run a test Vorbis program],, enable_vorbistest=yes)

  if test "x$vorbis_libraries" != "x" ; then
    VORBIS_LIBS="-L$vorbis_libraries"
  elif test "x$vorbis_prefix" != "x" ; then
    VORBIS_LIBS="-L$vorbis_prefix/lib"
  elif test "x$prefix" != "xNONE"; then
    VORBIS_LIBS="-L$prefix/lib"
  fi

  VORBIS_LIBS="$VORBIS_LIBS $USER_LDFLAGS -lvorbis_nmm -lm"
  VORBISFILE_LIBS="-lvorbisfile_nmm"
  VORBISENC_LIBS="$USER_LDFLAGS -lvorbisenc_nmm"

  if test "x$vorbis_includes" != "x" ; then
    VORBIS_CFLAGS="-I$vorbis_includes"
  elif test "x$vorbis_prefix" != "x" ; then
    VORBIS_CFLAGS="-I$vorbis_prefix/include"
  elif test "x$prefix" != "xNONE"; then
    VORBIS_CFLAGS="-I$prefix/include"
  fi


  AC_MSG_CHECKING(for Vorbis_nmm)
  no_vorbis=""


  if test "x$enable_vorbistest" = "xyes" ; then
    ac_save_CFLAGS="$CFLAGS"
    ac_save_LIBS="$LIBS"
    CFLAGS="$CFLAGS $VORBIS_CFLAGS $OGG_CFLAGS $USER_INCLUDES"
    LIBS="$LIBS $VORBIS_LIBS $OGG_LIBS $USER_INCLUDES $USER_LDFLAGS"
dnl
dnl Now check if the installed Vorbis is sufficiently new.
dnl
      rm -f conf.vorbistest
      AC_TRY_RUN([
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <vorbis/codec.h>
// first test
int main ()
{
  system("touch conf.vorbistest");
  return 0;
}

],, no_vorbis=yes,[echo $ac_n "cross compiling; assumed OK... $ac_c"])
       CFLAGS="$ac_save_CFLAGS"
       LIBS="$ac_save_LIBS"
  fi

  if test "x$no_vorbis" = "x" ; then
     AC_MSG_RESULT(yes)
     ifelse([$1], , :, [$1])
  else
     AC_MSG_RESULT(no)
     if test -f conf.vorbistest ; then
       :
     else
       CFLAGS="$CFLAGS $VORBIS_CFLAGS"
       LIBS="$LIBS $VORBIS_LIBS $OGG_LIBS"
       AC_TRY_LINK([
#include <stdio.h>
#include <vorbis/codec.h>
],     [ return 0; ],
       [ echo "*** The test program compiled, but did not run. This usually means"
       echo "*** that the run-time linker is not finding Vorbis or finding the wrong"
       echo "*** version of Vorbis. If it is not finding Vorbis, you'll need to set your"
       echo "*** LD_LIBRARY_PATH environment variable, or edit /etc/ld.so.conf to point"
       echo "*** to the installed location  Also, make sure you have run ldconfig if that"
       echo "*** is required on your system"
       echo "***"
       echo "*** If you have an old version installed, it is best to remove it, although"
       echo "*** you may also be able to get things to work by modifying LD_LIBRARY_PATH"],
       [])
       CFLAGS="$ac_save_CFLAGS"
       LIBS="$ac_save_LIBS"
     fi
     VORBIS_CFLAGS=""
     VORBIS_LIBS=""
     VORBISFILE_LIBS=""
     VORBISENC_LIBS=""
     ifelse([$2], , :, [$2])
  fi
  AC_SUBST(VORBIS_CFLAGS)
  AC_SUBST(VORBIS_LIBS)
  AC_SUBST(VORBISFILE_LIBS)
  AC_SUBST(VORBISENC_LIBS)
  rm -f conf.vorbistest
])


dnl AM_PATH_VORBIS([ACTION-IF-FOUND [, ACTION-IF-NOT-FOUND]])
dnl Test for libvorbis, and define VORBIS_CFLAGS and VORBIS_LIBS
dnl
AC_DEFUN([AM_PATH_VORBIS],
[dnl 
dnl Get the cflags and libraries
dnl
AC_ARG_WITH(vorbis,[  --with-vorbis=PFX          Prefix where libvorbis is installed (optional)], vorbis_prefix="$withval", vorbis_prefix="")
AC_ARG_WITH(vorbis-libraries,[  --with-vorbis-libraries=DIR Directory where libvorbis library is installed (optional)], vorbis_libraries="$withval", vorbis_libraries="")
AC_ARG_WITH(vorbis-includes,[  --with-vorbis-includes=DIR  Directory where libvorbis header files are installed (optional)], vorbis_includes="$withval", vorbis_includes="")
AC_ARG_ENABLE(vorbistest, [  --disable-vorbistest        Do not try to compile and run a test Vorbis program],, enable_vorbistest=yes)

  if test "x$vorbis_libraries" != "x" ; then
    VORBIS_LIBS="-L$vorbis_libraries"
  elif test "x$vorbis_prefix" != "x" ; then
    VORBIS_LIBS="-L$vorbis_prefix/lib"
  elif test "x$prefix" != "xNONE"; then
    VORBIS_LIBS="-L$prefix/lib"
  fi

  VORBIS_LIBS="$VORBIS_LIBS -lvorbis -lm"
  VORBISFILE_LIBS="-lvorbisfile"
  VORBISENC_LIBS="-lvorbisenc"

  if test "x$vorbis_includes" != "x" ; then
    VORBIS_CFLAGS="-I$vorbis_includes"
  elif test "x$vorbis_prefix" != "x" ; then
    VORBIS_CFLAGS="-I$vorbis_prefix/include"
  elif test "x$prefix" != "xNONE"; then
    VORBIS_CFLAGS="-I$prefix/include"
  fi


  AC_MSG_CHECKING(for Vorbis)
  no_vorbis=""


  if test "x$enable_vorbistest" = "xyes" ; then
    ac_save_CFLAGS="$CFLAGS"
    ac_save_LIBS="$LIBS"
    CFLAGS="$CFLAGS $VORBIS_CFLAGS $OGG_CFLAGS"
    LIBS="$LIBS $VORBIS_LIBS $OGG_LIBS"
dnl
dnl Now check if the installed Vorbis is sufficiently new.
dnl
      rm -f conf.vorbistest
      AC_TRY_RUN([
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <vorbis/codec.h>

int main ()
{
  system("touch conf.vorbistest");
  return 0;
}

],, no_vorbis=yes,[echo $ac_n "cross compiling; assumed OK... $ac_c"])
       CFLAGS="$ac_save_CFLAGS"
       LIBS="$ac_save_LIBS"
  fi

  if test "x$no_vorbis" = "x" ; then
     AC_MSG_RESULT(yes)
     ifelse([$1], , :, [$1])     
  else
     AC_MSG_RESULT(no)
     if test -f conf.vorbistest ; then
       :
     else
       echo "*** Could not run Vorbis test program, checking why..."
       CFLAGS="$CFLAGS $VORBIS_CFLAGS"
       LIBS="$LIBS $VORBIS_LIBS $OGG_LIBS"
       AC_TRY_LINK([
#include <stdio.h>
#include <vorbis/codec.h>
],     [ return 0; ],
       [ echo "*** The test program compiled, but did not run. This usually means"
       echo "*** that the run-time linker is not finding Vorbis or finding the wrong"
       echo "*** version of Vorbis. If it is not finding Vorbis, you'll need to set your"
       echo "*** LD_LIBRARY_PATH environment variable, or edit /etc/ld.so.conf to point"
       echo "*** to the installed location  Also, make sure you have run ldconfig if that"
       echo "*** is required on your system"
       echo "***"
       echo "*** If you have an old version installed, it is best to remove it, although"
       echo "*** you may also be able to get things to work by modifying LD_LIBRARY_PATH"],
       [ echo "*** The test program failed to compile or link. See the file config.log for the"
       echo "*** exact error that occured. This usually means Vorbis was incorrectly installed"
       echo "*** or that you have moved Vorbis since it was installed." ])
       CFLAGS="$ac_save_CFLAGS"
       LIBS="$ac_save_LIBS"
     fi
     VORBIS_CFLAGS=""
     VORBIS_LIBS=""
     VORBISFILE_LIBS=""
     VORBISENC_LIBS=""
     ifelse([$2], , :, [$2])
  fi
  AC_SUBST(VORBIS_CFLAGS)
  AC_SUBST(VORBIS_LIBS)
  AC_SUBST(VORBISFILE_LIBS)
  AC_SUBST(VORBISENC_LIBS)
  rm -f conf.vorbistest
])


dnl taken from automake-1.5: as.m4, but corrected
# Figure out how to run the assembler.

# NMM_PROG_AS
AC_DEFUN([NMM_PROG_AS],
[# By default we simply use the C compiler to build assembly code.
AC_REQUIRE([AC_PROG_CC])
: ${AS="${CC}"}
# Set ASFLAGS if not already set.
: ${ASFLAGS="${CFLAGS}"}
# errror 20030428: added CCAS and CCASFLAGS for automake1.6
: ${CCAS="${AS}"}
: ${CCASFLAGS="${ASFLAGS}"}
AC_SUBST(AS)
AC_SUBST(ASFLAGS)
AC_SUBST(CCAS)
AC_SUBST(CCASFLAGS)])



dnl pthread.m4
dnl
dnl taken from the iperf package, see nmm/utils/iperf/LICENSE.iperf
dnl for copyright details.
dnl
AC_DEFUN([ACX_PTHREAD], [
AC_REQUIRE([AC_CANONICAL_HOST])
acx_pthread_ok=no

# First, check if the POSIX threads header, pthread.h, is available.
# If it isn't, don't bother looking for the threads libraries.
AC_CHECK_HEADER(pthread.h, , acx_pthread_ok=noheader)

# We must check for the threads library under a number of different
# names; the ordering is very important because some systems
# (e.g. DEC) have both -lpthread and -lpthreads, where one of the
# libraries is broken (non-POSIX).

# First of all, check if the user has set any of the PTHREAD_LIBS,
# etcetera environment variables, and if threads linking works using
# them:
if test x"$PTHREAD_LIBS$PTHREAD_CFLAGS" != x; then
        save_CFLAGS="$CFLAGS"
        CFLAGS="$CFLAGS $PTHREAD_CFLAGS"
        save_LIBS="$LIBS"
        LIBS="$PTHREAD_LIBS $LIBS"
        AC_MSG_CHECKING([for pthread_join in LIBS=$PTHREAD_LIBS with CFLAGS=$PTHREAD_CFLAGS])
        AC_TRY_LINK_FUNC(pthread_join, acx_pthread_ok=yes)
        AC_MSG_RESULT($acx_pthread_ok)
        if test x"$acx_pthread_ok" = xno; then
                PTHREAD_LIBS=""
                PTHREAD_CFLAGS=""
        fi
        LIBS="$save_LIBS"
        CFLAGS="$save_CFLAGS"
fi

# Create a list of thread flags to try.  Items starting with a "-" are
# C compiler flags, and other items are library names, except for "none"
# which indicates that we try without any flags at all.

acx_pthread_flags="pthreads none -Kthread -kthread lthread -pthread -pthreads -mthreads pthread --thread-safe -mt"

# The ordering *is* (sometimes) important.  Some notes on the
# individual items follow:

# pthreads: AIX (must check this before -lpthread)
# none: in case threads are in libc; should be tried before -Kthread and
#       other compiler flags to prevent continual compiler warnings
# -Kthread: Sequent (threads in libc, but -Kthread needed for pthread.h)
# -kthread: FreeBSD kernel threads (preferred to -pthread since SMP-able)
# lthread: LinuxThreads port on FreeBSD (also preferred to -pthread)
# -pthread: Linux/gcc (kernel threads), BSD/gcc (userland threads)
# -pthreads: Solaris/gcc
# -mthreads: Mingw32/gcc, Lynx/gcc
# -mt: Sun Workshop C (may only link SunOS threads [-lthread], but it
#      doesn't hurt to check since this sometimes defines pthreads too;
#      also defines -D_REENTRANT)
# pthread: Linux, etcetera
# --thread-safe: KAI C++

case "${host_cpu}-${host_os}" in
        *solaris*)

        # On Solaris (at least, for some versions), libc contains stubbed
        # (non-functional) versions of the pthreads routines, so link-based
        # tests will erroneously succeed.  (We need to link with -pthread or
        # -lpthread.)  (The stubs are missing pthread_cleanup_push, or rather
        # a function called by this macro, so we could check for that, but
        # who knows whether they'll stub that too in a future libc.)  So,
        # we'll just look for -pthreads and -lpthread first:

        acx_pthread_flags="-pthread -pthreads pthread -mt $acx_pthread_flags"
        ;;
esac

if test x"$acx_pthread_ok" = xno; then
for flag in $acx_pthread_flags; do

        case $flag in
                none)
                AC_MSG_CHECKING([whether pthreads work without any flags])
                ;;

                -*)
                AC_MSG_CHECKING([whether pthreads work with $flag])
                PTHREAD_CFLAGS="$flag"
                ;;

                *)
                AC_MSG_CHECKING([for the pthreads library -l$flag])
                PTHREAD_LIBS="-l$flag"
                ;;
        esac

        save_LIBS="$LIBS"
        save_CFLAGS="$CFLAGS"
        LIBS="$PTHREAD_LIBS $LIBS"
        CFLAGS="$CFLAGS $PTHREAD_CFLAGS"

        # Check for various functions.  We must include pthread.h,
        # since some functions may be macros.  (On the Sequent, we
        # need a special flag -Kthread to make this header compile.)
        # We check for pthread_join because it is in -lpthread on IRIX
        # while pthread_create is in libc.  We check for pthread_attr_init
        # due to DEC craziness with -lpthreads.  We check for
        # pthread_cleanup_push because it is one of the few pthread
        # functions on Solaris that doesn't have a non-functional libc stub.
        # We try pthread_create on general principles.
        AC_TRY_LINK([#include <pthread.h>],
                    [pthread_t th; pthread_join(th, 0);
                     pthread_attr_init(0); pthread_cleanup_push(0, 0);
                     pthread_create(0,0,0,0); pthread_cleanup_pop(0); ],
                    [acx_pthread_ok=yes])

        LIBS="$save_LIBS"
        CFLAGS="$save_CFLAGS"

        AC_MSG_RESULT($acx_pthread_ok)
        if test "x$acx_pthread_ok" = xyes; then
                break;
        fi

        PTHREAD_LIBS=""
        PTHREAD_CFLAGS=""
done
fi

# Various other checks:
if test "x$acx_pthread_ok" = xyes; then
        save_LIBS="$LIBS"
        LIBS="$PTHREAD_LIBS $LIBS"
        save_CFLAGS="$CFLAGS"
        CFLAGS="$CFLAGS $PTHREAD_CFLAGS"

        # Detect AIX lossage: threads are created detached by default
        # and the JOINABLE attribute has a nonstandard name (UNDETACHED).
        AC_MSG_CHECKING([for joinable pthread attribute])
        AC_TRY_LINK([#include <pthread.h>],
                    [int attr=PTHREAD_CREATE_JOINABLE;],
                    ok=PTHREAD_CREATE_JOINABLE, ok=unknown)
        if test x"$ok" = xunknown; then
                AC_TRY_LINK([#include <pthread.h>],
                            [int attr=PTHREAD_CREATE_UNDETACHED;],
                            ok=PTHREAD_CREATE_UNDETACHED, ok=unknown)
        fi
        if test x"$ok" != xPTHREAD_CREATE_JOINABLE; then
                AC_DEFINE(PTHREAD_CREATE_JOINABLE, $ok,
                          [Define to the necessary symbol if this constant
                           uses a non-standard name on your system.])
        fi
        AC_MSG_RESULT(${ok})
        if test x"$ok" = xunknown; then
                AC_MSG_WARN([we do not know how to create joinable pthreads])
        fi

        AC_MSG_CHECKING([if more special flags are required for pthreads])
        flag=no
        case "${host_cpu}-${host_os}" in
                *-aix* | *-freebsd*)     flag="-D_THREAD_SAFE";;
                *solaris* | alpha*-osf*) flag="-D_REENTRANT";;
        esac
        AC_MSG_RESULT(${flag})
        if test "x$flag" != xno; then
                PTHREAD_CFLAGS="$flag $PTHREAD_CFLAGS"
        fi

        LIBS="$save_LIBS"
        CFLAGS="$save_CFLAGS"

        # More AIX lossage: must compile with cc_r
        AC_CHECK_PROG(PTHREAD_CC, cc_r, cc_r, ${CC})
else
        PTHREAD_CC="$CC"
fi

AC_SUBST(PTHREAD_LIBS)
AC_SUBST(PTHREAD_CFLAGS)
AC_SUBST(PTHREAD_CC)

# Finally, execute ACTION-IF-FOUND/ACTION-IF-NOT-FOUND:
if test x"$acx_pthread_ok" = xyes; then
        ifelse([$1],,AC_DEFINE(HAVE_PTHREAD,1,[Define if you have POSIX threads libraries and header files.]),[$1])
        :
else
        acx_pthread_ok=no
        $2
fi

])dnl ACX_PTHREAD



dnl dast.m4
dnl Macros taken from dast.m4 shipped with iperf package:
dnl ===================================================================
dnl dast.m4
dnl by Ajay Tirumala <tirumala@ncsa.uiuc.edu>
dnl    and Mark Gates <mgates@nlanr.net>
dnl Copyright 1999-2002 Board of Trustees of the University of Illinois.
dnl See the main web page for full copyrights notice and disclaimer
dnl ===================================================================

dnl ===================================================================
dnl DAST_CHECK_TYPE( type, includes [, default] )
dnl Check whether a type exists.
dnl If it does not exist, use the default (if given).
dnl Define HAVE_<type> if it exists or a default is given.

AC_DEFUN([DAST_CHECK_TYPE], [

AC_CACHE_CHECK(for $1, ac_cv_type_$1,
  AC_TRY_COMPILE(
    [$2],
    [$1 foo],
  ac_cv_type_$1=yes,
  ac_cv_type_$1=no)

if test "$ac_cv_type_$1" = no; then
  if test -n "$3"; then
    ac_cv_type_$1="$3"
  fi
fi)

if test "$ac_cv_type_$1" != no; then
  if test "$ac_cv_type_$1" != yes; then
    AC_DEFINE_UNQUOTED($1, $ac_cv_type_$1, [Define $1 to the according type of your system])
  else
    AC_DEFINE_UNQUOTED(translit(HAVE_$1, `a-z', `A-Z'), 1, [Define if you have a $1 type on youre system.])
  fi
fi

])

dnl ===================================================================
dnl DAST_CHECK_TYPE_SIZEOF( type, includes, sizeof [, default] )
dnl Check for the type as AC_CHECK_TYPE does. Define HAVE_<type>
dnl if type exists; don't define <type> to anything if it doesn't exist.
dnl Useful if there is no well-defined default type, such as int32_t
dnl Also allows additional include files

AC_DEFUN([DAST_CHECK_TYPE_SIZEOF], [

AC_CACHE_CHECK(for $1, ac_cv_type_$1,
  AC_TRY_COMPILE(
    [$2],
    [$1 foo],
  ac_cv_type_$1=yes,
  ac_cv_type_$1=no)

if test $ac_cv_type_$1 != yes ; then
  if test "$ac_cv_sizeof_char" = $3; then
    ac_cv_type_$1="char"
  else if test "$ac_cv_sizeof_short" = $3; then
    ac_cv_type_$1="short"
  else if test "$ac_cv_sizeof_int" = $3; then
    ac_cv_type_$1="int"
  else if test "$ac_cv_sizeof_long" = $3; then
    ac_cv_type_$1="long"
  else if test "$ac_cv_sizeof_long_long" = $3; then
    ac_cv_type_$1="long long"
  fi fi fi fi fi
fi

if test "$ac_cv_type_$1" = no; then
  if test -n "$4"; then
    ac_cv_type_$1="$4"
  fi
fi)

if test "$ac_cv_type_$1" != no; then
  if test "$ac_cv_type_$1" != yes; then
    AC_DEFINE_UNQUOTED($1, $ac_cv_type_$1, [Define $1 to a type with size $3])
  else
    AC_DEFINE_UNQUOTED(translit(HAVE_$1, `a-z', `A-Z'), 1, [Define if you have a $1 type with size $3])
  fi
fi

])

AC_DEFUN([DAST_CHECK_TYPE_SIZEOF_UNSIGNED], [

AC_CACHE_CHECK(for $1, ac_cv_type_$1,
  AC_TRY_COMPILE(
    [$2],
    [$1 foo],
  ac_cv_type_$1=yes,
  ac_cv_type_$1=no)

if test $ac_cv_type_$1 != yes ; then
  if test "$ac_cv_sizeof_unsigned_char" = $3; then
    ac_cv_type_$1="unsigned char"
  else if test "$ac_cv_sizeof_unsigned_short" = $3; then
    ac_cv_type_$1="unsigned short"
  else if test "$ac_cv_sizeof_unsigned_int" = $3; then
    ac_cv_type_$1="unsigned int"
  else if test "$ac_cv_sizeof_unsigned_long" = $3; then
    ac_cv_type_$1="unsigned long"
  else if test "$ac_cv_sizeof_unsigned_long_long" = $3; then
    ac_cv_type_$1="unsigned long long"
  fi fi fi fi fi
fi

if test "$ac_cv_type_$1" = no; then
  if test -n "$4"; then
    ac_cv_type_$1="$4"
  fi
fi)

if test "$ac_cv_type_$1" != no; then
  if test "$ac_cv_type_$1" != yes; then
    AC_DEFINE_UNQUOTED($1, $ac_cv_type_$1, [Define $1 to unsigned type with size $3])
  else
    AC_DEFINE_UNQUOTED(translit(HAVE_$1, `a-z', `A-Z'), 1, [Define if you have a $1 unsigned type with size $3])
  fi
fi

])

dnl ===================================================================
dnl Check for IPV6 support
dnl We have avoided checking for ss_family in sockaddr_storage because
dnl linux 2.4.x versions support IPv6 but do not have this structure
dnl Just check for the presence of sockaddr_storage, sockaddr_in6 
dnl and sin6_port
dnl ===================================================================
AC_DEFUN([DAST_CHECK_IPV6], [	
    AC_TRY_COMPILE(
	[#include <sys/types.h>
    	 #include <sys/socket.h>
	 #include <netinet/in.h>
	 #include <netinet/tcp.h>
	],
      	[struct sockaddr_storage sa_union, *sa_unionp;
  	 struct sockaddr_in6 *sa;
  	 sa_unionp = &sa_union;
  	 sa = (struct sockaddr_in6 *)sa_unionp;
  	 sa->sin6_port = ntohs(5001);
        ],
    	ac_accept_ipv6=yes,
    	ac_accept_ipv6=no)
    if test "$ac_accept_ipv6" = yes ; then
    	AC_DEFINE_UNQUOTED(IPV6, 1, [Define if your system has IPV6 support])
    fi	
])


dnl NMM_CHECK_TYPE_SOCKLEN_T
dnl
dnl taken from the iperf package, see nmm/utils/iperf/LICENSE.iperf
dnl for copyright details.

dnl Just checking whether socklen_t is defined is (alas)
dnl not sufficient. DEC OSF/1 defines it as unsigned long,
dnl but uses int as the argument for accept (this is a bug).
dnl AIX doesn't define it, but uses size_t not int as the
dnl argument for accept.
dnl Use C++ here to get an error, not just a warning as C does.

AC_DEFUN([DAST_ACCEPT_ARG], [
  if test -z "$ac_cv_accept_arg" ; then
    AC_LANG_SAVE
    AC_LANG_CPLUSPLUS

    AC_TRY_COMPILE(
      [#include <sys/types.h>
       #include <sys/socket.h>],
      [$1 length;
       accept( 0, 0, &length );],
    ac_cv_accept_arg=$1,
    ac_cv_accept_arg=)

    AC_LANG_RESTORE
  fi
])

AC_DEFUN([NMM_CHECK_TYPE_SOCKLEN_T], [
  AC_CACHE_CHECK(3rd argument of accept, ac_cv_accept_arg, [
    dnl Try socklen_t (POSIX)
    DAST_ACCEPT_ARG(socklen_t)

    dnl Try int (original BSD)
    DAST_ACCEPT_ARG(int)

    dnl Try size_t (older standard; AIX)
    DAST_ACCEPT_ARG(size_t)

    dnl Try short (should not be)
    DAST_ACCEPT_ARG(short)

    dnl Try long (should not be)
    DAST_ACCEPT_ARG(long)
  ])

  if test -z "$ac_cv_accept_arg" ; then
    AC_MSG_ERROR([***  Could not determine 3rd argument of accept(), strange system!  ***])
  fi

  AC_DEFINE_UNQUOTED(Socklen_t, $ac_cv_accept_arg, [Define to the type of the 3rd argument to accept() on your system.])
])

dnl =====================================================================
dnl check for glib 
dnl =====================================================================

# Configure paths for GLIB
# Owen Taylor     1997-2001

dnl AM_PATH_GLIB_2_0([MINIMUM-VERSION, [ACTION-IF-FOUND [, ACTION-IF-NOT-FOUND [, MODULES]]]])
dnl Test for GLIB, and define GLIB_CFLAGS and GLIB_LIBS, if gmodule, gobject or 
dnl gthread is specified in MODULES, pass to pkg-config
dnl
AC_DEFUN([AM_PATH_GLIB_2_0],
[dnl 
dnl Get the cflags and libraries from pkg-config
dnl
AC_ARG_ENABLE(glibtest, [  --disable-glibtest          Do NOT try to compile and run a test GLIB program],
		    , enable_glibtest=yes)

  pkg_config_args=glib-2.0
  for module in . $4
  do
      case "$module" in
         gmodule) 
             pkg_config_args="$pkg_config_args gmodule-2.0"
         ;;
         gmodule-no-export) 
             pkg_config_args="$pkg_config_args gmodule-no-export-2.0"
         ;;
         gobject) 
             pkg_config_args="$pkg_config_args gobject-2.0"
         ;;
         gthread) 
             pkg_config_args="$pkg_config_args gthread-2.0"
         ;;
      esac
  done

  AC_PATH_PROG(PKG_CONFIG, pkg-config, no)

  no_glib=""

  if test x$PKG_CONFIG != xno ; then
    if $PKG_CONFIG --atleast-pkgconfig-version 0.7 ; then
      :
    else
      echo *** pkg-config too old; version 0.7 or better required.
      no_glib=yes
      PKG_CONFIG=no
    fi
  else
    no_glib=yes
  fi

  min_glib_version=ifelse([$1], ,2.0.0,$1)
  AC_MSG_CHECKING(for GLIB - version >= $min_glib_version)

  if test x$PKG_CONFIG != xno ; then
    ## don't try to run the test against uninstalled libtool libs
    if $PKG_CONFIG --uninstalled $pkg_config_args; then
	  echo "Will use uninstalled version of GLib found in PKG_CONFIG_PATH"
	  enable_glibtest=no
    fi

    if $PKG_CONFIG --atleast-version $min_glib_version $pkg_config_args; then
	  :
    else
	  no_glib=yes
    fi
  fi

  if test x"$no_glib" = x ; then
    GLIB_GENMARSHAL=`$PKG_CONFIG --variable=glib_genmarshal glib-2.0`
    GOBJECT_QUERY=`$PKG_CONFIG --variable=gobject_query glib-2.0`
    GLIB_MKENUMS=`$PKG_CONFIG --variable=glib_mkenums glib-2.0`

    GLIB_CFLAGS=`$PKG_CONFIG --cflags $pkg_config_args`
    GLIB_LIBS=`$PKG_CONFIG --libs $pkg_config_args`
    glib_config_major_version=`$PKG_CONFIG --modversion glib-2.0 | \
           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\1/'`
    glib_config_minor_version=`$PKG_CONFIG --modversion glib-2.0 | \
           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\2/'`
    glib_config_micro_version=`$PKG_CONFIG --modversion glib-2.0 | \
           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\3/'`
    if test "x$enable_glibtest" = "xyes" ; then
      ac_save_CFLAGS="$CFLAGS"
      ac_save_LIBS="$LIBS"
      CFLAGS="$CFLAGS $GLIB_CFLAGS"
      LIBS="$GLIB_LIBS $LIBS"
dnl
dnl Now check if the installed GLIB is sufficiently new. (Also sanity
dnl checks the results of pkg-config to some extent)
dnl
      rm -f conf.glibtest
      AC_TRY_RUN([
#include <glib.h>
#include <stdio.h>
#include <stdlib.h>

int 
main ()
{
  int major, minor, micro;
  char *tmp_version;

  system ("touch conf.glibtest");

  /* HP/UX 9 (%@#!) writes to sscanf strings */
  tmp_version = g_strdup("$min_glib_version");
  if (sscanf(tmp_version, "%d.%d.%d", &major, &minor, &micro) != 3) {
     printf("%s, bad version string\n", "$min_glib_version");
     exit(1);
   }

  if ((glib_major_version != $glib_config_major_version) ||
      (glib_minor_version != $glib_config_minor_version) ||
      (glib_micro_version != $glib_config_micro_version))
    {
      printf("\n*** 'pkg-config --modversion glib-2.0' returned %d.%d.%d, but GLIB (%d.%d.%d)\n", 
             $glib_config_major_version, $glib_config_minor_version, $glib_config_micro_version,
             glib_major_version, glib_minor_version, glib_micro_version);
      printf ("*** was found! If pkg-config was correct, then it is best\n");
      printf ("*** to remove the old version of GLib. You may also be able to fix the error\n");
      printf("*** by modifying your LD_LIBRARY_PATH enviroment variable, or by editing\n");
      printf("*** /etc/ld.so.conf. Make sure you have run ldconfig if that is\n");
      printf("*** required on your system.\n");
      printf("*** If pkg-config was wrong, set the environment variable PKG_CONFIG_PATH\n");
      printf("*** to point to the correct configuration files\n");
    } 
  else if ((glib_major_version != GLIB_MAJOR_VERSION) ||
	   (glib_minor_version != GLIB_MINOR_VERSION) ||
           (glib_micro_version != GLIB_MICRO_VERSION))
    {
      printf("*** GLIB header files (version %d.%d.%d) do not match\n",
	     GLIB_MAJOR_VERSION, GLIB_MINOR_VERSION, GLIB_MICRO_VERSION);
      printf("*** library (version %d.%d.%d)\n",
	     glib_major_version, glib_minor_version, glib_micro_version);
    }
  else
    {
      if ((glib_major_version > major) ||
        ((glib_major_version == major) && (glib_minor_version > minor)) ||
        ((glib_major_version == major) && (glib_minor_version == minor) && (glib_micro_version >= micro)))
      {
        return 0;
       }
     else
      {
        printf("\n*** An old version of GLIB (%d.%d.%d) was found.\n",
               glib_major_version, glib_minor_version, glib_micro_version);
        printf("*** You need a version of GLIB newer than %d.%d.%d. The latest version of\n",
	       major, minor, micro);
        printf("*** GLIB is always available from ftp://ftp.gtk.org.\n");
        printf("***\n");
        printf("*** If you have already installed a sufficiently new version, this error\n");
        printf("*** probably means that the wrong copy of the pkg-config shell script is\n");
        printf("*** being found. The easiest way to fix this is to remove the old version\n");
        printf("*** of GLIB, but you can also set the PKG_CONFIG environment to point to the\n");
        printf("*** correct copy of pkg-config. (In this case, you will have to\n");
        printf("*** modify your LD_LIBRARY_PATH enviroment variable, or edit /etc/ld.so.conf\n");
        printf("*** so that the correct libraries are found at run-time))\n");
      }
    }
  return 1;
}
],, no_glib=yes,[echo $ac_n "cross compiling; assumed OK... $ac_c"])
       CFLAGS="$ac_save_CFLAGS"
       LIBS="$ac_save_LIBS"
     fi
  fi
  if test "x$no_glib" = x ; then
     AC_MSG_RESULT(yes (version $glib_config_major_version.$glib_config_minor_version.$glib_config_micro_version))
     ifelse([$2], , :, [$2])     
  else
     AC_MSG_RESULT(no)
     if test "$PKG_CONFIG" = "no" ; then
       echo "*** A new enough version of pkg-config was not found."
       echo "*** See http://www.freedesktop.org/software/pkgconfig/"
     else
       if test -f conf.glibtest ; then
        :
       else
          echo "*** Could not run GLIB test program, checking why..."
          ac_save_CFLAGS="$CFLAGS"
          ac_save_LIBS="$LIBS"
          CFLAGS="$CFLAGS $GLIB_CFLAGS"
          LIBS="$LIBS $GLIB_LIBS"
          AC_TRY_LINK([
#include <glib.h>
#include <stdio.h>
],      [ return ((glib_major_version) || (glib_minor_version) || (glib_micro_version)); ],
        [ echo "*** The test program compiled, but did not run. This usually means"
          echo "*** that the run-time linker is not finding GLIB or finding the wrong"
          echo "*** version of GLIB. If it is not finding GLIB, you'll need to set your"
          echo "*** LD_LIBRARY_PATH environment variable, or edit /etc/ld.so.conf to point"
          echo "*** to the installed location  Also, make sure you have run ldconfig if that"
          echo "*** is required on your system"
	  echo "***"
          echo "*** If you have an old version installed, it is best to remove it, although"
          echo "*** you may also be able to get things to work by modifying LD_LIBRARY_PATH" ],
        [ echo "*** The test program failed to compile or link. See the file config.log for the"
          echo "*** exact error that occured. This usually means GLIB is incorrectly installed."])
          CFLAGS="$ac_save_CFLAGS"
          LIBS="$ac_save_LIBS"
       fi
     fi
     GLIB_CFLAGS=""
     GLIB_LIBS=""
     GLIB_GENMARSHAL=""
     GOBJECT_QUERY=""
     GLIB_MKENUMS=""
     ifelse([$3], , :, [$3])
  fi
  AC_SUBST(GLIB_CFLAGS)
  AC_SUBST(GLIB_LIBS)
  AC_SUBST(GLIB_GENMARSHAL)
  AC_SUBST(GOBJECT_QUERY)
  AC_SUBST(GLIB_MKENUMS)
  rm -f conf.glibtest
])

# Configure paths for GLIB
# Owen Taylor     97-11-3

dnl AM_PATH_GLIB([MINIMUM-VERSION, [ACTION-IF-FOUND [, ACTION-IF-NOT-FOUND [, MODULES]]]])
dnl Test for GLIB, and define GLIB_CFLAGS and GLIB_LIBS, if "gmodule" or 
dnl gthread is specified in MODULES, pass to glib-config
dnl
AC_DEFUN([AM_PATH_GLIB],
[dnl 
dnl Get the cflags and libraries from the glib-config script
dnl
AC_ARG_WITH(glib-prefix,[  --with-glib-prefix=PFX   Prefix where GLIB is installed (optional)],
            glib_config_prefix="$withval", glib_config_prefix="")
AC_ARG_WITH(glib-exec-prefix,[  --with-glib-exec-prefix=PFX Exec prefix where GLIB is installed (optional)],
            glib_config_exec_prefix="$withval", glib_config_exec_prefix="")
AC_ARG_ENABLE(glibtest, [  --disable-glibtest       Do NOT try to compile and run a test GLIB program],
		    , enable_glibtest=yes)

  if test x$glib_config_exec_prefix != x ; then
     glib_config_args="$glib_config_args --exec-prefix=$glib_config_exec_prefix"
     if test x${GLIB_CONFIG+set} != xset ; then
        GLIB_CONFIG=$glib_config_exec_prefix/bin/glib-config
     fi
  fi
  if test x$glib_config_prefix != x ; then
     glib_config_args="$glib_config_args --prefix=$glib_config_prefix"
     if test x${GLIB_CONFIG+set} != xset ; then
        GLIB_CONFIG=$glib_config_prefix/bin/glib-config
     fi
  fi

  for module in . $4
  do
      case "$module" in
         gmodule) 
             glib_config_args="$glib_config_args gmodule"
         ;;
         gthread) 
             glib_config_args="$glib_config_args gthread"
         ;;
      esac
  done

  AC_PATH_PROG(GLIB_CONFIG, glib-config, no)
  min_glib_version=ifelse([$1], ,0.99.7,$1)
  AC_MSG_CHECKING(for GLIB - version >= $min_glib_version)
  no_glib=""
  if test "$GLIB_CONFIG" = "no" ; then
    no_glib=yes
  else
    GLIB_CFLAGS=`$GLIB_CONFIG $glib_config_args --cflags`
    GLIB_LIBS=`$GLIB_CONFIG $glib_config_args --libs`
    glib_config_major_version=`$GLIB_CONFIG $glib_config_args --version | \
           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\1/'`
    glib_config_minor_version=`$GLIB_CONFIG $glib_config_args --version | \
           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\2/'`
    glib_config_micro_version=`$GLIB_CONFIG $glib_config_args --version | \
           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\3/'`
    if test "x$enable_glibtest" = "xyes" ; then
      ac_save_CFLAGS="$CFLAGS"
      ac_save_LIBS="$LIBS"
      CFLAGS="$CFLAGS $GLIB_CFLAGS"
      LIBS="$GLIB_LIBS $LIBS"
dnl
dnl Now check if the installed GLIB is sufficiently new. (Also sanity
dnl checks the results of glib-config to some extent
dnl
      rm -f conf.glibtest
      AC_TRY_RUN([
#include <glib.h>
#include <stdio.h>
#include <stdlib.h>

int 
main ()
{
  int major, minor, micro;
  char *tmp_version;

  system ("touch conf.glibtest");

  /* HP/UX 9 (%@#!) writes to sscanf strings */
  tmp_version = g_strdup("$min_glib_version");
  if (sscanf(tmp_version, "%d.%d.%d", &major, &minor, &micro) != 3) {
     printf("%s, bad version string\n", "$min_glib_version");
     exit(1);
   }

  if ((glib_major_version != $glib_config_major_version) ||
      (glib_minor_version != $glib_config_minor_version) ||
      (glib_micro_version != $glib_config_micro_version))
    {
      printf("\n*** 'glib-config --version' returned %d.%d.%d, but GLIB (%d.%d.%d)\n", 
             $glib_config_major_version, $glib_config_minor_version, $glib_config_micro_version,
             glib_major_version, glib_minor_version, glib_micro_version);
      printf ("*** was found! If glib-config was correct, then it is best\n");
      printf ("*** to remove the old version of GLIB. You may also be able to fix the error\n");
      printf("*** by modifying your LD_LIBRARY_PATH enviroment variable, or by editing\n");
      printf("*** /etc/ld.so.conf. Make sure you have run ldconfig if that is\n");
      printf("*** required on your system.\n");
      printf("*** If glib-config was wrong, set the environment variable GLIB_CONFIG\n");
      printf("*** to point to the correct copy of glib-config, and remove the file config.cache\n");
      printf("*** before re-running configure\n");
    } 
  else if ((glib_major_version != GLIB_MAJOR_VERSION) ||
	   (glib_minor_version != GLIB_MINOR_VERSION) ||
           (glib_micro_version != GLIB_MICRO_VERSION))
    {
      printf("*** GLIB header files (version %d.%d.%d) do not match\n",
	     GLIB_MAJOR_VERSION, GLIB_MINOR_VERSION, GLIB_MICRO_VERSION);
      printf("*** library (version %d.%d.%d)\n",
	     glib_major_version, glib_minor_version, glib_micro_version);
    }
  else
    {
      if ((glib_major_version > major) ||
        ((glib_major_version == major) && (glib_minor_version > minor)) ||
        ((glib_major_version == major) && (glib_minor_version == minor) && (glib_micro_version >= micro)))
      {
        return 0;
       }
     else
      {
        printf("\n*** An old version of GLIB (%d.%d.%d) was found.\n",
               glib_major_version, glib_minor_version, glib_micro_version);
        printf("*** You need a version of GLIB newer than %d.%d.%d. The latest version of\n",
	       major, minor, micro);
        printf("*** GLIB is always available from ftp://ftp.gtk.org.\n");
        printf("***\n");
        printf("*** If you have already installed a sufficiently new version, this error\n");
        printf("*** probably means that the wrong copy of the glib-config shell script is\n");
        printf("*** being found. The easiest way to fix this is to remove the old version\n");
        printf("*** of GLIB, but you can also set the GLIB_CONFIG environment to point to the\n");
        printf("*** correct copy of glib-config. (In this case, you will have to\n");
        printf("*** modify your LD_LIBRARY_PATH enviroment variable, or edit /etc/ld.so.conf\n");
        printf("*** so that the correct libraries are found at run-time))\n");
      }
    }
  return 1;
}
],, no_glib=yes,[echo $ac_n "cross compiling; assumed OK... $ac_c"])
       CFLAGS="$ac_save_CFLAGS"
       LIBS="$ac_save_LIBS"
     fi
  fi
  if test "x$no_glib" = x ; then
     AC_MSG_RESULT(yes)
     ifelse([$2], , :, [$2])     
  else
     AC_MSG_RESULT(no)
     if test "$GLIB_CONFIG" = "no" ; then
       echo "*** The glib-config script installed by GLIB could not be found"
       echo "*** If GLIB was installed in PREFIX, make sure PREFIX/bin is in"
       echo "*** your path, or set the GLIB_CONFIG environment variable to the"
       echo "*** full path to glib-config."
     else
       if test -f conf.glibtest ; then
        :
       else
          echo "*** Could not run GLIB test program, checking why..."
          CFLAGS="$CFLAGS $GLIB_CFLAGS"
          LIBS="$LIBS $GLIB_LIBS"
          AC_TRY_LINK([
#include <glib.h>
#include <stdio.h>
],      [ return ((glib_major_version) || (glib_minor_version) || (glib_micro_version)); ],
        [ echo "*** The test program compiled, but did not run. This usually means"
          echo "*** that the run-time linker is not finding GLIB or finding the wrong"
          echo "*** version of GLIB. If it is not finding GLIB, you'll need to set your"
          echo "*** LD_LIBRARY_PATH environment variable, or edit /etc/ld.so.conf to point"
          echo "*** to the installed location  Also, make sure you have run ldconfig if that"
          echo "*** is required on your system"
	  echo "***"
          echo "*** If you have an old version installed, it is best to remove it, although"
          echo "*** you may also be able to get things to work by modifying LD_LIBRARY_PATH"
          echo "***"
          echo "*** If you have a RedHat 5.0 system, you should remove the GTK package that"
          echo "*** came with the system with the command"
          echo "***"
          echo "***    rpm --erase --nodeps gtk gtk-devel" ],
        [ echo "*** The test program failed to compile or link. See the file config.log for the"
          echo "*** exact error that occured. This usually means GLIB was incorrectly installed"
          echo "*** or that you have moved GLIB since it was installed. In the latter case, you"
          echo "*** may want to edit the glib-config script: $GLIB_CONFIG" ])
          CFLAGS="$ac_save_CFLAGS"
          LIBS="$ac_save_LIBS"
       fi
     fi
     GLIB_CFLAGS=""
     GLIB_LIBS=""
     ifelse([$3], , :, [$3])
  fi
  AC_SUBST(GLIB_CFLAGS)
  AC_SUBST(GLIB_LIBS)
  rm -f conf.glibtest
])
