/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:         
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */


#ifndef MMBOXTASKMGR_H
#define MMBOXTASKMGR_H MMBOXTASKMGR_H

#include"../../main/application.hpp"
#include "../../main/mmboxstate.hpp"
#include "nmm/utils/DirReader.hpp"

#include "nmm/base/ProxyObject.hpp"

// include interfaces
#include "nmm/interfaces/video/osd/manager/ITextView.hpp"
#include "nmm/interfaces/video/osd/manager/IOSDManager.hpp"
#include "nmm/interfaces/video/osd/manager/IWidgetFactory.hpp"
#include "nmm/interfaces/apps/mmbox/ITaskMgrStateImpl.hpp"

// include widget units
#include "nmm/plugins/video/osd/manager/OSDElements/listunit.hpp"

#include <list>
using std::list;

namespace NMM {

  class TaskMgrState : public MMBoxState, public ITaskMgrStateImpl {
  public:
  
    TaskMgrState( string id,  MMBoxApplication* _app );
    ~TaskMgrState();
  
    Result doCreate( string );
    Result doKill();
  
    Result doInitialize( string );
    Result doUninitialize();
  
    Result Up();
    Result Down();

    Result colorKeyRed();
    Result colorKeyGreen();
  
    Result Back();

    /**
     * Fills the list "tasks" with the names of the active tasks.
     */
    virtual void getTaskList(list<string > & tasks);
  
  private:
    IOSDManager*      manager;
    IWidgetFactory*   factory;
  
    ListUnit*	    task_list;
  
    void activeTaskToList();
    void createWindow();
    void deleteWindow();
    Result receiveMessage(string);

  };

}

#endif //__MMBOXTASMBGR_H__
