/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002, 2003
 *                    Network-Multimedia Workgroup,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        David Maass <dama@graphics.cs.uni-sb.de>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

#ifndef TRANSCODERWEBINTERFACE
#define TRANSCODERWEBINTERFACE

namespace NMM{

  class TranscoderWebInterface {

  public:
    virtual list<pair<int,string> > getTranscodingGroups() = 0;
    virtual list<string>            getTranscodingJobs(const int& group_number) = 0;
    virtual list<string>            getGroupInformation(const int& group_number) = 0;
    virtual list<string>            getJobInformation(const int& group_number, const int& job_number) = 0;
  };
}

#endif
