#include "MainHandler.hpp"
#include "nmm/utils/embeddedWebserver/HttpConstants.hpp"

#include "nmm/utils/utils.hpp"

#include <fstream>

namespace NMM{
  MainHandler::MainHandler()
    : WebRequestHandler("")
  {}
  MainHandler::~MainHandler(){}
  
  void MainHandler::doGet (WebServerRequest *pRequest, WebServerResponse *pResponse){
    //cerr << "Method  : " << pRequest->getMethod() << endl;
    //cerr << "Protocol: " << pRequest->getProtocol() << endl;
    //cerr << "URI     : " << pRequest->getRequestURI() << endl;
    //cerr << "Query   : " << pRequest->getQueryString() << endl;
    //cerr << "RemAddr : " << pRequest->getRemoteAddress() << endl;

    if(!pRequest->getQueryString().empty()){
      ifstream f((getNMMResourceDir() + string("/mmbox/webhandler/" + pRequest->getQueryString())).c_str());
      char line[1000];
      
      if(f.fail()){
        pResponse->sendError(HTTP_NOT_FOUND);
      }else{
        while(!f.eof()){
          f.getline(line, 1000);
          pResponse->write(string(line) + "\n");
        }
        f.close(); 
      }

    }else{
      pResponse->write("<html>");
      pResponse->write("<head>");
      pResponse->write("<title> NMM :: MultimediaBox - Web-Interface </title>");
      pResponse->write("</head>");
      
      pResponse->write("<frameset cols=\"200,*\">");
      pResponse->write("<frameset rows=\"210,*\">");
      pResponse->write("<frame src=\"epg?calendar\" name=\"calendar\" scrolling=\"no\" noresize>");
      pResponse->write("<frame src=\"navigation\" name=\"decription\">");
      pResponse->write("</frameset>");
      time_t now = time(NULL);
      char t[10];
      strftime(t, sizeof(t), "%Y%m%d", localtime(&now));
      pResponse->write("<frame src=\"epg?date="+ string(t) + "\" name=\"events\">");
      pResponse->write("<noframes>");
      pResponse->write("arg");
      pResponse->write("</noframes>");
      pResponse->write("</frameset>");
      pResponse->write("</html>");
    }
  }

  void MainHandler::doPost(WebServerRequest *, WebServerResponse *){

  }
}
