/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        Christoph Wellner <chwellner@graphics.cs.uni-sb.de>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

#include "webserver.hpp"
#include "apps/mmbox/apps/webserver/handler/MainHandler.hpp"
#include "apps/mmbox/apps/webserver/handler/NavigationHandler.hpp"

namespace NMM{

  MMBoxWebServer::MMBoxWebServer()
    : server(NULL)
  {
  }
  MMBoxWebServer::MMBoxWebServer(const MMBoxWebServer&)
    : server(NULL)
    {}
  MMBoxWebServer::~MMBoxWebServer(){
    delete server;
  }

  void MMBoxWebServer::registerHandler(WebRequestHandler *handler){
    if(server){
      server->registerHandler(handler);
    }else{
    }
  }

  void MMBoxWebServer::start(MMBoxApplication *app){

    string serverPort = "0";
    MMBoxConfig* config = app->getMMBoxConfig();
    if (!(config->getValue("webserver_port", serverPort))) {
      serverPort = "0";
    }
    int port = atoi(serverPort.c_str());
    if(port > 0){
      server = new WebServer(port);
      server->registerHandler(new MainHandler());
      server->registerHandler(new NavigationHandler());
      server->start();
    }
  }
  



}
