/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        David Maass <dama@graphics.cs.uni-sb.de>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

#ifndef _NMM_WINDOWSELECTORTRANSCODE_HPP
#define _NMM_WINDOWSELECTORTRANSCODE_HPP
#include "WindowSelectorPlaylist.hpp"
#include "nmm/plugins/video/osd/manager/OSDElements/OSDElementComposit.hpp"
#include "nmm/plugins/video/osd/manager/OSDElements/listunit.hpp"

#include "nmm/interfaces/base/INode.hpp"
#include "nmm/base/graph/CompositeNode.hpp"
#include "../main/PlaylistTemplateFunctions.hpp"
#include "../main/application.hpp"

#include "nmm/utils/DirReader.hpp"
#include "nmm/base/utils/GraphURL.hpp"

#include <stack>

namespace NMM {
  class WindowSelectorTranscode :
    public WindowSelectorPlaylist {

  public:
    WindowSelectorTranscode(IOSDManager* manager, IWidgetFactory* factory, PlaylistTemplateFunctions* state);
    ~WindowSelectorTranscode();
    
    virtual void createWindows();
    
    virtual Result select();

    virtual Result colorKeyBlue();
    virtual Result colorKeyGreen();
    
    virtual void updateColorBar();

    void show() {
      OSDElementComposit::show();updateColorBar();}
  };
}

#endif
