/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        Marco Lohse <mlohse@cs.uni-sb.de> 
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

#ifndef _DISTMMBOXSTATE_HPP
#define _DISTMMBOXSTATE_HPP

#include "mmboxstate.hpp"
#include "nmm/interfaces/apps/mmbox/IMMBoxStateImpl.hpp"
// include used interfaces
#include "nmm/interfaces/video/osd/manager/IWindow.hpp"
#include "nmm/interfaces/video/osd/manager/IOSDManager.hpp"

namespace NMM {
  class DistMMBoxState : public MMBoxState,
			 virtual public IDistMMBoxStateImpl {
  public:
    DistMMBoxState( string id, MMBoxApplication* app);
    ~DistMMBoxState();

    Result Back();

    virtual Result doInitialize(string);
    virtual Result doUninitialize();

  protected: // methods from IMMBoxStateImpl (super class of IDistMMBoxStateImpl)  
    virtual Result initialize(const string& message = "");
    virtual Result uninitialize();
    virtual Result create(const string& message = "");
    virtual Result kill();

  protected: // methods from IDistMMBoxStateImpl

    virtual INode* createNode(const NodeDescription& ndescr);

    virtual INode* getAudioNode();

    virtual INode* getOsdNode();

    virtual INode* getDisplayNode();

    virtual void setNeedVideo(const bool& b);

    virtual void setNeedAudio(const bool& b);

  };
}
#endif
