/*
 * Qwt Widget Library (http://qwt.sf.net)
 * Copyright (C) 1997   Josef Wilgen
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, 
 * USA.
 */


#ifndef QWT_SCALE_IF_H
#define QWT_SCALE_IF_H

#include <qwt_scldraw.h>


class QwtScaleIf
{

private:
	bool d_userScale;

protected:

	QwtScaleDraw d_scale;
	int d_maxMajor;
	int d_maxMinor;
   
public:

	QwtScaleIf();
	virtual ~QwtScaleIf(){}
	void setScale (double vmin, double vmax, int logarithmic = 0);
	void setScale (double vmin, double vmax, double step, int logarithmic = 0);
	void setScale(const QwtScaleDiv &s);
	void setScaleMaxMajor( int ticks);
	void setScaleMaxMinor( int ticks);
	void autoScale();

	int scaleMaxMinor() const {return d_maxMinor;}
	int scaleMaxMajor() const {return d_maxMinor;}

protected:

	bool hasUserScale() {return d_userScale;}
	virtual void scaleChange() = 0;
};

inline void QwtScaleIf::setScale(const QwtScaleDiv &s)
{
    d_scale.setScale(s);
    scaleChange();
}



#endif















