/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        Michael Repplinger <repplinger@cs.uni-sb.de>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

#ifndef PLUGINVIEW_HPP
#define PLUGINVIEW_HPP

#include <qwidget.h>
#include "View.hpp"


/**
  *@author Michael Repplinger
  */
namespace NMM {
  class IPluginManager;
  class NMMApplication;
}

class QListView;
class QGridLayout;
class QListViewItem;
class QPoint;
class QPopupMenu;
          
class PluginView : public View  {
   Q_OBJECT
public: 
  PluginView(NMM::NMMApplication& na, QWidget *parent=0, const char *name=0);
  ~PluginView();

  virtual void updateView();
private:
  void allocate();
  void initConnect();

private slots:
  void openDialog(QListViewItem*, const QPoint &, int );
  void loadPlugin();
  void unloadPlugin();
  void initRegistry();
  void initFactory();

private://attributes
  QListView*    __list_view;
  QGridLayout*  __top_layout;
  QPopupMenu*   __plugin_menu;
  QListViewItem* __current_item;
  NMM::IPluginManager* __p_manager;
};

#endif
