#include "OperatorMyStruct.hpp"
#include "nmm/base/serialize/XMLValueStream.hpp"

using namespace MyNamespace;
using namespace NMM;

int main ( int, char** ) {
  MyStruct my_struct1;
  my_struct1.getName() = "my_struct1";
  my_struct1.setCounter(54);

  for (unsigned int i = 0; i < 10; ++i)
    my_struct1.getValueList().push_back(34.0 + i);


  /*Begin> serialize the object */
  XMLOValueStream xov; //create a XML based OValueStream
  xov << my_struct1;   //serialize the object

  string s = xov.toString();
  cout << s << endl;
  /*End< */


  /*Begin> deserialize the object*/
  XMLIValueStream xiv(s); //create a XML based IValueStream
  MyStruct my_struct2;
  xiv >> my_struct2;
  /*End<*/

  /*Begin> compare both objects*/
  if (my_struct1.getName() != my_struct2.getName()) {
    cerr << "deserialization failed" << endl;
    return 0;
  }

  if (my_struct1.getCounter() != my_struct2.getCounter()) {
    cerr << "deserialization failed" << endl;
    return 0;
  }

  if (my_struct1.getValueList() != my_struct2.getValueList()) {
    cerr << "deserialization failed" << endl;
    return 0;
  }
  /*End<*/

  cout << "De/serialisation successfully completed" << endl;
  return 1;
}
