#include <iostream>
#include "OperatorMyStruct.hpp"
#include "nmm/base/serialize/ValueStream.hpp"
#include "nmm/base/serialize/ComplexValue.hpp"


namespace MyNamespace {
  NMM::OValueStream& operator<<(NMM::OValueStream& o_stream, const MyStruct& my_struct) {
    o_stream.beginType("MyStruct", "MyNamespace");  //Initialize a complex type with its typename MyStruct and the namespace MyNamespace .

    o_stream << my_struct.getName();                //Write the name
    o_stream << my_struct.getCounter();             //Write the counter
    o_stream << my_struct.getValueList();           //Write the list.

    o_stream.endType();                             //End the new type
    return o_stream;
  }

  NMM::IValueStream& operator>>(NMM::IValueStream& i_stream,MyStruct& my_struct) {
    /*Begin> Type checking */
    if ((i_stream.getCurrentType() != "MyStruct") || (i_stream.getCurrentNamespace() != "MyNamespace")) {
      cerr << "Invalid Type assignment" << endl;
      i_stream.nextElement();    //Don't forget to skip this element.
      return i_stream;
    }
    /*End< */

    /*Begin> Try to access the attributes */
    if (!i_stream.goDown()) {
      cerr << "MyStruct has no attributes" << endl;
      i_stream.nextElement();   //Don't forget to skip this element.
      return i_stream;
    }
    /*End< */

    /*Begin> read the attributes in the same order as they are written*/
    i_stream >> my_struct.getName();        //reads the name

    int counter;
    i_stream >> counter;                     //reads the counter
    my_struct.setCounter(counter);

    i_stream >> my_struct.getValueList();   //reads the value_list
    /*End<*/

    i_stream.goUp();  //Don't forget to go up that calls nextElement() too.

    return i_stream;  //return a reference to the current ValueStream
  }
}
