/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        Michael Repplinger <repplinger@cs.uni-sb.de>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

#ifndef MY_STRUCT
#define MY_STRUCT

#include <list>
#include <string>

using namespace std;

namespace NMM {
  class OValueStream;
  class IValueStream;
}


namespace MyNamespace {
  class MyStruct {
  public:
                     MyStruct() : __counter(0) {};

        string&      getName()            {return __name;}
  const string&      getName()      const {return __name;}

  const list<float>& getValueList() const {return __value_list;}
        list<float>& getValueList()       {return __value_list;}
        int          getCounter()   const {return __counter;}
        void         setCounter(int i)    {__counter = i;}

  private: //The attributes
    string      __name;
    int         __counter;
    list<float> __value_list;
  };

  NMM::OValueStream& operator<<(NMM::OValueStream&, const MyStruct& );
  NMM::IValueStream& operator>>(NMM::IValueStream&,MyStruct& );
}

#endif

