/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        Michael Repplinger <repplinger@cs.uni-sb.de>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */


#ifndef _NMM_STDNAMEDOBJECT_HPP_
#define _NMM_STDNAMEDOBJECT_HPP_

#include "nmm/interfaces/base/INamedImpl.hpp"

using namespace std;

namespace NMM {
  class StdNamedObject : public INamedImpl, public NamedObject {
    public:

    /** Default constructor
      */
      StdNamedObject(const string& name = "NMMObject");

    /** Destructor
      */
      virtual ~StdNamedObject();

    /** Both event methods are still public because these methods are used in several nodes */
      virtual string getName()                                    const { return NamedObject::getName(); }
      virtual void setName(const string& name)                          { NamedObject::setName(name); }

    protected: //event methods

      virtual void setErrorStream(const string&, const int& );
      virtual void setDebugStream(const string&, const int& );
      virtual void setWarningStream(const string&, const int& );
      virtual void setMessageStream(const string&, const int& );

    private:
      vector<ostream*>          __error_stream;
      vector<ostream*>          __warning_stream;
      vector<ostream*>          __debug_stream;
      vector<ostream*>          __message_stream;
  };




}

#endif // _StdNamedObject_HPP_
