/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        NMM work group,
 *                    http://www.networkmultimedia.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */


#ifndef _NMM_CKECK_NETWORK_BANDWIDTH_HPP
#define _NMM_CHECK_NETWORK_BANDWIDTH_HPP

#include "definition.hpp"

namespace NMM
{

  /**
     Tries to check the available network bandwidth between node1 and node2 for transmitting
     the specified format.
     Note: Up till now, there is no network support in the NMM-project. This function must
           be implemented someday. This is only a dummy-function to support 
	   this feature already in the pathfinder-algorithm for finding valid formats.
     \param Node * node1: the starting node.
     \param Node * node2: the ending node.
     \param Format * format: the intersection-format which will be used for this link.
     \return true if the available bandwidth is sufficient, otherwise false.
  **/
  bool checkNetworkBandwidth(const Node * node1, const Node * node2, const Format * format);
}

#endif
