/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        NMM work group,
 *                    http://www.networkmultimedia.org
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

#include <iostream>
#include <stdlib.h>
#include <stdio.h>

#include "function.hpp"
#include "Format.hpp"

//#include "pathfinder/Negotiation_Result.hpp"
//#include "pathfinder/Node_Connector.hpp"
//#include "pathfinder/ConnectionObject.hpp"
//#include "pathfinder/ConnectionObjectMulti.hpp"
//#include "pathfinder/DependentTree.hpp"

namespace NMM
{

  string intToString(int pValue)
  {
    char s[10];
    sprintf(s, "%d", pValue);
    string ss(s);
    return ss;
  }

  string getGUID()
  {
    FILE * program;
    char   tempchar[1024];
    string tempstring;
    string uuidgen_program = "/usr/bin/uuidgen -t";
    program = popen(uuidgen_program.c_str(),"r");
    if(!program)
      GLOBAL_ERROR_STREAM2( "Could not open the external program 'uuidgen -t' ! " << endl);
    
    fgets(tempchar,1024,program);
    strtok(tempchar,"\n");
    tempstring = tempchar;
    pclose(program);
    return tempstring;
  }

//  string getHostname()
//  {
//    FILE * program;
//    char   tempchar[1024];
//    string tempstring;
//    string hostname_program = "/bin/hostname -f";
//    program = popen(hostname_program.c_str(),"r");
//    if (!program)
//      GLOBAL_ERROR_STREAM2( "could not open the external program 'hostname -f' !" << endl);
//    fgets(tempchar, 1024, program);
//    strtok(tempchar, "\n");
//    tempstring = tempchar;
//    pclose(program);
//    return tempstring;
//  }

//  string_list transformNodeConnectorList(node_connector_list & list)
//  {
//    string_list temp_list;
//    for (node_connector_iterator itr = list.begin(); itr != list.end(); itr ++)
//      {
//	temp_list.push_back((*itr).device);
//      }
//    return temp_list;
//  }

//  ostream & operator << (ostream &os, const node_connector_list & param)
//  {
//    for (node_connector_list::const_iterator itr = param.begin(); itr != param.end(); itr ++)
//      {
//	os << "Device : " << itr->device << ", "
//	   << "JackTag: " << itr->port << endl;
//      }
//    return os;
//  }
  
  ostream & operator << (ostream &os, const edge_list & param)
  {
    for (edge_list::const_iterator itr = param.begin(); itr != param.end(); itr ++)
      {
	os << (*itr) << endl;
      }
    return os;
  }

//  ostream & operator << (ostream &os, const Negotiation_Result &param)
//  {
//    os << "---------------------------------" << endl;
//    os << "cost :" << param.cost << endl;
//    if  (param.SourceFormat != NULL)
//      {
//	os << param.SourceFormat << endl;
//	os << "Source-Format :" << endl;
//	param.SourceFormat->showParameter();
//      }
//    if (param.SinkFormat != NULL)
//      {
//	os << "Sink-Format   :" << endl;
//	param.SinkFormat->showParameter();
//      }
//    os << "Edge-List   : " ;
//    edge_list templist = param.getEdgeList();
//    for (edge_iterator itr = templist.begin(); itr != templist.end(); itr ++)
//      os << *itr << " ";
//    os << endl;
//    return os;
//  }
//
//  ostream & operator << (ostream &os, const negotiation_result_list &param)
//  {
//    negotiation_result_list temp_list = param;
//    for (negotiation_result_iterator itr = temp_list.begin(); itr != temp_list.end(); itr ++)
//      {
//	os << **itr;
//      }
//    return os;
//  }
//
//
//  ostream & operator << (ostream &os, const connection_object_list &param)
//  {
//    connection_object_list temp_list = param;
//    for (connection_object_iterator itr = temp_list.begin(); itr != temp_list.end(); itr ++)
//      {
//	os << **itr;
//      }
//    return os;
//  }
//
//  ostream & operator << (ostream &os, const connection_object_multi_list &param)
//  {
//    connection_object_multi_list temp_list = param;
//    for (connection_object_multi_iterator itr = temp_list.begin(); itr != temp_list.end(); itr ++)
//      {
//	os << **itr;
//      }
//    os << "-----------------------------------" << endl;
//    return os;
//  }

  ostream & operator << (ostream &os, const string_list & param)
  {
    string_list list = (string_list)(param);
    for (string_iterator itr = list.begin(); itr != list.end(); itr ++)
      {
	os << *itr << endl;
      }
    return os;
  }

  ostream & operator << (ostream &os, const parameter_list & param)
  {
    parameter_list *list = const_cast<parameter_list *>(&param);
    for (parameter_iterator itr = list->begin(); itr != list->end(); itr++)
      {
	GLOBAL_DEBUG_STREAM2( **itr);
      }
    return os;
  }

  ostream & operator << (ostream &os, const format_list & param)
  {
    format_list *list = const_cast<format_list *>(&param);
    for (format_iterator itr = list->begin(); itr != list->end(); itr ++)
      {
	GLOBAL_DEBUG_STREAM2( **itr);
      }
    return os;
  }

//  ostream & operator << (ostream &os, const DependentTreeResultItem & param)
//  {
//    os << "DependentTreeResultItem: " << param.m_node_name << " , " << param.m_cost << " , " << param.m_quality << endl;
//    return os;
//  }
//
//  ostream & operator << (ostream &os, const DependentTreeResult & param)
//  {
//    os << "DependentTreeResult start:" << param.m_start_position << endl;
//    for (list<DependentTreeResultItem *>::const_iterator itr = param.m_DependentTreeResult.begin();
//	 itr != param.m_DependentTreeResult.end(); itr ++)
//      {
//	os << **itr;
//      }
//    os << "Total weight : " << param.m_total_weight << endl;
//    os << "Total cost   : " << param.m_total_cost << endl << endl;
//    return os;
//  }
//
//  ostream & operator << (ostream &os, const dependent_tree_result_list & param)
//  {
//    for (list<DependentTreeResult *>::const_iterator itr = param.begin(); itr != param.end(); itr ++)
//      {
//	os << **itr;
//      }
//    return os;
//  }
}
