
#ifndef NMM_IMMBoxApplication_HPP
#define NMM_IMMBoxApplication_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>

#include "IMMBoxState.hpp"

namespace NMM
{

  class IMMBoxApplication : virtual public Interface { 
  public:
    IMMBoxApplication() {  setTypeInfo(TypeInfo(IMMBoxApplication::IMMBoxApplication_type, "NMM")); };

    IMMBoxApplication(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(IMMBoxApplication::IMMBoxApplication_type, "NMM")); setEventReceiver(parent); };

    virtual ~IMMBoxApplication() {};

    static const char* IMMBoxApplication_type;

    virtual  string getInterfaceType() const { return IMMBoxApplication_type; }

    Interface* copy() const { return new IMMBoxApplication(*this); }
    static const char* getStateSessionLocation_event;
    static const char* createDistState_event;
    static const char* deleteDistState_event;

    virtual string getStateSessionLocation(const string& id)
      throw(const Exception&);

    virtual IMMBoxState* createDistState(const string& id)
      throw(const Exception&);

    virtual void deleteDistState(const string& id)
      throw(const Exception&);


  };

  typedef auto_ptr<IMMBoxApplication> IMMBoxApplication_var;




}

#endif
