
#include "ITaskMgrState.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void ITaskMgrState::getTaskList(list<string > & tasks)
      throw(const Exception&)
  {
    TOutValue<list<string >  > tasks_value(tasks);
    Event event("ITaskMgrState::getTaskList", &tasks_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    tasks = tasks_value.getRValue();
  }

  const char* ITaskMgrState::ITaskMgrState_type = "ITaskMgrState";
  TIFactoryObject<ITaskMgrState > __ITaskMgrState_prototype("ITaskMgrState");


  const char* ITaskMgrState::getTaskList_event = "ITaskMgrState::getTaskList";


}


