
#ifndef NMM_IMute_HPP
#define NMM_IMute_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{

  class IMute : virtual public Interface { 
  public:
    IMute() {  setTypeInfo(TypeInfo(IMute::IMute_type, "NMM")); };

    IMute(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(IMute::IMute_type, "NMM")); setEventReceiver(parent); };

    virtual ~IMute() {};

    static const char* IMute_type;

    virtual  string getInterfaceType() const { return IMute_type; }

    Interface* copy() const { return new IMute(*this); }
    static const char* mute_event;
    static Event* create_mute();
    static const char* unmute_event;
    static Event* create_unmute();
  /* instream (protected) and non-instream (public) */        /**
     * Mutes an audio source or sink
     */

    virtual void mute() /* in-stream */ 
      throw(const Exception&);
        /**
     * Un-mutes an audio source or sink
     */

    virtual void unmute() /* in-stream */ 
      throw(const Exception&);


  };

  typedef auto_ptr<IMute> IMute_var;




}

#endif
