
#include "IIcecast.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  Result IIcecast::setServerIP(const string& value) /* limited(INode::INITIALIZED) */ /* required(INode::INITIALIZED, INode::ACTIVATED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TOutValue<Result > return_value;
    TInValue<string > value_value(value, false);
    Event event("IIcecast::setServerIP", &value_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  Result IIcecast::setServerPort(const int& value) /* limited(INode::INITIALIZED) */ /* required(INode::INITIALIZED, INode::ACTIVATED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TOutValue<Result > return_value;
    TInValue<int > value_value(value, false);
    Event event("IIcecast::setServerPort", &value_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  Result IIcecast::setServerPassword(const string& value) /* limited(INode::INITIALIZED) */ /* required(INode::INITIALIZED, INode::ACTIVATED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TOutValue<Result > return_value;
    TInValue<string > value_value(value, false);
    Event event("IIcecast::setServerPassword", &value_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  Result IIcecast::setUser(const string& value) /* limited(INode::INITIALIZED) */ /* required(INode::INITIALIZED, INode::ACTIVATED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TOutValue<Result > return_value;
    TInValue<string > value_value(value, false);
    Event event("IIcecast::setUser", &value_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  Result IIcecast::setMountpoint(const string& value) /* limited(INode::INITIALIZED) */ /* required(INode::INITIALIZED, INode::ACTIVATED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TOutValue<Result > return_value;
    TInValue<string > value_value(value, false);
    Event event("IIcecast::setMountpoint", &value_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  Result IIcecast::setTitle(const string& value) /* limited(INode::INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TOutValue<Result > return_value;
    TInValue<string > value_value(value, false);
    Event event("IIcecast::setTitle", &value_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  Result IIcecast::setStreamName(const string& value) /* limited(INode::INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TOutValue<Result > return_value;
    TInValue<string > value_value(value, false);
    Event event("IIcecast::setStreamName", &value_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  Result IIcecast::setGenre(const string& value) /* limited(INode::INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TOutValue<Result > return_value;
    TInValue<string > value_value(value, false);
    Event event("IIcecast::setGenre", &value_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  Result IIcecast::setDescription(const string& value) /* limited(INode::INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TOutValue<Result > return_value;
    TInValue<string > value_value(value, false);
    Event event("IIcecast::setDescription", &value_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  Result IIcecast::setURL(const string& value) /* limited(INode::INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TOutValue<Result > return_value;
    TInValue<string > value_value(value, false);
    Event event("IIcecast::setURL", &value_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  Result IIcecast::setPublic(const int& value) /* limited(INode::INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TOutValue<Result > return_value;
    TInValue<int > value_value(value, false);
    Event event("IIcecast::setPublic", &value_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  Result IIcecast::setSendTitle(const bool& value) /* limited(INode::INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TOutValue<Result > return_value;
    TInValue<bool > value_value(value, false);
    Event event("IIcecast::setSendTitle", &value_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* IIcecast::IIcecast_type = "IIcecast";
  TIFactoryObject<IIcecast > __IIcecast_prototype("IIcecast");


  const char* IIcecast::setServerIP_event = "IIcecast::setServerIP";
  const char* IIcecast::setServerPort_event = "IIcecast::setServerPort";
  const char* IIcecast::setServerPassword_event = "IIcecast::setServerPassword";
  const char* IIcecast::setUser_event = "IIcecast::setUser";
  const char* IIcecast::setMountpoint_event = "IIcecast::setMountpoint";
  const char* IIcecast::setTitle_event = "IIcecast::setTitle";
  const char* IIcecast::setStreamName_event = "IIcecast::setStreamName";
  const char* IIcecast::setGenre_event = "IIcecast::setGenre";
  const char* IIcecast::setDescription_event = "IIcecast::setDescription";
  const char* IIcecast::setURL_event = "IIcecast::setURL";
  const char* IIcecast::setPublic_event = "IIcecast::setPublic";
  const char* IIcecast::setSendTitle_event = "IIcecast::setSendTitle";


}


