
#include "IOggVorbis.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  string IOggVorbis::getUserComments()
      throw(const Exception&)
  {
    TOutValue<string > return_value;
    Event event("IOggVorbis::getUserComments");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  string IOggVorbis::getVendor()
      throw(const Exception&)
  {
    TOutValue<string > return_value;
    Event event("IOggVorbis::getVendor");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* IOggVorbis::IOggVorbis_type = "IOggVorbis";
  TIFactoryObject<IOggVorbis > __IOggVorbis_prototype("IOggVorbis");


  const char* IOggVorbis::getUserComments_event = "IOggVorbis::getUserComments";
  const char* IOggVorbis::getVendor_event = "IOggVorbis::getVendor";


}


