
#ifndef NMM_IStreamJump_HPP
#define NMM_IStreamJump_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{

  class IStreamJump : virtual public Interface { 
  public:
    IStreamJump() {  setTypeInfo(TypeInfo(IStreamJump::IStreamJump_type, "NMM")); };

    IStreamJump(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(IStreamJump::IStreamJump_type, "NMM")); setEventReceiver(parent); };

    virtual ~IStreamJump() {};

    static const char* IStreamJump_type;

    virtual  string getInterfaceType() const { return IStreamJump_type; }

    Interface* copy() const { return new IStreamJump(*this); }
    static const char* fastForward_event;
    static Event* create_fastForward(const int& value);
    static const char* streamJump_event;
    static Event* create_streamJump(const int& value);
    static const char* sendIFramesOnly_event;
    static Event* create_sendIFramesOnly(const int& n);
  /* instream (protected) and non-instream (public) */    
    virtual Result fastForward(const int& value) /* in-stream */ 
      throw(const Exception&);
    
    virtual Result streamJump(const int& value) /* in-stream */ 
      throw(const Exception&);
        /**
     * Send only n I-Frames.
     * Tells the decoder to send only the n decoded I-frames
     * (usefull for fast-forward)
     * n = 0 means normal buffer processing
     */

    virtual Result sendIFramesOnly(const int& n) /* in-stream */ 
      throw(const Exception&);


  };

  typedef auto_ptr<IStreamJump> IStreamJump_var;




}

#endif
