
#ifndef NMM_IFilterNode_HPP
#define NMM_IFilterNode_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{

  class IFilterNode : virtual public Interface { 
  public:
    IFilterNode() {  setTypeInfo(TypeInfo(IFilterNode::IFilterNode_type, "NMM")); };

    IFilterNode(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(IFilterNode::IFilterNode_type, "NMM")); setEventReceiver(parent); };

    virtual ~IFilterNode() {};

    static const char* IFilterNode_type;

    virtual  string getInterfaceType() const { return IFilterNode_type; }

    Interface* copy() const { return new IFilterNode(*this); }
    static const char* setEnabled_event;
    static const char* isEnabled_event;

    virtual void setEnabled(const bool& enable)
      throw(const Exception&);

    virtual bool isEnabled()
      throw(const Exception&);


  };

  typedef auto_ptr<IFilterNode> IFilterNode_var;




}

#endif
