
#include "IInstream.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  Result IInstream::sendMessageUpstream(const CEvent& cevent)
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    TInValue<CEvent > cevent_value(cevent, false);
    Event event("IInstream::sendMessageUpstream", &cevent_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  Result IInstream::sendMessageDownstream(const CEvent& cevent)
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    TInValue<CEvent > cevent_value(cevent, false);
    Event event("IInstream::sendMessageDownstream", &cevent_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* IInstream::IInstream_type = "IInstream";
  TIFactoryObject<IInstream > __IInstream_prototype("IInstream");


  const char* IInstream::sendMessageUpstream_event = "IInstream::sendMessageUpstream";
  const char* IInstream::sendMessageDownstream_event = "IInstream::sendMessageDownstream";


}


