
#ifndef NMM_IJack_HPP
#define NMM_IJack_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{

  class INode;

  class TSAddress;

  class IJack : virtual public Interface { 
  public:
    IJack() {  setTypeInfo(TypeInfo(IJack::IJack_type, "NMM")); };

    IJack(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(IJack::IJack_type, "NMM")); setEventReceiver(parent); };

    virtual ~IJack() {};

    static const char* IJack_type;

    virtual  string getInterfaceType() const { return IJack_type; }

    Interface* copy() const { return new IJack(*this); }
    static const char* getIParent_event;
    static const char* getJackTag_event;
    static const char* isConnected_event;
    static const char* setTransportStrategy_event;
    static const char* disconnect_event;
    static const char* connectToJack_event;
    static Event* create_connectToJack();

    virtual INode* getIParent()
      throw(const Exception&);

    virtual string getJackTag() const
      throw(const Exception&);
    /**
     * Returns true, if this Jack is connected, otherwise false.
     */

    virtual bool isConnected() const
      throw(const Exception&);

    virtual void setTransportStrategy(const TSAddress* address)
      throw(const Exception&, const BindingException&);
    /**
     * Disconnect from partner jack.
     */

    virtual void disconnect()
      throw(const Exception&);
  /* instream (protected) and non-instream (public) */    
    virtual void connectToJack() /* in-stream */ 
      throw(const Exception&);


  };

  typedef auto_ptr<IJack> IJack_var;




}

#endif
