
#include "IThreadedNode.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void IThreadedNode::lowerPriority(const unsigned int& value) /* limited(INode::OUTPUT_INITIALIZED) */ /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TInValue<unsigned int > value_value(value, false);
    Event event("IThreadedNode::lowerPriority", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
  }

  const char* IThreadedNode::IThreadedNode_type = "IThreadedNode";
  TIFactoryObject<IThreadedNode > __IThreadedNode_prototype("IThreadedNode");


  const char* IThreadedNode::lowerPriority_event = "IThreadedNode::lowerPriority";


}


