
#include "IRegistryImpl.hpp"

#include "nmm/base/registry/NodeDescription.hpp"

namespace NMM
{
  
  void IRegistryImpl::registerEvents()
  {
  
    getEventDispatcher().registerEvent(IRegistry::requestNode_event, new TEDObject4<IRegistryImpl, RegistryID, ObjectID, UserInfo, NodeDescription, INode*(IRegistryImpl:: * )(const RegistryID&, const ObjectID&, const UserInfo&, NodeDescription&), INode* >(this, &IRegistryImpl::requestNode));
  
    getEventDispatcher().registerEvent(IRegistry::requestObject_event, new TEDObject3<IRegistryImpl, RegistryID, ObjectID, UserInfo, Interface*(IRegistryImpl:: * )(const RegistryID&, const ObjectID&, const UserInfo&), Interface* >(this, &IRegistryImpl::requestObject));
  
    getEventDispatcher().registerEvent(IRegistry::releaseNode_event, new TEDObject4<IRegistryImpl, RegistryID, NMMReference, ObjectID, UserInfo, void(IRegistryImpl:: * )(const RegistryID&, const NMMReference&, const ObjectID&, const UserInfo&), void >(this, &IRegistryImpl::releaseNode));
  
    getEventDispatcher().registerEvent(IRegistry::releaseObject_event, new TEDObject4<IRegistryImpl, RegistryID, NMMReference, ObjectID, UserInfo, void(IRegistryImpl:: * )(const RegistryID&, const NMMReference&, const ObjectID&, const UserInfo&), void >(this, &IRegistryImpl::releaseObject));
  
    getEventDispatcher().registerEvent(IRegistry::initRequest_event, new TEDObject1<IRegistryImpl, NodeDescription, list<Response > (IRegistryImpl:: * )(const NodeDescription&) const, list<Response >  >(this, &IRegistryImpl::initRequest));
  
    getEventDispatcher().registerEvent(IRegistry::initObjectRequest_event, new TEDObject1<IRegistryImpl, ObjectDescription, list<Response > (IRegistryImpl:: * )(const ObjectDescription&) const, list<Response >  >(this, &IRegistryImpl::initObjectRequest));
  
    getEventDispatcher().registerEvent(IRegistry::searchNode_event, new TEDObject2<IRegistryImpl, RegistryID, NodeDescription, list<ObjectID > (IRegistryImpl:: * )(const RegistryID&, const NodeDescription&) const, list<ObjectID >  >(this, &IRegistryImpl::searchNode));
  
    getEventDispatcher().registerEvent(IRegistry::reserveNode_event, new TEDObject3<IRegistryImpl, RegistryID, ObjectID, UserInfo, FactoryTicket(IRegistryImpl:: * )(const RegistryID&, const ObjectID&, const UserInfo&), FactoryTicket >(this, &IRegistryImpl::reserveNode));
  
    getEventDispatcher().registerEvent(IRegistry::instantiateNode_event, new TEDObject3<IRegistryImpl, RegistryID, FactoryTicket, UserInfo, INode*(IRegistryImpl:: * )(const RegistryID&, const FactoryTicket&, const UserInfo&), INode* >(this, &IRegistryImpl::instantiateNode));
  
    getEventDispatcher().registerEvent(IRegistry::releaseReservation_event, new TEDObject3<IRegistryImpl, RegistryID, ObjectID, UserInfo, void(IRegistryImpl:: * )(const RegistryID&, const ObjectID&, const UserInfo&), void >(this, &IRegistryImpl::releaseReservation));
  
    getEventDispatcher().registerEvent(IRegistry::destroyNode_event, new TEDObject3<IRegistryImpl, RegistryID, NMMReference, UserInfo, void(IRegistryImpl:: * )(const RegistryID&, const NMMReference&, const UserInfo&), void >(this, &IRegistryImpl::destroyNode));
  
    getEventDispatcher().registerEvent(IRegistry::getMaxInstanceCount_event, new TEDObject2<IRegistryImpl, RegistryID, ObjectID, int(IRegistryImpl:: * )(const RegistryID&, const ObjectID&) const, int >(this, &IRegistryImpl::getMaxInstanceCount));
  
    getEventDispatcher().registerEvent(IRegistry::getInstanceCount_event, new TEDObject2<IRegistryImpl, RegistryID, ObjectID, int(IRegistryImpl:: * )(const RegistryID&, const ObjectID&) const, int >(this, &IRegistryImpl::getInstanceCount));
  
    getEventDispatcher().registerEvent(IRegistry::getPluginInfo_event, new TEDObject2<IRegistryImpl, RegistryID, ObjectID, string(IRegistryImpl:: * )(const RegistryID&, const ObjectID&) const, string >(this, &IRegistryImpl::getPluginInfo));
  
    getEventDispatcher().registerEvent(IRegistry::getNodeList_event, new TEDObject1<IRegistryImpl, RegistryID, list<ObjectID > (IRegistryImpl:: * )(const RegistryID&) const, list<ObjectID >  >(this, &IRegistryImpl::getNodeList));
  
    getEventDispatcher().registerEvent(IRegistry::getReservedNodeList_event, new TEDObject1<IRegistryImpl, RegistryID, list<ObjectID > (IRegistryImpl:: * )(const RegistryID&) const, list<ObjectID >  >(this, &IRegistryImpl::getReservedNodeList));
  
    getEventDispatcher().registerEvent(IRegistry::getNodeInfoList_event, new TEDObject1<IRegistryImpl, RegistryID, list<NodeInfo > (IRegistryImpl:: * )(const RegistryID&) const, list<NodeInfo >  >(this, &IRegistryImpl::getNodeInfoList));
  
    getEventDispatcher().registerEvent(IRegistry::getNodeDescription_event, new TEDObject2<IRegistryImpl, RegistryID, ObjectID, NodeDescription(IRegistryImpl:: * )(const RegistryID&, const ObjectID&) const, NodeDescription >(this, &IRegistryImpl::getNodeDescription));
  
    getEventDispatcher().registerEvent(IRegistry::getNodeDescriptionList_event, new TEDObject1<IRegistryImpl, RegistryID, list<NodeDescription > (IRegistryImpl:: * )(const RegistryID&), list<NodeDescription >  >(this, &IRegistryImpl::getNodeDescriptionList));
  
    getEventDispatcher().registerEvent(IRegistry::getNodeFactoryID_event, new TEDObject2<IRegistryImpl, RegistryID, ObjectID, NodeFactoryID(IRegistryImpl:: * )(const RegistryID&, const ObjectID&) const, NodeFactoryID >(this, &IRegistryImpl::getNodeFactoryID));
  
    getEventDispatcher().registerEvent(IRegistry::resetInternalReservation_event, new TEDObject0<IRegistryImpl, void(IRegistryImpl:: * )(), void >(this, &IRegistryImpl::resetInternalReservation));
  
    getEventDispatcher().registerEvent(IRegistry::resetSpecificInternalReservation_event, new TEDObject1<IRegistryImpl, UserInfo, void(IRegistryImpl:: * )(const UserInfo&), void >(this, &IRegistryImpl::resetSpecificInternalReservation));
  
    getEventDispatcher().registerEvent(IRegistry::initTransaction_event, new TEDObject1<IRegistryImpl, UserInfo, void(IRegistryImpl:: * )(const UserInfo&), void >(this, &IRegistryImpl::initTransaction));
  
    getEventDispatcher().registerEvent(IRegistry::closeTransaction_event, new TEDObject1<IRegistryImpl, UserInfo, void(IRegistryImpl:: * )(const UserInfo&), void >(this, &IRegistryImpl::closeTransaction));
  
    getEventDispatcher().registerEvent(IRegistry::getRegistryID_event, new TEDObject0<IRegistryImpl, RegistryID(IRegistryImpl:: * )() const, RegistryID >(this, &IRegistryImpl::getRegistryID));
  
    getEventDispatcher().registerEvent(IRegistry::getChildList_event, new TEDObject1<IRegistryImpl, RegistryID, list<RegistryID > (IRegistryImpl:: * )(const RegistryID&) const, list<RegistryID >  >(this, &IRegistryImpl::getChildList));
  
    getEventDispatcher().registerEvent(IRegistry::isSubRegistry_event, new TEDObject1<IRegistryImpl, RegistryID, bool(IRegistryImpl:: * )(const RegistryID&) const, bool >(this, &IRegistryImpl::isSubRegistry));
  
    getEventDispatcher().registerEvent(IRegistry::getMemento_event, new TEDObject0<IRegistryImpl, RegistryMemento(IRegistryImpl:: * )(), RegistryMemento >(this, &IRegistryImpl::getMemento));
  
    getEventDispatcher().registerEvent(IRegistry::setMemento_event, new TEDObject1<IRegistryImpl, RegistryMemento, void(IRegistryImpl:: * )(const RegistryMemento&), void >(this, &IRegistryImpl::setMemento));

  }

}


