
#include "IController.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  Time IPing::ping()
      throw(const Exception&)
  {
    TOutValue<Time > return_value;
    Event event("IPing::ping");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* IPing::IPing_type = "IPing";
  TIFactoryObject<IPing > __IPing_prototype("IPing");


  const char* IPing::ping_event = "IPing::ping";
  
  
  Result IController::setMode(const IController::Mode& value)
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    TInValue<IController::Mode > value_value(value, false);
    Event event("IController::setMode", &value_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  Result IController::permitDiscardBuffers(const bool& value)
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    TInValue<bool > value_value(value, false);
    Event event("IController::permitDiscardBuffers", &value_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  Result IController::pause()
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    Event event("IController::pause");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  Result IController::wakeup()
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    Event event("IController::wakeup");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  Result IController::reset()
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    Event event("IController::reset");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  void IController::setBuffersInvalid(const bool& status)
      throw(const Exception&)
  {
    TInValue<bool > status_value(status, false);
    Event event("IController::setBuffersInvalid", &status_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void IController::setBuffersInvalidTimed(const bool& status, const Timestamp& status_time)
      throw(const Exception&)
  {
    TInValue<bool > status_value(status, false);
    TInValue<Timestamp > status_time_value(status_time, false);
    Event event("IController::setBuffersInvalidTimed", &status_value, &status_time_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }

  const char* IController::IController_type = "IController";
  TIFactoryObject<IController > __IController_prototype("IController");
  TValueConstructor< IController::Mode > __IController_Mode_prototype(TypeInfo("IController::Mode", "NMM"));

  OValueStream& operator<<(OValueStream& ov, const IController::Mode& t)
  {
    ov.beginType(TypeInfo("IController::Mode", "NMM"));
    ov << reinterpret_cast<const int&>(t);
    ov.endType();
    return ov;
  }

  IValueStream& operator>>(IValueStream& iv, IController::Mode& t)
  {
    if(iv.getCurrentTypeInfo() != TypeInfo("IController::Mode", "NMM")) {
      throw InvalidTypeException(TypeInfo("IController::Mode", "NMM"), iv.getCurrentTypeInfo());
    }
    iv.goDown();
    iv >> reinterpret_cast<int&>(t);
    iv.goUp();
    return iv;
  }



  const char* IController::setMode_event = "IController::setMode";
  const char* IController::permitDiscardBuffers_event = "IController::permitDiscardBuffers";
  const char* IController::pause_event = "IController::pause";
  const char* IController::wakeup_event = "IController::wakeup";
  const char* IController::reset_event = "IController::reset";
  const char* IController::setBuffersInvalid_event = "IController::setBuffersInvalid";
  const char* IController::setBuffersInvalidTimed_event = "IController::setBuffersInvalidTimed";


}


