
#ifndef NMM_IMultiAudioSinkSynchronizer_HPP
#define NMM_IMultiAudioSinkSynchronizer_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>

#include "ISinkSynchronizer.hpp"

namespace NMM
{

  class IMultiAudioSinkSynchronizer : virtual public Interface { 
  public:
    IMultiAudioSinkSynchronizer() {  setTypeInfo(TypeInfo(IMultiAudioSinkSynchronizer::IMultiAudioSinkSynchronizer_type, "NMM")); };

    IMultiAudioSinkSynchronizer(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(IMultiAudioSinkSynchronizer::IMultiAudioSinkSynchronizer_type, "NMM")); setEventReceiver(parent); };

    virtual ~IMultiAudioSinkSynchronizer() {};

    static const char* IMultiAudioSinkSynchronizer_type;

    virtual  string getInterfaceType() const { return IMultiAudioSinkSynchronizer_type; }

    Interface* copy() const { return new IMultiAudioSinkSynchronizer(*this); }
    static const char* addAudioSinkController_event;
    /**
     * Adds an audio sink controller.
     * This adds the controller for an audio sink.
     * A new id is returned.
     * @param controller controller for this sink
     * @return id audio sink id
     */

    virtual int addAudioSinkController(const ISinkController* controller)
      throw(const Exception&);


  };

  typedef auto_ptr<IMultiAudioSinkSynchronizer> IMultiAudioSinkSynchronizer_var;




}

#endif
