
#include "ISinkControllerImpl.hpp"

#include "ISinkSynchronizer.hpp"

namespace NMM
{
  
  void ISinkControllerImpl::registerEvents()
  {
  
    getEventDispatcher().registerEvent(ISinkController::setMaxDelay_event, new TEDObject1<ISinkControllerImpl, Interval, Result(ISinkControllerImpl:: * )(const Interval&), Result >(this, &ISinkControllerImpl::setMaxDelay));
  
    getEventDispatcher().registerEvent(ISinkController::setMaxAverageDelay_event, new TEDObject1<ISinkControllerImpl, Interval, Result(ISinkControllerImpl:: * )(const Interval&), Result >(this, &ISinkControllerImpl::setMaxAverageDelay));
  
    getEventDispatcher().registerEvent(ISinkController::setTheoLatency_event, new TEDObject1<ISinkControllerImpl, Interval, Result(ISinkControllerImpl:: * )(const Interval&), Result >(this, &ISinkControllerImpl::setTheoLatency));
  
    getEventDispatcher().registerEvent(ISinkController::setDefaultTheoLatency_event, new TEDObject1<ISinkControllerImpl, Interval, Result(ISinkControllerImpl:: * )(const Interval&), Result >(this, &ISinkControllerImpl::setDefaultTheoLatency));
  
    getEventDispatcher().registerEvent(ISinkController::setSinkSynchronizer_event, new TEDObject2<ISinkControllerImpl, ISinkSynchronizer*, int, Result(ISinkControllerImpl:: * )(const ISinkSynchronizer*, const int&), Result >(this, &ISinkControllerImpl::setSinkSynchronizer));
  
    getEventDispatcher().registerEvent(ISinkController::setAverageCount_event, new TEDObject1<ISinkControllerImpl, int, Result(ISinkControllerImpl:: * )(const int&), Result >(this, &ISinkControllerImpl::setAverageCount));
  
    getEventDispatcher().registerEvent(ISinkController::setMaxDiscardingCount_event, new TEDObject1<ISinkControllerImpl, int, Result(ISinkControllerImpl:: * )(const int&), Result >(this, &ISinkControllerImpl::setMaxDiscardingCount));
  
    getEventDispatcher().registerEvent(ISinkController::waitForReset_event, new TEDObject0<ISinkControllerImpl, Result(ISinkControllerImpl:: * )(), Result >(this, &ISinkControllerImpl::waitForReset));
  
    getEventDispatcher().registerEvent(ISinkController::restart_event, new TEDObject0<ISinkControllerImpl, Result(ISinkControllerImpl:: * )(), Result >(this, &ISinkControllerImpl::restart));
  
    getEventDispatcher().registerEvent(ISinkController::enableWaitToPresent_event, new TEDObject1<ISinkControllerImpl, bool, Result(ISinkControllerImpl:: * )(const bool&), Result >(this, &ISinkControllerImpl::enableWaitToPresent));
  
    getEventDispatcher().registerEvent(ISinkController::setMinWaitInterval_event, new TEDObject1<ISinkControllerImpl, Interval, Result(ISinkControllerImpl:: * )(const Interval&), Result >(this, &ISinkControllerImpl::setMinWaitInterval));
  
    getEventDispatcher().registerEvent(ISinkController::enableFirstBufferInTime_event, new TEDObject1<ISinkControllerImpl, bool, void(ISinkControllerImpl:: * )(const bool&), void >(this, &ISinkControllerImpl::enableFirstBufferInTime));
  
    getEventDispatcher().registerEvent(ISinkController::enableBlocking_event, new TEDObject1<ISinkControllerImpl, bool, void(ISinkControllerImpl:: * )(const bool&), void >(this, &ISinkControllerImpl::enableBlocking));

  }

}


