
#ifndef NMM_IAudioDevice_HPP
#define NMM_IAudioDevice_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>

#include "nmm/interfaces/device/IDevice.hpp"

namespace NMM
{

  class IAudioDevice : virtual public IDevice { 
  public:
    IAudioDevice() {  setTypeInfo(TypeInfo(IAudioDevice::IAudioDevice_type, "NMM")); };

    IAudioDevice(NMMObject& parent) : IDevice(parent) {  setTypeInfo(TypeInfo(IAudioDevice::IAudioDevice_type, "NMM")); setEventReceiver(parent); };

    virtual ~IAudioDevice() {};

    static const char* IAudioDevice_type;

    virtual  string getInterfaceType() const { return IAudioDevice_type; }

    Interface* copy() const { return new IAudioDevice(*this); }
    static const char* setMixerDevice_event;
    static const char* getMixerDevice_event;
    static const char* increaseVolume_event;
    static const char* decreaseVolume_event;
    static const char* setVolume_event;
    static const char* getVolume_event;

    virtual void setMixerDevice(const string& value)
      throw(const Exception&, const DeviceNotFoundException&);

    virtual string getMixerDevice() const
      throw(const Exception&);

    virtual void increaseVolume()
      throw(const Exception&);

    virtual void decreaseVolume()
      throw(const Exception&);

    virtual void setVolume(const int& volume)
      throw(const Exception&);

    virtual int getVolume()
      throw(const Exception&);


  };

  typedef auto_ptr<IAudioDevice> IAudioDevice_var;




}

#endif
