
#ifndef NMM_IAudioDeviceImpl_HPP
#define NMM_IAudioDeviceImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "IAudioDevice.hpp"

#include "nmm/interfaces/device/IDeviceImpl.hpp"

namespace NMM
{

  class IAudioDeviceImpl  : virtual public IDeviceImpl { 
  public:
    IAudioDeviceImpl() { addInterface(new IAudioDevice(*this)); registerEvents(); };

    virtual ~IAudioDeviceImpl() {};

  protected:

    virtual void setMixerDevice(const string& value) 
      throw(const DeviceNotFoundException&) = 0;

    virtual string getMixerDevice() const = 0;

    virtual void increaseVolume() = 0;

    virtual void decreaseVolume() = 0;

    virtual void setVolume(const int& volume) = 0;

    virtual int getVolume() = 0;


  private:
    void registerEvents();
  };

}

#endif
