
#ifndef NMM_IFileSize_HPP
#define NMM_IFileSize_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{

  class IFileSize : virtual public Interface { 
  public:
    IFileSize() {  setTypeInfo(TypeInfo(IFileSize::IFileSize_type, "NMM")); };

    IFileSize(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(IFileSize::IFileSize_type, "NMM")); setEventReceiver(parent); };

    virtual ~IFileSize() {};

    static const char* IFileSize_type;

    virtual  string getInterfaceType() const { return IFileSize_type; }

    Interface* copy() const { return new IFileSize(*this); }
    static const char* hasFileSize_event;
    static const char* getFileSize_event;

    virtual bool hasFileSize()
      throw(const Exception&);

    virtual void getFileSize(u_int64_t& bytes)
      throw(const Exception&);


  };

  typedef auto_ptr<IFileSize> IFileSize_var;




}

#endif
