
#include "IPNGWrite.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void IPNGWrite::setDiscardImages(const bool& discardImages)
      throw(const Exception&)
  {
    TInValue<bool > discardImages_value(discardImages, false);
    Event event("IPNGWrite::setDiscardImages", &discardImages_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }

  const char* IPNGWrite::IPNGWrite_type = "IPNGWrite";
  TIFactoryObject<IPNGWrite > __IPNGWrite_prototype("IPNGWrite");


  const char* IPNGWrite::setDiscardImages_event = "IPNGWrite::setDiscardImages";


}


