
#include "ISeekReceiver.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  Result ISeekReciever::seeked(const u_int64_t& pos, const int64_t& offset) /* in-stream */ 
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    TInValue<u_int64_t > pos_value(pos, false);
    TInValue<int64_t > offset_value(offset, false);
    Event event("ISeekReciever::seeked", &pos_value, &offset_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* ISeekReciever::ISeekReciever_type = "ISeekReciever";
  TIFactoryObject<ISeekReciever > __ISeekReciever_prototype("ISeekReciever");


  const char* ISeekReciever::seeked_event = "ISeekReciever::seeked";
  Event* ISeekReciever::create_seeked(const u_int64_t& pos, const int64_t& offset)
  {
    TInValue<u_int64_t >* pos_value = new TInValue<u_int64_t >();
    pos_value->setValue(pos);
    TInValue<int64_t >* offset_value = new TInValue<int64_t >();
    offset_value->setValue(offset);

    return new Event("ISeekReciever::seeked", pos_value, offset_value);
  }



}


