
#ifndef NMM_ISeekReceiver_HPP
#define NMM_ISeekReceiver_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{

  class ISeekReciever : virtual public Interface { 
  public:
    ISeekReciever() {  setTypeInfo(TypeInfo(ISeekReciever::ISeekReciever_type, "NMM")); };

    ISeekReciever(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(ISeekReciever::ISeekReciever_type, "NMM")); setEventReceiver(parent); };

    virtual ~ISeekReciever() {};

    static const char* ISeekReciever_type;

    virtual  string getInterfaceType() const { return ISeekReciever_type; }

    Interface* copy() const { return new ISeekReciever(*this); }
    static const char* seeked_event;
    static Event* create_seeked(const u_int64_t& pos, const int64_t& offset);
  /* instream (protected) and non-instream (public) */        /**
     * this method tells aus the new fileposition and the seeked filesize
     *\param pos The new Fileposition
     *\param amount of data seekd
     */

    virtual Result seeked(const u_int64_t& pos, const int64_t& offset) /* in-stream */ 
      throw(const Exception&);


  };

  typedef auto_ptr<ISeekReciever> ISeekReciever_var;




}

#endif
