
#include "ISendFilenameAndTimestamp.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  Result ISendFilenameAndTimestamp::sendFilenameAndTimestamp(const string& fn, const Timestamp& ts) /* in-stream */ 
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    TInValue<string > fn_value(fn, false);
    TInValue<Timestamp > ts_value(ts, false);
    Event event("ISendFilenameAndTimestamp::sendFilenameAndTimestamp", &fn_value, &ts_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* ISendFilenameAndTimestamp::ISendFilenameAndTimestamp_type = "ISendFilenameAndTimestamp";
  TIFactoryObject<ISendFilenameAndTimestamp > __ISendFilenameAndTimestamp_prototype("ISendFilenameAndTimestamp");


  const char* ISendFilenameAndTimestamp::sendFilenameAndTimestamp_event = "ISendFilenameAndTimestamp::sendFilenameAndTimestamp";
  Event* ISendFilenameAndTimestamp::create_sendFilenameAndTimestamp(const string& fn, const Timestamp& ts)
  {
    TInValue<string >* fn_value = new TInValue<string >();
    fn_value->setValue(fn);
    TInValue<Timestamp >* ts_value = new TInValue<Timestamp >();
    ts_value->setValue(ts);

    return new Event("ISendFilenameAndTimestamp::sendFilenameAndTimestamp", fn_value, ts_value);
  }



}


