
#include "ISinkFileHandler.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void ISinkFileHandler::setWorkingDirectory(const string& directory)
      throw(const Exception&)
  {
    TInValue<string > directory_value(directory, false);
    Event event("ISinkFileHandler::setWorkingDirectory", &directory_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  string ISinkFileHandler::getWorkingDirectory()
      throw(const Exception&)
  {
    TOutValue<string > return_value;
    Event event("ISinkFileHandler::getWorkingDirectory");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  void ISinkFileHandler::setFileExtension(const string& extension)
      throw(const Exception&)
  {
    TInValue<string > extension_value(extension, false);
    Event event("ISinkFileHandler::setFileExtension", &extension_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  string ISinkFileHandler::getFileExtension()
      throw(const Exception&)
  {
    TOutValue<string > return_value;
    Event event("ISinkFileHandler::getFileExtension");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* ISinkFileHandler::ISinkFileHandler_type = "ISinkFileHandler";
  TIFactoryObject<ISinkFileHandler > __ISinkFileHandler_prototype("ISinkFileHandler");


  const char* ISinkFileHandler::setWorkingDirectory_event = "ISinkFileHandler::setWorkingDirectory";
  const char* ISinkFileHandler::getWorkingDirectory_event = "ISinkFileHandler::getWorkingDirectory";
  const char* ISinkFileHandler::setFileExtension_event = "ISinkFileHandler::setFileExtension";
  const char* ISinkFileHandler::getFileExtension_event = "ISinkFileHandler::getFileExtension";


}


