
#ifndef NMM_IDVBEPGPlugin_HPP
#define NMM_IDVBEPGPlugin_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>

#include "nmm/base/ProxyApplication.hpp"
#include "nmm/interfaces/video/tv/ITVCard.hpp"
#include "nmm/interfaces/misc/tvmanager/ITVManager.hpp"

namespace NMM
{

  class IDVBEPGPlugin : virtual public Interface { 
  public:
    IDVBEPGPlugin() {  setTypeInfo(TypeInfo(IDVBEPGPlugin::IDVBEPGPlugin_type, "NMM")); };

    IDVBEPGPlugin(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(IDVBEPGPlugin::IDVBEPGPlugin_type, "NMM")); setEventReceiver(parent); };

    virtual ~IDVBEPGPlugin() {};

    static const char* IDVBEPGPlugin_type;

    virtual  string getInterfaceType() const { return IDVBEPGPlugin_type; }

    Interface* copy() const { return new IDVBEPGPlugin(*this); }
    static const char* setConfigFile_event;
    static const char* getConfigFile_event;
    static const char* setTVManager_event;
    /**
     * Set the patch and name of the temporary config-file, where the plugin stores its current position in update
     *@param filepath and filename of configfile
     */

    virtual void setConfigFile(const string& f)
      throw(const Exception&);
    /**
     * get the filename of the temp datafile
     *@return path + datafile
     */

    virtual string getConfigFile()
      throw(const Exception&);
    /**
     *@param Application
     */ 

    virtual void setTVManager(const ITVManager* tvm)
      throw(const Exception&);


  };

  typedef auto_ptr<IDVBEPGPlugin> IDVBEPGPlugin_var;




}

#endif
