
#include "ITVGuideImpl.hpp"


namespace NMM
{
  
  void ITVGuideImpl::registerEvents()
  {
  
    getEventDispatcher().registerEvent(ITVGuide::insertChannel_event, new TEDObject2<ITVGuideImpl, string, string, Result(ITVGuideImpl:: * )(const string&, const string&), Result >(this, &ITVGuideImpl::insertChannel));
  
    getEventDispatcher().registerEvent(ITVGuide::insertChannelDescription_event, new TEDObject1<ITVGuideImpl, ChannelDescription, Result(ITVGuideImpl:: * )(const ChannelDescription&), Result >(this, &ITVGuideImpl::insertChannelDescription));
  
    getEventDispatcher().registerEvent(ITVGuide::insertEvent_event, new TEDObject1<ITVGuideImpl, ProgramDescription, Result(ITVGuideImpl:: * )(const ProgramDescription&), Result >(this, &ITVGuideImpl::insertEvent));
  
    getEventDispatcher().registerEvent(ITVGuide::setDirectory_event, new TEDObject1<ITVGuideImpl, string, void(ITVGuideImpl:: * )(const string&), void >(this, &ITVGuideImpl::setDirectory));
  
    getEventDispatcher().registerEvent(ITVGuide::getDirectory_event, new TEDObject0<ITVGuideImpl, string(ITVGuideImpl:: * )(), string >(this, &ITVGuideImpl::getDirectory));
  
    getEventDispatcher().registerEvent(ITVGuide::getChannelsList_event, new TEDObject0<ITVGuideImpl, list<ChannelDescription > (ITVGuideImpl:: * )(), list<ChannelDescription >  >(this, &ITVGuideImpl::getChannelsList));
  
    getEventDispatcher().registerEvent(ITVGuide::getChannelById_event, new TEDObject1<ITVGuideImpl, string, string(ITVGuideImpl:: * )(const string&), string >(this, &ITVGuideImpl::getChannelById));
  
    getEventDispatcher().registerEvent(ITVGuide::getChannelByName_event, new TEDObject1<ITVGuideImpl, string, string(ITVGuideImpl:: * )(const string&), string >(this, &ITVGuideImpl::getChannelByName));
  
    getEventDispatcher().registerEvent(ITVGuide::getEvent_event, new TEDObject3<ITVGuideImpl, string, string, string, ProgramDescription(ITVGuideImpl:: * )(const string&, const string&, const string&), ProgramDescription >(this, &ITVGuideImpl::getEvent));
  
    getEventDispatcher().registerEvent(ITVGuide::getEventsOnDayOnChannel_event, new TEDObject2<ITVGuideImpl, string, string, list<ProgramDescription > (ITVGuideImpl:: * )(const string&, const string&), list<ProgramDescription >  >(this, &ITVGuideImpl::getEventsOnDayOnChannel));
  
    getEventDispatcher().registerEvent(ITVGuide::search_event, new TEDObject2<ITVGuideImpl, ProgramFilter, ITVGuidePeerObject*, list<ProgramDescription > (ITVGuideImpl:: * )(const ProgramFilter&, const ITVGuidePeerObject*), list<ProgramDescription >  >(this, &ITVGuideImpl::search));
  
    getEventDispatcher().registerEvent(ITVGuide::addExtDescription_event, new TEDObject4<ITVGuideImpl, string, string, string, string, void(ITVGuideImpl:: * )(const string&, const string&, const string&, const string&), void >(this, &ITVGuideImpl::addExtDescription));
  
    getEventDispatcher().registerEvent(ITVGuide::getCurrentEventOnChannel_event, new TEDObject1<ITVGuideImpl, string, ProgramDescription(ITVGuideImpl:: * )(const string&), ProgramDescription >(this, &ITVGuideImpl::getCurrentEventOnChannel));
  
    getEventDispatcher().registerEvent(ITVGuide::getFollowingEventOnChannel_event, new TEDObject1<ITVGuideImpl, string, ProgramDescription(ITVGuideImpl:: * )(const string&), ProgramDescription >(this, &ITVGuideImpl::getFollowingEventOnChannel));
  
    getEventDispatcher().registerEvent(ITVGuide::getCategories_event, new TEDObject0<ITVGuideImpl, list<string > (ITVGuideImpl:: * )(), list<string >  >(this, &ITVGuideImpl::getCategories));
  
    getEventDispatcher().registerEvent(ITVGuide::start_event, new TEDObject0<ITVGuideImpl, Result(ITVGuideImpl:: * )(), Result >(this, &ITVGuideImpl::start));
  
    getEventDispatcher().registerEvent(ITVGuide::stop_event, new TEDObject0<ITVGuideImpl, Result(ITVGuideImpl:: * )(), Result >(this, &ITVGuideImpl::stop));
  
    getEventDispatcher().registerEvent(ITVGuide::init_event, new TEDObject0<ITVGuideImpl, Result(ITVGuideImpl:: * )(), Result >(this, &ITVGuideImpl::init));
  
    getEventDispatcher().registerEvent(ITVGuide::deinit_event, new TEDObject0<ITVGuideImpl, Result(ITVGuideImpl:: * )(), Result >(this, &ITVGuideImpl::deinit));
  
    getEventDispatcher().registerEvent(ITVGuide::getGrabberInterface_event, new TEDObject1<ITVGuideImpl, string, ITVGuidePlugin*(ITVGuideImpl:: * )(const string&), ITVGuidePlugin* >(this, &ITVGuideImpl::getGrabberInterface));
  
    getEventDispatcher().registerEvent(ITVGuide::addPeerHost_event, new TEDObject2<ITVGuideImpl, string, int, void(ITVGuideImpl:: * )(const string&, const int&), void >(this, &ITVGuideImpl::addPeerHost));
  
    getEventDispatcher().registerEvent(ITVGuide::clearPeerHosts_event, new TEDObject0<ITVGuideImpl, void(ITVGuideImpl:: * )(), void >(this, &ITVGuideImpl::clearPeerHosts));
  
    getEventDispatcher().registerEvent(ITVGuide::cleanDatabase_event, new TEDObject1<ITVGuideImpl, int, void(ITVGuideImpl:: * )(const int&), void >(this, &ITVGuideImpl::cleanDatabase));

  }

}


