
#include "ITVGuideProducer.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void ITVGuideProducer::registerTVGuideServer(const ITVGuide* itvg)
      throw(const Exception&)
  {
    TInValue<ITVGuide* > itvg_value (const_cast<ITVGuide* >(itvg), false);
    Event event("ITVGuideProducer::registerTVGuideServer", &itvg_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }

  const char* ITVGuideProducer::ITVGuideProducer_type = "ITVGuideProducer";
  TIFactoryObject<ITVGuideProducer > __ITVGuideProducer_prototype("ITVGuideProducer");


  const char* ITVGuideProducer::registerTVGuideServer_event = "ITVGuideProducer::registerTVGuideServer";


}


