
#ifndef NMM_ITVGuideUpdateFinishedImpl_HPP
#define NMM_ITVGuideUpdateFinishedImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "ITVGuideUpdateFinished.hpp"


namespace NMM
{
  /**
   *This interface represents the events sent by a TVGuide-Plugin or the TVGuide itself*/

  class ITVGuideUpdateFinishedImpl  : public virtual NMMObject { 
  public:
    ITVGuideUpdateFinishedImpl() { addInterface(new ITVGuideUpdateFinished(*this)); registerEvents(); };

    virtual ~ITVGuideUpdateFinishedImpl() {};

  protected:
    /**
     * Event sent when a certain state in grabbing data is reached
     */

    virtual Result partiallyFinished() = 0;
    /*
     * This event is sent when all the data available is grabbed. Can only be sent by plugins wich are starteted periodically
     */

    virtual Result finished() = 0;
    /**
     * Indicates, that a new channel is available in the database
     */

    virtual Result newChannel() = 0;
    /**
     * indicates, that a new Event-Information is available for the given channel
     */

    virtual Result newShow(const string& channelID) = 0;
    /**
     * Indicates, that the information for an already insertet event has been updated
     */

    virtual Result informationUpdate() = 0;


  private:
    void registerEvents();
  };

}

#endif
