
#ifndef NMM_ITVTimerEvents_HPP
#define NMM_ITVTimerEvents_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{
  /**
   *This interface represents the Events that are send by the TVTimer-Object
   */

  class ITVTimerEvents : virtual public Interface { 
  public:
    ITVTimerEvents() {  setTypeInfo(TypeInfo(ITVTimerEvents::ITVTimerEvents_type, "NMM")); };

    ITVTimerEvents(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(ITVTimerEvents::ITVTimerEvents_type, "NMM")); setEventReceiver(parent); };

    virtual ~ITVTimerEvents() {};

    static const char* ITVTimerEvents_type;

    virtual  string getInterfaceType() const { return ITVTimerEvents_type; }

    Interface* copy() const { return new ITVTimerEvents(*this); }
    static const char* recordingStopped_event;
    static Event* create_recordingStopped(const unsigned int& id);
    static const char* tvcardUnavailable_event;
    static Event* create_tvcardUnavailable(const unsigned int& id);
    static const char* timerUpdate_event;
    static Event* create_timerUpdate();
  /* instream (protected) and non-instream (public) */        /**
     *This method indicates, that a recoding has ended
     *@param id of the TVTimerEntry, that has ended
     */

    virtual Result recordingStopped(const unsigned int& id) /* in-stream */ 
      throw(const Exception&);
        /**
     *This method is called, if an TVCard is unavailable
     *@param TVTimerEntry, for wich the TVCard is unavailable
     */

    virtual Result tvcardUnavailable(const unsigned int& id) /* in-stream */ 
      throw(const Exception&);
        /**
     *Indicates a timer-change in general
     */

    virtual Result timerUpdate() /* in-stream */ 
      throw(const Exception&);


  };

  typedef auto_ptr<ITVTimerEvents> ITVTimerEvents_var;




}

#endif
