
#ifndef NMM_INet_HPP
#define NMM_INet_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>

#include "nmm/interfaces/base/INode.hpp"

namespace NMM
{

  class INet : virtual public Interface { 
  public:
    INet() {  setTypeInfo(TypeInfo(INet::INet_type, "NMM")); };

    INet(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(INet::INet_type, "NMM")); setEventReceiver(parent); };

    virtual ~INet() {};

    static const char* INet_type;

    virtual  string getInterfaceType() const { return INet_type; }

    Interface* copy() const { return new INet(*this); }
    static const char* setTransportStrategy_event;
    static const char* setRTPStrategy_event;
    static const char* setPayloadType_event;
    static const char* getPayloadType_event;
    /**
     * Set the transport strategy to the TSAddress address.
     * Tells the NetNode which transport strategy to use.
     */

    virtual void setTransportStrategy(const TSAddress* address)
      throw(const Exception&, const BindingException&);

    virtual void setRTPStrategy(const string& address, const int& rtp_port, const int& rtcp_port) /* limited(INode::CONSTRUCTED) */
      throw(const Exception&, const IllegalStateException&);

    virtual void setPayloadType(const int& type)
      throw(const Exception&);

    virtual int getPayloadType() const
      throw(const Exception&);


  };

  typedef auto_ptr<INet> INet_var;




}

#endif
