
#ifndef NMM_INetServer_HPP
#define NMM_INetServer_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{

  class INetServer : virtual public Interface { 
  public:
    INetServer() {  setTypeInfo(TypeInfo(INetServer::INetServer_type, "NMM")); };

    INetServer(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(INetServer::INetServer_type, "NMM")); setEventReceiver(parent); };

    virtual ~INetServer() {};

    static const char* INetServer_type;

    virtual  string getInterfaceType() const { return INetServer_type; }

    Interface* copy() const { return new INetServer(*this); }
    static const char* setPort_event;
    static const char* getPort_event;
    static const char* getHostName_event;

    virtual void setPort(const int& port)
      throw(const Exception&);

    virtual int getPort() const
      throw(const Exception&);

    virtual string getHostName() const
      throw(const Exception&);


  };

  typedef auto_ptr<INetServer> INetServer_var;




}

#endif
