
#ifndef NMM_IObjectAcceptor_HPP
#define NMM_IObjectAcceptor_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{

  class IObjectAcceptor : virtual public Interface { 
  public:
    IObjectAcceptor() {  setTypeInfo(TypeInfo(IObjectAcceptor::IObjectAcceptor_type, "NMM")); };

    IObjectAcceptor(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(IObjectAcceptor::IObjectAcceptor_type, "NMM")); setEventReceiver(parent); };

    virtual ~IObjectAcceptor() {};

    static const char* IObjectAcceptor_type;

    virtual  string getInterfaceType() const { return IObjectAcceptor_type; }

    Interface* copy() const { return new IObjectAcceptor(*this); }
    static const char* connectToObject_event;
    static const char* connectToService_event;
    static const char* getServiceList_event;

    virtual void connectToObject(const NMMReference& reference)
      throw(const Exception&, const BindingException&);

    virtual void connectToService(const string& service)
      throw(const Exception&, const BindingException&);

    virtual list<string >  getServiceList() const
      throw(const Exception&);


  };

  typedef auto_ptr<IObjectAcceptor> IObjectAcceptor_var;




}

#endif
