
#ifndef NMM_IRTPParameters_HPP
#define NMM_IRTPParameters_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{

  class IRTPParameters : virtual public Interface { 
  public:
    IRTPParameters() {  setTypeInfo(TypeInfo(IRTPParameters::IRTPParameters_type, "NMM")); };

    IRTPParameters(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(IRTPParameters::IRTPParameters_type, "NMM")); setEventReceiver(parent); };

    virtual ~IRTPParameters() {};

    static const char* IRTPParameters_type;

    virtual  string getInterfaceType() const { return IRTPParameters_type; }

    Interface* copy() const { return new IRTPParameters(*this); }
    static const char* getRTPSinkMediaType_event;
    static const char* getRTPSinkPayloadType_event;
    static const char* getRTPSinkMapLine_event;
    static const char* getRTPSinkAuxSDPLine_event;
    static const char* getRTPSeqNum_event;
    static const char* getRTPTimestamp_event;
    static const char* getRTPPort_event;
    static const char* getRTCPPort_event;

    virtual string getRTPSinkMediaType() const
      throw(const Exception&);

    virtual unsigned char getRTPSinkPayloadType() const
      throw(const Exception&);

    virtual string getRTPSinkMapLine() const
      throw(const Exception&);

    virtual string getRTPSinkAuxSDPLine() const
      throw(const Exception&);

    virtual unsigned short getRTPSeqNum() const
      throw(const Exception&);

    virtual unsigned int getRTPTimestamp() const
      throw(const Exception&);

    virtual unsigned int getRTPPort() const
      throw(const Exception&);

    virtual unsigned int getRTCPPort() const
      throw(const Exception&);


  };

  typedef auto_ptr<IRTPParameters> IRTPParameters_var;




}

#endif
