
#ifndef NMM_IVNCImpl_HPP
#define NMM_IVNCImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "IVNC.hpp"


namespace NMM
{

  class IVNCImpl  : public virtual NMMObject { 
  public:
    IVNCImpl() { addInterface(new IVNC(*this)); registerEvents(); };

    virtual ~IVNCImpl() {};

  protected:

    virtual void setTolerance(const float& tolerance) = 0;

    virtual void setInterval(const float& interval) = 0;

    virtual void setShared(const bool& unshared) = 0;

    virtual float getTolerance() const = 0;

    virtual float getInterval() const = 0;

    virtual void setPasswd(const string& passwd) = 0;

    virtual void setPasswdPath(const string& passwdpath) = 0;

    virtual void setMode(const IVNC::Mode& mode) = 0;

    virtual bool isShared() const = 0;

    virtual void sendKeyEvent(const unsigned long& key, const int& down) = 0;

    virtual void sendPointerEvent(const int& x, const int& y, const int& buttonmask) = 0;

    virtual void sendFrameBufferUpdateRequest() = 0;


  private:
    void registerEvents();
  };

}

#endif
