
#include "IEncodeStats.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void IEncodeStats::sendFrameCount(const bool& value)
      throw(const Exception&)
  {
    TInValue<bool > value_value(value, false);
    Event event("IEncodeStats::sendFrameCount", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }

  const char* IEncodeStats::IEncodeStats_type = "IEncodeStats";
  TIFactoryObject<IEncodeStats > __IEncodeStats_prototype("IEncodeStats");


  const char* IEncodeStats::sendFrameCount_event = "IEncodeStats::sendFrameCount";
  
  
  void IEncodeStatsListener::setFrameCount(const unsigned int& count, const float& fps) /* in-stream */ 
      throw(const Exception&)
  {
    TInValue<unsigned int > count_value(count, false);
    TInValue<float > fps_value(fps, false);
    Event event("IEncodeStatsListener::setFrameCount", &count_value, &fps_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }

  const char* IEncodeStatsListener::IEncodeStatsListener_type = "IEncodeStatsListener";
  TIFactoryObject<IEncodeStatsListener > __IEncodeStatsListener_prototype("IEncodeStatsListener");


  const char* IEncodeStatsListener::setFrameCount_event = "IEncodeStatsListener::setFrameCount";
  Event* IEncodeStatsListener::create_setFrameCount(const unsigned int& count, const float& fps)
  {
    TInValue<unsigned int >* count_value = new TInValue<unsigned int >();
    count_value->setValue(count);
    TInValue<float >* fps_value = new TInValue<float >();
    fps_value->setValue(fps);

    return new Event("IEncodeStatsListener::setFrameCount", count_value, fps_value);
  }



}


