
#ifndef NMM_ISleepImpl_HPP
#define NMM_ISleepImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "ISleep.hpp"


namespace NMM
{
  /**
   * Interfae for setting the sleep time after receiving a buffer.
   * This functionality is for testing purposes and implemented, for example, in DevNullNode.
   */

  class ISleepImpl  : public virtual NMMObject { 
  public:
    ISleepImpl() { addInterface(new ISleep(*this)); registerEvents(); };

    virtual ~ISleepImpl() {};

  protected:
    /**
     * Set the sleep time.
     * Set the time the node will wait after receiving a buffer, in seconds.
     */

    virtual void setSleepTime(const int& value) = 0;
    /**
     * Get the sleep time.
     * Get the time the node will wait after receiving a buffer, in seconds.
     */

    virtual int getSleepTime() const = 0;


  private:
    void registerEvents();
  };

}

#endif
