
#ifndef NMM_ISVGPaint_HPP
#define NMM_ISVGPaint_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>


namespace NMM
{

  class ISVGPaint : virtual public Interface { 
  public:
    ISVGPaint() {  setTypeInfo(TypeInfo(ISVGPaint::ISVGPaint_type, "NMM")); };

    ISVGPaint(NMMObject& parent) : Interface(parent) {  setTypeInfo(TypeInfo(ISVGPaint::ISVGPaint_type, "NMM")); setEventReceiver(parent); };

    virtual ~ISVGPaint() {};

    static const char* ISVGPaint_type;

    virtual  string getInterfaceType() const { return ISVGPaint_type; }

    Interface* copy() const { return new ISVGPaint(*this); }
    static const char* setImageHeight_event;
    static const char* setImageWidth_event;
    static const char* setShowSVGAnnotation_event;

    virtual void setImageHeight(const int& height)
      throw(const Exception&);

    virtual void setImageWidth(const int& width)
      throw(const Exception&);

    virtual void setShowSVGAnnotation(const bool& ssa)
      throw(const Exception&);


  };

  typedef auto_ptr<ISVGPaint> ISVGPaint_var;




}

#endif
