
#include "IFrameEncodeMode.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void IFrameEncodeMode::setFrameEncodeMode(const IFrameEncodeMode::Mode& value)
      throw(const Exception&)
  {
    TInValue<IFrameEncodeMode::Mode > value_value(value, false);
    Event event("IFrameEncodeMode::setFrameEncodeMode", &value_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  IFrameEncodeMode::Mode IFrameEncodeMode::getFrameEncodeMode() const
      throw(const Exception&)
  {
    TOutValue<IFrameEncodeMode::Mode > return_value;
    Event event("IFrameEncodeMode::getFrameEncodeMode");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* IFrameEncodeMode::IFrameEncodeMode_type = "IFrameEncodeMode";
  TIFactoryObject<IFrameEncodeMode > __IFrameEncodeMode_prototype("IFrameEncodeMode");
  TValueConstructor< IFrameEncodeMode::Mode > __IFrameEncodeMode_Mode_prototype(TypeInfo("IFrameEncodeMode::Mode", "NMM"));

  OValueStream& operator<<(OValueStream& ov, const IFrameEncodeMode::Mode& t)
  {
    ov.beginType(TypeInfo("IFrameEncodeMode::Mode", "NMM"));
    ov << reinterpret_cast<const int&>(t);
    ov.endType();
    return ov;
  }

  IValueStream& operator>>(IValueStream& iv, IFrameEncodeMode::Mode& t)
  {
    if(iv.getCurrentTypeInfo() != TypeInfo("IFrameEncodeMode::Mode", "NMM")) {
      throw InvalidTypeException(TypeInfo("IFrameEncodeMode::Mode", "NMM"), iv.getCurrentTypeInfo());
    }
    iv.goDown();
    iv >> reinterpret_cast<int&>(t);
    iv.goUp();
    return iv;
  }



  const char* IFrameEncodeMode::setFrameEncodeMode_event = "IFrameEncodeMode::setFrameEncodeMode";
  const char* IFrameEncodeMode::getFrameEncodeMode_event = "IFrameEncodeMode::getFrameEncodeMode";


}


