
#ifndef NMM_IScalerImpl_HPP
#define NMM_IScalerImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "IScaler.hpp"


namespace NMM
{

  class IScalerImpl  : public virtual NMMObject { 
  public:
    IScalerImpl() { addInterface(new IScaler(*this)); registerEvents(); };

    virtual ~IScalerImpl() {};

  protected:

    virtual void setAutoAspect(const bool& value) = 0;

    virtual void setFiltering(const bool& value) = 0;

    virtual void setOutputSize(const int& w, const int& h) = 0;

    virtual void getOutputSize(int& w, int& h) const = 0;

    virtual bool getAutoAspect() const = 0;

    virtual bool getFiltering() const = 0;


  private:
    void registerEvents();
  };

}

#endif
