
#include "IStillFrame.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  Result IStillFrame::setStillFrame(const bool& value) /* in-stream */ 
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    TInValue<bool > value_value(value, false);
    Event event("IStillFrame::setStillFrame", &value_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* IStillFrame::IStillFrame_type = "IStillFrame";
  TIFactoryObject<IStillFrame > __IStillFrame_prototype("IStillFrame");


  const char* IStillFrame::setStillFrame_event = "IStillFrame::setStillFrame";
  Event* IStillFrame::create_setStillFrame(const bool& value)
  {
    TInValue<bool >* value_value = new TInValue<bool >();
    value_value->setValue(value);

    return new Event("IStillFrame::setStillFrame", value_value);
  }



}


