
#include "IVideoDelay.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  Result IVideoDelay::setVideoDelay(const int& delay)
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    TInValue<int > delay_value(delay, false);
    Event event("IVideoDelay::setVideoDelay", &delay_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* IVideoDelay::IVideoDelay_type = "IVideoDelay";
  TIFactoryObject<IVideoDelay > __IVideoDelay_prototype("IVideoDelay");


  const char* IVideoDelay::setVideoDelay_event = "IVideoDelay::setVideoDelay";


}


