
#ifndef NMM_IHeaderDecorator_HPP
#define NMM_IHeaderDecorator_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>

#include "IDecorator.hpp"

namespace NMM
{
  /**
   * Header decorator interface.
   */

  class IHeaderDecorator : virtual public IDecorator { 
  public:
    IHeaderDecorator() {  setTypeInfo(TypeInfo(IHeaderDecorator::IHeaderDecorator_type, "NMM")); };

    IHeaderDecorator(NMMObject& parent) : IDecorator(parent) {  setTypeInfo(TypeInfo(IHeaderDecorator::IHeaderDecorator_type, "NMM")); setEventReceiver(parent); };

    virtual ~IHeaderDecorator() {};

    static const char* IHeaderDecorator_type;

    virtual  string getInterfaceType() const { return IHeaderDecorator_type; }

    Interface* copy() const { return new IHeaderDecorator(*this); }
    static const char* setFont_event;
    static const char* setText_event;
    /**
     * Set header font.
     * Set the font that is used to draw the text.
     * @param value font name
     */

    virtual void setFont(const string& value)
      throw(const Exception&);
    /**
     * Set header text.
     * Set the text that should be displayed in the header.
     * @param value header text
     */

    virtual void setText(const string& value)
      throw(const Exception&);


  };

  typedef auto_ptr<IHeaderDecorator> IHeaderDecorator_var;




}

#endif
