
#ifndef NMM_IProgressBarImpl_HPP
#define NMM_IProgressBarImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "IProgressBar.hpp"

#include "IWidgetImpl.hpp"

namespace NMM
{
  /**
   * Progress bar widget interface.
   */

  class IProgressBarImpl  : virtual public IWidgetImpl { 
  public:
    IProgressBarImpl() { addInterface(new IProgressBar(*this)); registerEvents(); };

    virtual ~IProgressBarImpl() {};

  protected:
    /** Set maximum value of progress bar. */

    virtual void setMaxProgress(const u_int64_t& value) = 0;
    /** Set current progress value. */

    virtual void setProgress(const u_int64_t& value) = 0;
    /**
     * Set bar color.
     * @param value bar color (rgba format)
     */

    virtual void setBarColor(const u_int32_t& value) = 0;
    /**
     * Definition of bar spaces.
     * @param space space between progress bars
     * @param space_step gap between spaces
     */

    virtual void setBarSpaces(const unsigned int& space, const unsigned int& space_step) = 0;


  private:
    void registerEvents();
  };

}

#endif
