
#ifndef NMM_IScrollDecorator_HPP
#define NMM_IScrollDecorator_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/Interface.hpp"
#include "nmm/base/Event.hpp"
#include <memory>

#include "IDecorator.hpp"

namespace NMM
{
  /**
   * Scroll decorator interface.
   */

  class IScrollDecorator : virtual public IDecorator { 
  public:
    IScrollDecorator() {  setTypeInfo(TypeInfo(IScrollDecorator::IScrollDecorator_type, "NMM")); };

    IScrollDecorator(NMMObject& parent) : IDecorator(parent) {  setTypeInfo(TypeInfo(IScrollDecorator::IScrollDecorator_type, "NMM")); setEventReceiver(parent); };

    virtual ~IScrollDecorator() {};

    static const char* IScrollDecorator_type;

    virtual  string getInterfaceType() const { return IScrollDecorator_type; }

    Interface* copy() const { return new IScrollDecorator(*this); }
    static const char* setBarWidth_event;
    static const char* setBackgroundColor_event;
    static const char* setBorderColor_event;
    static const char* setBarColor_event;
    static const char* setBarBorderColors_event;

    virtual void setBarWidth(const unsigned int& bw)
      throw(const Exception&);

    virtual void setBackgroundColor(const u_int32_t& bcolor)
      throw(const Exception&);

    virtual void setBorderColor(const u_int32_t& bcolor)
      throw(const Exception&);

    virtual void setBarColor(const u_int32_t& bcolor)
      throw(const Exception&);

    virtual void setBarBorderColors(const u_int32_t& bcolor1, const u_int32_t& bcolor2)
      throw(const Exception&);


  };

  typedef auto_ptr<IScrollDecorator> IScrollDecorator_var;




}

#endif
