
#include "IScrollable.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  int IScrollable::getScrollBarHeight() const
      throw(const Exception&)
  {
    TOutValue<int > return_value;
    Event event("IScrollable::getScrollBarHeight");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  int IScrollable::getScrollBarWidth() const
      throw(const Exception&)
  {
    TOutValue<int > return_value;
    Event event("IScrollable::getScrollBarWidth");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  int IScrollable::getScrollBarYPosition() const
      throw(const Exception&)
  {
    TOutValue<int > return_value;
    Event event("IScrollable::getScrollBarYPosition");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  int IScrollable::getScrollBarXPosition() const
      throw(const Exception&)
  {
    TOutValue<int > return_value;
    Event event("IScrollable::getScrollBarXPosition");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* IScrollable::IScrollable_type = "IScrollable";
  TIFactoryObject<IScrollable > __IScrollable_prototype("IScrollable");


  const char* IScrollable::getScrollBarHeight_event = "IScrollable::getScrollBarHeight";
  const char* IScrollable::getScrollBarWidth_event = "IScrollable::getScrollBarWidth";
  const char* IScrollable::getScrollBarYPosition_event = "IScrollable::getScrollBarYPosition";
  const char* IScrollable::getScrollBarXPosition_event = "IScrollable::getScrollBarXPosition";


}


