
#include "ISymbolChange.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  Result ISymbolChange::symbolChanged(const string& symbol) /* in-stream */ 
      throw(const Exception&)
  {
    TOutValue<Result > return_value;
    TInValue<string > symbol_value(symbol, false);
    Event event("ISymbolChange::symbolChanged", &symbol_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }

  const char* ISymbolChange::ISymbolChange_type = "ISymbolChange";
  TIFactoryObject<ISymbolChange > __ISymbolChange_prototype("ISymbolChange");


  const char* ISymbolChange::symbolChanged_event = "ISymbolChange::symbolChanged";
  Event* ISymbolChange::create_symbolChanged(const string& symbol)
  {
    TInValue<string >* symbol_value = new TInValue<string >();
    symbol_value->setValue(symbol);

    return new Event("ISymbolChange::symbolChanged", symbol_value);
  }



}


