
#include "IWidgetComposite.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  void IWidgetComposite::add(const IWidget& wg)
      throw(const Exception&)
  {
    TInValue<IWidget > wg_value(wg, false);
    Event event("IWidgetComposite::add", &wg_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void IWidgetComposite::remove(const IWidget& wg)
      throw(const Exception&)
  {
    TInValue<IWidget > wg_value(wg, false);
    Event event("IWidgetComposite::remove", &wg_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }
  
  void IWidgetComposite::removeAll()
      throw(const Exception&)
  {
    Event event("IWidgetComposite::removeAll");
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        throw Exception(*event.getException());
      }
    }
  }

  const char* IWidgetComposite::IWidgetComposite_type = "IWidgetComposite";
  TIFactoryObject<IWidgetComposite > __IWidgetComposite_prototype("IWidgetComposite");


  const char* IWidgetComposite::add_event = "IWidgetComposite::add";
  const char* IWidgetComposite::remove_event = "IWidgetComposite::remove";
  const char* IWidgetComposite::removeAll_event = "IWidgetComposite::removeAll";


}


