
#ifndef NMM_IWidgetCompositeImpl_HPP
#define NMM_IWidgetCompositeImpl_HPP

#include "nmm/NMMTypes.hpp"
#include "nmm/base/NMMObject.hpp"
#include "IWidgetComposite.hpp"

#include "IWidgetImpl.hpp"

namespace NMM
{
  /**
   * Widget composite interfaced.
   */

  class IWidgetCompositeImpl  : virtual public IWidgetImpl { 
  public:
    IWidgetCompositeImpl() { addInterface(new IWidgetComposite(*this)); registerEvents(); };

    virtual ~IWidgetCompositeImpl() {};

  protected:
    /** Add widget to composite object. */

    virtual void add(const IWidget& wg) = 0;
    /** Remove widget from composite object. */

    virtual void remove(const IWidget& wg) = 0;
    /** Remove all widgets from composite object. */

    virtual void removeAll() = 0;


  private:
    void registerEvents();
  };

}

#endif
