
#include "ITV.hpp"
#include "nmm/base/InterfaceFactory.hpp"


namespace NMM
{
  
  
  unsigned int ITV::getAudioCount() const /* limited(INode::INITIALIZED) */ /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TOutValue<unsigned int > return_value;
    Event event("ITV::getAudioCount");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  TVAudio ITV::getAudio(const unsigned int& index) const /* limited(INode::INITIALIZED) */ /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TOutValue<TVAudio > return_value;
    TInValue<unsigned int > index_value(index, false);
    Event event("ITV::getAudio", &index_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  list<TVAudio >  ITV::getAudioList() const /* limited(INode::INITIALIZED) */ /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TOutValue<list<TVAudio >  > return_value;
    Event event("ITV::getAudioList");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  unsigned int ITV::getCurrentAudio() const /* limited(INode::INITIALIZED) */ /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TOutValue<unsigned int > return_value;
    Event event("ITV::getCurrentAudio");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  void ITV::setCurrentAudio(const unsigned int& index) /* limited(INode::INITIALIZED) */ /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TInValue<unsigned int > index_value(index, false);
    Event event("ITV::setCurrentAudio", &index_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
  }
  
  unsigned int ITV::getInputCount() const /* limited(INode::INITIALIZED) */ /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TOutValue<unsigned int > return_value;
    Event event("ITV::getInputCount");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  TVInput ITV::getInput(const unsigned int& num) const /* limited(INode::INITIALIZED) */ /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TOutValue<TVInput > return_value;
    TInValue<unsigned int > num_value(num, false);
    Event event("ITV::getInput", &num_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  list<TVInput >  ITV::getInputList() const /* limited(INode::INITIALIZED) */ /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TOutValue<list<TVInput >  > return_value;
    Event event("ITV::getInputList");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  unsigned int ITV::getCurrentInput() const /* limited(INode::INITIALIZED) */ /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TOutValue<unsigned int > return_value;
    Event event("ITV::getCurrentInput");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  void ITV::setCurrentInput(const unsigned int& num) /* limited(INode::INITIALIZED) */ /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TInValue<unsigned int > num_value(num, false);
    Event event("ITV::setCurrentInput", &num_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
  }
  
  unsigned int ITV::getStandardByName(const string& name) const /* limited(INode::INITIALIZED) */ /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TOutValue<unsigned int > return_value;
    TInValue<string > name_value(name, false);
    Event event("ITV::getStandardByName", &name_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  TVStandard ITV::getStandard(const unsigned int& num) const /* limited(INode::INITIALIZED) */ /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TOutValue<TVStandard > return_value;
    TInValue<unsigned int > num_value(num, false);
    Event event("ITV::getStandard", &num_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  list<TVStandard >  ITV::getStandardList() const /* limited(INode::INITIALIZED) */ /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TOutValue<list<TVStandard >  > return_value;
    Event event("ITV::getStandardList");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  unsigned int ITV::getCurrentStandard() const /* limited(INode::INITIALIZED) */ /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TOutValue<unsigned int > return_value;
    Event event("ITV::getCurrentStandard");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  void ITV::setCurrentStandard(const unsigned int& standard) /* limited(INode::INITIALIZED) */ /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TInValue<unsigned int > standard_value(standard, false);
    Event event("ITV::setCurrentStandard", &standard_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
  }
  
  void ITV::setStandardByName(const string& name) /* limited(INode::INITIALIZED) */ /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TInValue<string > name_value(name, false);
    Event event("ITV::setStandardByName", &name_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
  }
  
  unsigned int ITV::getTunerCount() const /* limited(INode::INITIALIZED) */ /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TOutValue<unsigned int > return_value;
    Event event("ITV::getTunerCount");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  TVTuner ITV::getTuner(const unsigned int& index) const /* limited(INode::INITIALIZED) */ /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TOutValue<TVTuner > return_value;
    TInValue<unsigned int > index_value(index, false);
    Event event("ITV::getTuner", &index_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  list<TVTuner >  ITV::getTunerList() const /* limited(INode::INITIALIZED) */ /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TOutValue<list<TVTuner >  > return_value;
    Event event("ITV::getTunerList");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  float ITV::getFrequency(const unsigned int& tuner) const /* limited(INode::INITIALIZED) */ /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TOutValue<float > return_value;
    TInValue<unsigned int > tuner_value(tuner, false);
    Event event("ITV::getFrequency", &tuner_value);
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  void ITV::setFrequency(const unsigned int& tuner, const float& frequency) /* limited(INode::INITIALIZED) */ /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TInValue<unsigned int > tuner_value(tuner, false);
    TInValue<float > frequency_value(frequency, false);
    Event event("ITV::setFrequency", &tuner_value, &frequency_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
  }
  
  unsigned int ITV::getBrightness() const /* limited(INode::INITIALIZED) */ /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TOutValue<unsigned int > return_value;
    Event event("ITV::getBrightness");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  unsigned int ITV::getContrast() const /* limited(INode::INITIALIZED) */ /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TOutValue<unsigned int > return_value;
    Event event("ITV::getContrast");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  unsigned int ITV::getSaturation() const /* limited(INode::INITIALIZED) */ /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TOutValue<unsigned int > return_value;
    Event event("ITV::getSaturation");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  int ITV::getHue() const /* limited(INode::INITIALIZED) */ /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TOutValue<int > return_value;
    Event event("ITV::getHue");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  unsigned int ITV::getVolume() const /* limited(INode::INITIALIZED) */ /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TOutValue<unsigned int > return_value;
    Event event("ITV::getVolume");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  bool ITV::getMute() const /* limited(INode::INITIALIZED) */ /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TOutValue<bool > return_value;
    Event event("ITV::getMute");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  void ITV::setBrightness(const unsigned int& brightness) /* limited(INode::INITIALIZED) */ /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TInValue<unsigned int > brightness_value(brightness, false);
    Event event("ITV::setBrightness", &brightness_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
  }
  
  void ITV::setContrast(const unsigned int& contrast) /* limited(INode::INITIALIZED) */ /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TInValue<unsigned int > contrast_value(contrast, false);
    Event event("ITV::setContrast", &contrast_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
  }
  
  void ITV::setSaturation(const unsigned int& saturation) /* limited(INode::INITIALIZED) */ /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TInValue<unsigned int > saturation_value(saturation, false);
    Event event("ITV::setSaturation", &saturation_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
  }
  
  void ITV::setHue(const int& hue) /* limited(INode::INITIALIZED) */ /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TInValue<int > hue_value(hue, false);
    Event event("ITV::setHue", &hue_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
  }
  
  void ITV::setVolume(const unsigned int& volume) /* limited(INode::INITIALIZED) */ /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TInValue<unsigned int > volume_value(volume, false);
    Event event("ITV::setVolume", &volume_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
  }
  
  void ITV::setMute(const bool& mute) /* limited(INode::INITIALIZED) */ /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TInValue<bool > mute_value(mute, false);
    Event event("ITV::setMute", &mute_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
  }
  
  list<string >  ITV::getFrequencyTableList() const /* limited(INode::INITIALIZED) */ /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TOutValue<list<string >  > return_value;
    Event event("ITV::getFrequencyTableList");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  string ITV::getFrequencyTable() const /* limited(INode::INITIALIZED) */ /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TOutValue<string > return_value;
    Event event("ITV::getFrequencyTable");
    event.setReturnValue(&return_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
    return return_value.getRValue();
  }
  
  void ITV::setFrequencyTable(const string& table) /* limited(INode::INITIALIZED) */ /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TInValue<string > table_value(table, false);
    Event event("ITV::setFrequencyTable", &table_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
  }
  
  void ITV::setInputOutput(const int& input, const int& output) /* limited(INode::ACTIVATED) */ /* limited(INode::STARTED) */ /* limited(INode::OUTPUT_INITIALIZED) */
      throw(const Exception&, const IllegalStateException&)
  {
    TInValue<int > input_value(input, false);
    TInValue<int > output_value(output, false);
    Event event("ITV::setInputOutput", &input_value, &output_value);
    if(sendEvent(event) == FAILURE) {
      if (event.getException()) {
        if(IllegalStateException* ex = dynamic_cast<IllegalStateException*>(event.getException())) {
          throw IllegalStateException(*ex);
        }
        throw Exception(*event.getException());
      }
    }
  }

  const char* ITV::ITV_type = "ITV";
  TIFactoryObject<ITV > __ITV_prototype("ITV");


  const char* ITV::getAudioCount_event = "ITV::getAudioCount";
  const char* ITV::getAudio_event = "ITV::getAudio";
  const char* ITV::getAudioList_event = "ITV::getAudioList";
  const char* ITV::getCurrentAudio_event = "ITV::getCurrentAudio";
  const char* ITV::setCurrentAudio_event = "ITV::setCurrentAudio";
  const char* ITV::getInputCount_event = "ITV::getInputCount";
  const char* ITV::getInput_event = "ITV::getInput";
  const char* ITV::getInputList_event = "ITV::getInputList";
  const char* ITV::getCurrentInput_event = "ITV::getCurrentInput";
  const char* ITV::setCurrentInput_event = "ITV::setCurrentInput";
  const char* ITV::getStandardByName_event = "ITV::getStandardByName";
  const char* ITV::getStandard_event = "ITV::getStandard";
  const char* ITV::getStandardList_event = "ITV::getStandardList";
  const char* ITV::getCurrentStandard_event = "ITV::getCurrentStandard";
  const char* ITV::setCurrentStandard_event = "ITV::setCurrentStandard";
  const char* ITV::setStandardByName_event = "ITV::setStandardByName";
  const char* ITV::getTunerCount_event = "ITV::getTunerCount";
  const char* ITV::getTuner_event = "ITV::getTuner";
  const char* ITV::getTunerList_event = "ITV::getTunerList";
  const char* ITV::getFrequency_event = "ITV::getFrequency";
  const char* ITV::setFrequency_event = "ITV::setFrequency";
  const char* ITV::getBrightness_event = "ITV::getBrightness";
  const char* ITV::getContrast_event = "ITV::getContrast";
  const char* ITV::getSaturation_event = "ITV::getSaturation";
  const char* ITV::getHue_event = "ITV::getHue";
  const char* ITV::getVolume_event = "ITV::getVolume";
  const char* ITV::getMute_event = "ITV::getMute";
  const char* ITV::setBrightness_event = "ITV::setBrightness";
  const char* ITV::setContrast_event = "ITV::setContrast";
  const char* ITV::setSaturation_event = "ITV::setSaturation";
  const char* ITV::setHue_event = "ITV::setHue";
  const char* ITV::setVolume_event = "ITV::setVolume";
  const char* ITV::setMute_event = "ITV::setMute";
  const char* ITV::getFrequencyTableList_event = "ITV::getFrequencyTableList";
  const char* ITV::getFrequencyTable_event = "ITV::getFrequencyTable";
  const char* ITV::setFrequencyTable_event = "ITV::setFrequencyTable";
  const char* ITV::setInputOutput_event = "ITV::setInputOutput";


}


