/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:         
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

#ifndef NMM_AUDIOCONVERTERNODE_HPP
#define NMM_AUDIOCONVERTERNODE_HPP NMM_AUDIOCONVERTERNODE_HPP

#include "nmm/base/GenericConverterNode.hpp"

namespace NMM {

  class AudioConverterNode
    : public GenericProcessorNode {

  public:

    AudioConverterNode(const char* name = "AudioConverterNode",
                       const StreamQueue::Mode queue_mode = StreamQueue::MODE_SUSPEND,
                       const int size = StreamQueue::DEFAULT_SIZE);

    ~AudioConverterNode();


  protected:

    virtual Result doInit();
    virtual Result doInitOutput();
    virtual Result doActivate();

    virtual Message* processBuffer(Buffer*);

  private:

    unsigned int in_channels;
    unsigned int in_sample_rate;
    bool stereo_to_mono;
    unsigned short downsample;
  };

} // end namespace NMM


#endif //NMM_AUDIOCONVERTERNODE_HPP
