/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307,
 * USA.
 */

#ifndef NMM_LADSPADATA2INTNODE_HPP
#define NMM_LADSPADAtA2INTNODE_HPP NMM_LADSPADATA2INTNODE_HPP

#include "nmm/base/GenericProcessorNode.hpp"
#include "ladspa.h"

namespace NMM {

    /**
     *This node converts LADSPA_Data based buffer back to a signed short based buffer
     *The LADSPAInt2DataNode can only be used int the context of the LADSPANode
     */
    class LADSPAData2IntNode : public GenericProcessorNode {
    private:
	int channels; /* number of channels in the input stream */

    protected:
	// INode-Interface
	virtual Result doInit(void);
	virtual Result doDeinit(void);
	virtual Result doInitOutput(void);
	virtual Result doDeinitOutput(void);
	virtual Result doActivate(void);
	virtual Result doDeactivate(void);
	virtual Message* processBuffer(Buffer* in_buffer);

    public:
	LADSPAData2IntNode(const char* = "LADSPAData2IntNode",
			   const StreamQueue::Mode= StreamQueue::DEFAULT_MODE,
			   const int = StreamQueue::DEFAULT_SIZE);
	~LADSPAData2IntNode(void);

    }; // class LADSPAData2IntNode

}; // namespace NMM

#endif // NMM_LADSPAINT2DATANODE_HPP
