/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2004
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

#ifndef NMM_FFMPEGAUDIOENCODENODE_HPP
#define NMM_FFMPEGAUDIOENCODENODE_HPP

#include "nmm/base/GenericProcessorNode.hpp"

class AVCodec;
class AVCodecContext;

namespace NMM {

  class FFMpegAudioEncodeNode : public GenericProcessorNode {
  public:
    FFMpegAudioEncodeNode(const char* name="FFMpegAudioEncodeNode",
			  const StreamQueue::Mode queue_mode = StreamQueue::MODE_SUSPEND,
			  const int queue_size = StreamQueue::DEFAULT_SIZE);
    ~FFMpegAudioEncodeNode(void);

  protected:
    //+++ INode +++
    virtual Result doInit(void);
    virtual Result doDeinit(void);
    virtual Result doInitOutput(void);
    virtual Result doDeinitOutput(void);
    virtual Result doActivate(void);
    virtual Result doDeactivate(void);
    virtual Message* processBuffer(Buffer *in_buffer);


  private:

    struct FFMpegAudioHandle {
      AVCodec        *ffAVCodec;
      AVCodecContext *ffAVCC;

      FFMpegAudioHandle();
    }; // struct FFMpegAudioHandle

    FFMpegAudioHandle *mFFMpeg;
    unsigned chunk_size;
    unsigned old_size;
    char *old_data;
    bool hasMP3Support;
  }; // class FFAudioEncodeNode

} // namespace NMM

#endif // NMM_FFMPEGAUDIOENCODENODE_HPP
