/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:        Michael Repplinger <repplinger@cs.uni-sb.de>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */

#include <l1394/l1394_session.h>
#include "nmm/NMMTypes.hpp"
#include "nmm/base/registry/LocalRegistry.hpp"
#include "Registry1394.hpp"
#include "Factory1394.hpp"
#include "nmm/base/registry/Plugin.hpp"


#ifndef NMM_PLUGIN1394_HPP
#define NMM_PLUGIN1394_HPP
namespace NMM {
  class Registry;
  class NodeFactory;
  class Exception;


class Plugin1394 : public Plugin  {
public:
  Plugin1394() : Plugin("Plugin1394", 0), __registry1394(0), __factory1394(0) {}

  virtual void nmmInit()
    throw (const Exception&);

  virtual void nmmFini();

  virtual void nmmRegistryInit(Registry& )
    throw (const Exception&);

  virtual void nmmRegistryFini(Registry& );

  virtual void nmmFactoryInit(NodeFactory&)
    throw (const Exception&);

  virtual void nmmFactoryFini(NodeFactory&);
private:
  Registry1394* __registry1394;
  Factory1394*  __factory1394;
};

}


#endif
