/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:         
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */


#ifndef _NMM_TIMEUNIT_HPP_
#define _NMM_TIMEUNIT_HPP_ _NMM_TIMEUNIT_HPP_

#include "OSDElement.hpp"
#include "nmm/interfaces/video/osd/manager/ITimeView.hpp"
#include "nmm/interfaces/video/osd/manager/IPlaneDecorator.hpp"
#include "nmm/interfaces/video/osd/manager/IBorderDecorator.hpp"
#include "nmm/interfaces/video/osd/manager/IHeaderDecorator.hpp"

namespace NMM {
  class TimeUnit : public OSDElement {
  public:
    
    TimeUnit(IOSDManager* manager, IWidgetFactory* factory, string font);
    ~TimeUnit();
    
    void setColors( unsigned int color );
    void setPrefix( string p ) { text->setPrefix( p ); };
    void setTimeOffset( long to ) { text->setTimeOffset( to ); };
    void setCurrentTime( long t ) { text->setCurrentTime( t ); };
    long getCurrentTime() { return text->getCurrentTime(); };
    
    /* methods that are passed through HeaderDecorator class */
    void setHeader( string h );
    
  protected:
    unsigned int  color1;
    
    void deleteWidgets();
    string font;
    
    ITimeView_var        text;
    IPlaneDecorator_var  plane;
    IBorderDecorator_var border;
    IHeaderDecorator_var  header;
  };
  
}

#endif //_NMM_TIMEUNIT_HPP_
