/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:         
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */


#ifndef _NMM_DECOPLANE_HPP_
#define _NMM_DECOPLANE_HPP_ _NMM_DECOPLANE_HPP_

#include "decorators.hpp"

#include "nmm/interfaces/video/osd/manager/IPlaneDecoratorImpl.hpp"

namespace NMM {
  
  /*****************************************************************************************/
  /* PlaneDecorator   									   */
  /*****************************************************************************************/
  class PlaneDecorator : virtual public Decorator,
                         virtual public IPlaneDecoratorImpl {
  protected:
    unsigned int planecolor;
    
    /**
     * Draws a rectangle plane.
     * @param ws pointer to the workspace
     * @param width width of the workspace
     * @param height height of the workspace
     */
    void drawPlane( workspace_t* ws );
    
  public:
    PlaneDecorator();
    
    /** IPlaneDecorator interface. */
    virtual void setPlaneColor( const u_int32_t& color );
    
    /** Draws Widget with plane. */
    virtual void draw( workspace_t* ws );
    
  }; // PlaneDecorator
} // NMM

#endif //_NMM_DECOPLANE_HPP_
