/* NMM - Network-Integrated Multimedia Middleware
 *
 * Copyright (C) 2002-2005
 *                    NMM work group,
 *                    Computer Graphics Lab,
 *                    Saarland University, Germany
 *                    http://www.networkmultimedia.org
 *
 * Maintainer:         
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307
 * USA
 */


#ifndef _NMM_WGPROGRESSBAR_HPP_
#define _NMM_WGPROGRESSBAR_HPP_ _NMM_WGPROGRESSBAR_HPP_

#include "widgets.hpp"

#include "nmm/interfaces/video/osd/manager/IProgressBarImpl.hpp"

namespace NMM {
  
  /**
   * Progressbar widget.
   */
  class ProgressBar : virtual public Widget,
                      virtual public IProgressBarImpl {
    
  protected:
    u_int64_t max;
    u_int64_t progress;
    u_int32_t barcolor;
    unsigned int space;		   // space between progress bars
    unsigned int space_step;       // gap between spaces
    
    void drawBar( workspace_t* ws );
    
  public:
    ProgressBar();
    virtual ~ProgressBar();
    
    /** IProgressBar interface. */
    virtual void setMaxProgress(const u_int64_t& value);
    virtual void setProgress(const u_int64_t& value);
    virtual void setBarColor(const u_int32_t& value);
    virtual void setBarSpaces(const unsigned int& space, const unsigned int& space_step);
    
    void draw( workspace_t* ws );
  }; // ProgressBar
}

#endif //_NMM_WGPROGRESSBAR_HPP_
